<?php

if (file_exists(cpg_plugin_dir_path() . '/phpoffice/vendor/autoload.php')){
require_once(cpg_plugin_dir_path() . '/phpoffice/vendor/autoload.php');
}

use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Cell\Coordinate;


class PHPExcelInterface {
	function __construct() {
		#echo "loading parser";
	}

	function ReadExcel( $filename='', $sheetname='', $run_calculations=true ) {
	    // $sheetname may be an array of names
		if (empty($filename)) {
			return false;
		}
		ini_set('error_reporting', E_ALL & ~E_NOTICE & ~E_STRICT & ~E_DEPRECATED);

		#$filename = "D:/Home/ApacheRoot/nufocusweb/httpdocs/wp-content/uploads/"  . "product.xlsx";
		$type = IOFactory::identify($filename);
		$objReader = IOFactory::createReader($type);
		$objReader->setReadDataOnly(TRUE);
		$objReader->setReadEmptyCells(false);
	#	$objReader->setIgnoreRowsWithNoCells(true);
		$objReader->setReadDataOnly(true);
		$objReader->setLoadSheetsOnly($sheetname);
		$objPHPExcel = $objReader->load($filename);

		$worksheets = array();
		foreach ($objPHPExcel->getWorksheetIterator() as $worksheet) {
			if (empty($sheetname) || is_array($sheetname)) {
				$worksheets[$worksheet->getTitle()] = $worksheet->toArray();
			} elseif (!empty($sheetname) && $worksheet->getTitle()==$sheetname) {
				$worksheets[$worksheet->getTitle()] = $worksheet->toArray(null,$run_calculations,true,true);
			}
		}
		$objPHPExcel = null;
		return $worksheets;
	} # end of ReadExcel

	function GetSheetnames( $filename='' ) {

		if (empty($filename)) {
			return false;
		}
		ini_set('error_reporting', E_ALL & ~E_NOTICE & ~E_STRICT & ~E_DEPRECATED);

		$type = IOFactory::identify($filename);
		$objReader = IOFactory::createReader($type);
		$worksheetNames = $objReader->listWorksheetNames($filename);

		return $worksheetNames;
	} # end of ReadExcel

	function createProductExcel( $cli_array='' ) {
		#echo "client id matrix";
		// put the main functions into a separate code file
		// if it cannot be found fail gracefuly

		error_reporting(-1);
		error_reporting(E_ALL ^ E_DEPRECATED);
		ini_set("display_errors", 1);

	#	if (file_exists(cpg_plugin_dir_path()  . '/functions/cli_excel.php')) {
		#	require_once(cpg_plugin_dir_path() . '/functions/cli_excel.php');
			#require_once (cpg_plugin_dir_path()  . 'PHPExcel.php');


			if (!isset($objPHPExcel) || !is_a($objPHPExcel,  'PHPExcel')){
				$objPHPExcel = new Spreadsheet(); // this creates the first sheet
			} 
			$objPHPExcel->getActiveSheet()->setTitle("no data");
			#$sheetname = '';

			if  (empty($cli_array)) {
				echo "No matching data found!<br>";
				return false;
			}
			
			$first = true;
			foreach ($cli_array as $sheetname=>$sheet) {
			    
			    if (!$first) {
			       $res = $objPHPExcel->createsheet();
			       $objPHPExcel->setActiveSheetIndex( $objPHPExcel->getSheetCount()-1);
			    }
			    $first = false;
			    $currentSheet = $objPHPExcel->getActiveSheet()->setTitle($sheetname);
			    
			    $i = 0;
			    foreach ($sheet as $row) {
			        if (empty($i)) {
			            $j=0;
			            foreach ($row as $key=>$cell){
			                if (in_array($key, array('id', 'active','deleted', 'created', 'modified') )) {
			                    continue;
			                }
			                $currentSheet->setCellValue(num2alpha($j).'1', $key);
			                $currentSheet->getColumnDimension(num2alpha($j) )->setAutoSize(true);
			                $j++;
			            }
			            $i=2;
			        }
		            $j=0;
				    foreach ($row as $key=>$cell) {
			            if (in_array($key, array('id', 'active','deleted', 'created', 'modified') )) {
			                    continue;
			           }
			           $currentSheet->setCellValue(num2alpha($j).$i, $cell);
			           $j++;
			        }
			        $i++;
			    }
			    
			    
			}

			// now write file files
		#	if ($file) {
				$file =  excelWriteWorkbook($objPHPExcel);
		#	}
			return $file;

	#	} # end of require files
	} # end of createProductExcel

	function ReformatExcel( $filename ) {
		/** Include PHPExcel */
		#require_once (cpg_plugin_dir_path()  . 'PHPExcel.php');

		if (!file_exists($filename)) {
		//	$uploads = wp_upload_dir();
		//	$file = $uploads['path'] . "/" . $filename;
		}

		$csv_file = $filename;
		$objPHPExcel = IOFactory::load($filename);
		$objPHPExcel->setActiveSheetIndex(0);
		$row = $objPHPExcel->getActiveSheet()->getHighestRow()+1;
		#echo $row;
		#$objPHPExcel->getActiveSheet()->SetCellValue('A'.$row, 'name');
		#$objPHPExcel->getActiveSheet()->SetCellValue('B'.$row, 'email');
		#$objPHPExcel->getActiveSheet()->SetCellValue('C'.$row, 'phone');
		#$objPHPExcel->getActiveSheet()->SetCellValue('D'.$row, 'city');
		#$objPHPExcel->getActiveSheet()->SetCellValue('E'.$row, 'kid1');
		#$objPHPExcel->getActiveSheet()->SetCellValue('F'.$row, 'kid2');

		$maxColumn = $objPHPExcel->getActiveSheet()->getHighestDataColumn();
		$startRange = "A1";
		$endRange = $maxColumn . "1";
		$objPHPExcel->getActiveSheet()->getStyle("$startRange:$endRange")->getFont()->setBold( true );
		$maxColumn = Coordinate::columnIndexFromString($maxColumn);
		#echo "<br>" . $maxColumn . "<br>";
		for ($i=0; $i<=$maxColumn; $i++) {
			$objPHPExcel->getActiveSheet()->getColumnDimensionByColumn($i)->setAutoSize(true);
		}	
		$objPHPExcel->getActiveSheet()->calculateColumnWidths();

		$fileparts = explode(".", $filename);
		array_pop($fileparts);
		$fileparts[] = "xlsx";
		$filename = implode(".", $fileparts);

		$objWriter = new Xlsx($objPHPExcel);
		$objWriter->save( $filename );
		unlink($csv_file);

		$fileparts = explode("/", $filename) ;
		$filename = array_pop($fileparts);
		return $filename;

	}

	function WriteCSVFile( $array, $filename, $loopNr = '' ) {
		global $masteroutputcount;
		global $masterfilename;

		$uploads = wp_upload_dir();

		//increment the count
		$masteroutputcount++;

		$uploads = wp_upload_dir();
		if(!empty($filename) || $filename==false) {
			if (!empty($masterfilename)) {
				$filename = $masterfilename . ' - Import'. $masteroutputcount . '.csv';
			} else {
			#	$filename = randomFilename() . ' - Import'.$masteroutputcount . '.csv';
			}
			#echo "<br>" . $filename;
		}
		$file = str_replace('.php', '.csv', $uploads['path'] . "/" . $filename);
		
		echo $file;
		if (file_exists($file)) {
			chmod($file, 0777);
			unlink($file);
		}
		$f = fopen($file, "w");
		$headerDone = false;
		foreach ($array as $line) {
			if (!$headerDone) {

			}
			$headerDone=true;
			fputcsv($f, $line);
		}

		$filename = $this->ReformatExcel( $file) ;
		return $uploads['url'] . "/" . $filename; 
	}

} # end pf class

class PriceSheetParser {

	var $master = array();
	var $master_default = array();
	var $master_default2 = array();

	var $maxDropWidths = array() ;

	var $productnames = array();
	var $productDetails = array();

	var $useTapeGroups = false;
	var $hasFrameColours = false;
	var $useSlatSizing = false;
	var $useGlassBead = false;
	var $useOperatingWand = false;
	var $wandPrices = array();
	var $activeSlats = array();

	var	$priceGroup = array();

	var $maxBlindWidth = '';
	var $maxBlindDrop = '';
	var $maxFabricWidth = '';
	var $maxFabricDrop = '';
	var $usevariantPricing = false;


	function __construct() {
		#echo "loading parser";
		$this->wandPrices = array();
	}

	function SetupChunk() {
		$this->master = array(); #array_slice($this->master,0,1);
		$this->productnames = array();
		$this->productDetails = array();

		$this->master_default = array();
		$this->master_default2 = array();

		$wandPrices = array();

	} # end of SetupChunk

	function ReadExcel( $filename='' ) {

		if (empty($filename)) {
			return false;
		}
		ini_set('error_reporting', E_ALL & ~E_NOTICE & ~E_STRICT & ~E_DEPRECATED);

		#$filename = "D:/Home/ApacheRoot/nufocusweb/httpdocs/wp-content/uploads/"  . "product.xlsx";
		$type = IOFactory::identify($filename);
		$objReader = IOFactory::createReader($type);
		$objPHPExcel = $objReader->load($filename);

		$worksheets = array();
		foreach ($objPHPExcel->getWorksheetIterator() as $worksheet) {
			$worksheets[$worksheet->getTitle()] = $worksheet->toArray();
		}
		$objPHPExcel = null;
		return $worksheets;
	} # end of ReadExcel

}

#######################################################################################################

function num2alpha($n)
{
    for($r = ""; $n >= 0; $n = intval($n / 26) - 1)
        $r = chr($n%26 + 0x41) . $r;
    return $r;
}
// S E T U P  T H E  D O C U M E N T  P R O P E R T I E S
function excelDocumentProperties( &$excel, $properties=array() ) {
		// setups generated Excel properties (like author, titles etc0
		// pass spaces (not empty) if you want to overwrite the defaults!
		$defaults = array( 'creator' => 'NuFocus Plugin',
							'modifiedBy' => 'Taichi Union Admin',
							'title' => 'Taichi Union',
							'subject' => 'Miscellaneous',
							'description' => 'This document is a generic template',
							'keywords' => 'None',
							'category' => 'Admin'
							);

		foreach  ($defaults as $key=>$value) {
			if (!isset($properties[$key]) || $properties[$key]=='') {
				//echo "<br>key=" . $key . " value=" . $value ;
				$properties[$key] = $value;
			}
		}
		$excel->getProperties()->setCreator($properties['creator'])
									 ->setLastModifiedBy($properties['modifiedBy'])
									 ->setTitle($properties['title'])
									 ->setSubject($properties['subject'])
									 ->setDescription($properties['description'])
									 ->setKeywords($properties['keywords'])
									 ->setCategory($properties['category']);

}

// A D D  H E A D E R  C E L L  W R A P P E R 
function excelHeaderCellByAxis( &$excel, $row, $column, $content='') {
	//wrapper function to add content converting row/column reference to A6 type reference
	$columnLetter = num2alpha($column);

	$rowcolumn = $columnLetter . $row;

	excelHeaderCell($excel, $rowcolumn, $content);
}
// A D D  H E A D E R  C E L L  
function excelHeaderCell( &$excel, $rowcolumn, $content='') {
	// adds content to a singele cell using A6 type reference
	##$excel->setActiveSheetIndex(0)->setCellValue($rowcolumn, $content);
	$excel->getActiveSheet()->setCellValue($rowcolumn, $content);
}
function excelHeaderRow ( &$excel, $params, $startCell, $stopCell='', $row=1, $sortkeys=array()) {
	if (empty($stopCell)) {
		$stopCell =$startCell + sizeof($params) - 1;
	}
	#$newparams = array();
	#foreach ($params as $key=>$val) {
	#	#$newparams[$key] = $val;
	#	$newparams[] = $val;
	#}
	#print_r($newparams);
	#$params = $newparams;

	$newparams = array();
	if ($sortkeys!=array()) {
		foreach ($sortkeys as $key=>$val) {
		#	echo $key . " = " . $val;
			$newparams[$key] = $params[$val] ;
		}
		$params = $newparams;
	} else {
		foreach ($params as $key=>$val) {
			$newparams[$key] = $val;
			$newparams[] = $val;
		}
		$params = $newparams;
	}
	#print_r($params);
	for ($i=$startCell; $i<=$stopCell; $i++) {
			#echo "<br>row=" . $row . " i=" . $i . " content=" . $params[$i-$startCell];
		excelHeaderCellByAxis($excel, $row, $i, $params[$i-$startCell]);
	}

	$excel->getActiveSheet()->setAutoFilter($excel->getActiveSheet()->calculateWorksheetDimension());
}

function excelColorCell( &$excel, $range, $color ) {

	$excel->getActiveSheet()->getStyle($range)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
	$excel->getActiveSheet()->getStyle($range)->getFill()->getStartColor()->setARGB('FF' . $color);

}
function excelTextStyleCell( &$excel, $range, $style ) {

	$style_array = array('font' => array('size' => 10,'bold' => true,'color' => array('rgb' => 'FF0000')));

	if (is_array($style)) {
		if (is_array($style['font'])) {
			foreach ($style['font'] as $key=>$value) {
				$style_array['font'][$key] = $value;
			}
		} else {
			foreach ($style as $key=>$value) {
				$style_array['font'][$key] = $value;
			}
		}
	} else {
		// only change colour
		$style_array['font']['color'] = array('rgb' => $style) ;
	}
		#print_r($style_array);

	#$excel->getActiveSheet()->getStyle($range)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
	$excel->getActiveSheet()->getStyle($range)->applyFromArray($style_array);

	#$excel->getActiveSheet()->getStyle($range)->getFill()->getStartColor()->setARGB('FF' . $color);

}

function excelTextAlignmentCell(&$excel, $range, $style='') {
	$center_style = 'HORIZONTAL_CENTER';
	if ($style!='') {
		$center_style = $style;
		$excel->getActiveSheet()->getStyle( $range  )->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER_CONTINUOUS );  
	} else {
		$excel->getActiveSheet()->getStyle( $range  )->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);  
	}
	#define('CENTER_STYLE', $center_style);

	#echo CENTER_STYLE;

	#$excel->getActiveSheet()->getStyle( $range  )->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::{$center_style}());  
}



function excelWriteWorkbook( $objPHPExcel ) {

	// Set active sheet index to the first sheet, so Excel opens this as the first sheet
	$objPHPExcel->setActiveSheetIndex(0);

	// Save Excel 2007 file
	#echo date('H:i:s') , " Write to Excel2007 format" , EOL;
	$callStartTime = microtime(true);

	#$filename = randomFilename() . '.xlsx';
	$filename = 'test.xlsx';
	$uploads = wp_upload_dir();

	$objWriter = IOFactory::createWriter($objPHPExcel, "Xlsx");

	$objWriter->save(str_replace('.php', '.xlsx', $uploads['path'] . "/" . $filename));
	$callEndTime = microtime(true);
	$callTime = $callEndTime - $callStartTime;

	return $uploads['url'] . "/" . $filename; 

}

?>