<?php

/**

 * @package CPGantt

 */

/*

Plugin Name: CPGantt

Plugin URI: http://www.nufocus.co.uk/plugins/cpgantt/?return=true

Description: NuFocus Gantt Chart Planning 

Version: 1.0.0

Author: David Coates

Author URI: http://www.nufocus.co.uk/

License: GPLv2 or later

*/



/*

This program is not free software; you can only use this plugin with written permission for the copyright owner.

*/



if (!defined('WP_CPG_MANAGEMENT_PERMISSION')){//This will allow the user to define custom capability for this constant in wp-config file

    define('WP_CPG_MANAGEMENT_PERMISSION', 'manage_options');

}



global $cpg_db_tables;

$cpg_db_tables = array( 

                        'clients' => 'z_clients',

                        'input_transfer' => 'z_input_transfer',

                        'input_sample' => 'z_input_sample',

					);





function cpg_plugin_dir_path() {

	return plugin_dir_path( __FILE__ );

}

function cpg_plugin_url() {

	return plugins_url() . '/cpgantt';

}



include(cpg_plugin_dir_path() . "classes/cpg_client_classes.php");

include(cpg_plugin_dir_path() . "functions/cpg_function_library.php");





class cpGantt {

    

    var $cpg_main_menu_slug = 'cpg-portal-main';

    var $cpg_transfer_menu_slug = 'cpg-transfer-data';

    var $cpg_buildbatch_menu_slug = 'cpg-build-batch';



    

    function __construct() {

 	    add_action('admin_menu', array($this, 'add_menus_link') );

	    add_action('init', array($this, 'nss_init') );

		#add_action( 'wp_footer', array($this, 'diagnostic_panel') );

		#add_action('in_admin_footer', array($this, 'diagnostic_panel') );



		#add_action( 'admin_notices', array($this, 'custom_error_notice') );

		#add_action('wp_dashboard_setup', array($this, 'custom_dashboard_widgets'));

       

        

    }

    

    function nss_init() {

        

    }

    

    function add_menus_link() {

 		$enable_menus = false;

		$user = wp_get_current_user();

		if ($user->ID <=2) {

			$enable_menus = true;

		}



		if ($enable_menus) { 

		add_menu_page(__('Custom Pharma Gantt', 'BLD'), __('Custom Pharma Gantt', 'BLD'), WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_main_menu_slug , 'nss_main_handler', $menu_icon_url, 4);

	    add_submenu_page($this->cpg_main_menu_slug, __('Transfer Data', 'BLD'),  __('Transfer Data', 'BLD') , WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_transfer_menu_slug, 'cpg_input_transfer_handler');



	    add_submenu_page($this->cpg_main_menu_slug, __('Build Batch Block', 'BLD'),  __('Build Batch Block', 'BLD') , WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_buildbatch_menu_slug, 'cpg_build_batch_handler');

	

#	    add_submenu_page($this->cpg_main_menu_slug, __('All Portfolios', 'BLD'),  __('All Portfolios', 'BLD') , WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_transfer_menu_slug, 'nss_all_portfolios_handler');



		}      

    }

    

    

} # end of cpGantt





$cpGantt = new cpGantt;



function nss_main_handler() {

    

}



function cpg_input_transfer_handler() {

    echo '<h1>Transfer Data</h1>';

 

    importTransferList();

}

function cpg_build_batch_handler() {
	global $offsets;

    echo '<h1>Build Work Centre Conflict Chart</h1>';
	
	error_reporting(-1);
	ini_set("display_errors",1);

    

    $batch_code = '200539';

    
	$opts = array();

   # $opts = array( 'Batch_Number' => $batch_code );

  #  $list = GetTransferList( $opts); 

    
    $list = LoadBatchList();

	
	

    $batches = array();

    foreach ($list as $row) {
		$row = offsetProcessTime( $row ) ;
		if (!array_key_exists($row['Batch_Number'], $batches)) {
			#print_r($row);
			$batch = new BatchClass;
			$batch->MOLineId = $row['MOLineId'];
			$batch->Batch_Number = $row['Batch_Number'];
			$batch->DocNum = $row['DocNum'];
			$batch->ItemCode = $row['ItemCode'];
			$batch->ItemDescription = $row['ItemDescription'];
			$batch->starttime = getBatchTime($row['SetupStartDate'], $row['SetupStartTime'] );
			$batch->endtime = getBatchTime($row['RunEndDate'], $row['RunEndTime'] );
			$batches[$row['Batch_Number']] = $batch;
		}
		$batch = $batches[$row['Batch_Number']];
		$starttime = getBatchTime($row['SetupStartDate'], $row['SetupStartTime'] );
		if ($starttime<$batch->starttime) {
			$batch->starttime = $starttime;
		}
		$endtime = getBatchTime($row['RunEndDate'], $row['RunEndTime'] );
		if ($endtime>$batch->endtime) {
			$batch->endtime = $endtime;
		}

	#	$process = new BatchItemClass($row['id']);
		$process = LoadBatchItem( $row );

		$batch->processes[$row['MOLineId']] = $process;

    }
	

    echo '<pre>';

   # print_r($batches);

    echo '</pre>';

	

    foreach ($batches as $key=>$batch) {

	#	$endtime = $batch->RecalculateBatch();
	#	print_r($endtime);
    }

	#$batches = array_slice($batches, 0, 2);
	
	BuildResourceStructure( $batches );



} # end of cpg_build_batch_handler
	
function BuildResourceStructure( $batches ) {
    echo '<pre>';
   # print_r(reset($batches));
    echo '</pre>';

	$resources = array();

	foreach ($batches as $batch) {

		foreach ($batch->processes as $process) {
		#	echo "<br>" .  $process->WorkCentre;
			$t = array();
			$t['start'] = $process->starttime;
			$t['end'] = $process->endtime;
			$t['process'] = $process;
			$resources[$process->WorkCentre][$process->Batch_Number] = $t;
		}

	}

    echo '<pre>';
    #print_r($resources);
    echo '</pre>';
	echo show_resource_gantt($resources);
}

function show_resource_gantt($resources) {
	
	require_once(__DIR__ . '/ganttchartphp/ganttloader.php');

	ob_start();
	$opts = array();
   # $batch_code = '200539';
   # $opts = array( 'Batch_Number' => $batch_code );
  #  $list = GetTransferList( $opts); 
#print_r($list);

	$array_data = array();
	foreach ($resources as $key=>$row) {
		$t = array();
		$array_data[$key]['label'] = $key;  #$row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
		#$t['series'] = array();
		$it = array();

		$row = setConflicts( $row ) ;

		foreach ($row as $key2=>$item) {
			#$start = getBatchTime($row['start'], $row['SetupStartTime']);
			#$end = getBatchTime($row['RunEndDate'], $row['RunEndTime']);
			$conflict = !empty($item['conflict']) ? $item['conflict'] : 0;
			switch ($conflict) {
				case 1:
					$color = '#ff0000';
					break;
				case -1:
					$color = '#ec990b'; ;
					break;
				default: 
					$color = '#20bc5d';
			}

			$i = array('label' => $key2, 'allocations' => array( Array
                                        (
                                            'label' => $item['process']->ItemCode,
                                            'start' => $item['start']->format("Y-m-d H:i:s"),
                                            'end' => $item['end']->format("Y-m-d H:i:s"),
                                            'description' => $item['start']->format("Y-m-d H:i:s") . ' ' . $item['end']->format("Y-m-d H:i:s") . ' '. $item['process']->ItemDescription,
                                            'color' => $color,
                                        ) ) ) ;
			$it[]  = $i;
		}
		$array_data[$key]['series'] = $it;
	}


/*
	foreach ($array_data as $key=>$process) {

		#$batch_code = $key;
		#$opts = array( 'Batch_Number' => $batch_code );
		#$list = GetTransferList( $opts); 
		$t = array();
		foreach ($list as $row){
			#$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
			$t[] = array('label' => $row['WorkCentre'], 'allocations' => array( link_allocation($row) ) ) ;
		}
		$array_data[$key]['series'] = $t;
	}
*/
echo "<pre>";
#print_r($array_data);
echo "</pre>";

/*
	#print_r($array_data);
	#$array_data[0]['label'] = 'Ibuprofen & Codeine Tabs';
	#$array_data[0]['series'][] = array( 'label' => 'Sub-Activitie 1',
 #                           'allocations' => Array
  #                              (
                                #   Array
                                #        (
                                #            'label' => 'Task 1',
                                 #           'start' => '2013-09-15',
                                #            'end' => '2013-09-29',
                                 #           'description' => 'Description x',
                                 ##           'color' => '#00ff00',
                                  #      )
								#);
#						);

#

	#$t = $array_data[0]['series'][0]['allocations'][2];
	#unset($array_data[0]['series'][0]['allocations'][2]);
	#$array_data[0]['series'][] = array( 'label' => 'xxxx', 'allocations' => array( $t) );
	print_r($array_data);
#	$array_legend_data[2]['color'] = '#0000ff';

	#print_r($array_legend_data);
*/


	$defaultwidth = 100;
	if (!empty($_GET['width'])) {
		$defaultwidth = intval($_GET['width']);
	}
	$zoom = 0;
	if (!empty($_GET['zoom'])) {
		$zoom = intval($_GET['zoom']);
	}



echo '<div><input id="reverse" type="button" value="Reverse">&nbsp;&nbsp;<input id="advance" type="button" value="Advance"><input id="zoom" type="button" value="Zoom"></div>';
?>
<script>
jQuery(document).ready(function() {

	var widthscalar = <?php echo $defaultwidth; ?>;
	var startzoom = <?php echo $zoom; ?>;

	var offsetStep = 1200;

	if (startzoom)
	{
		jQuery(".gchart").css("zoom", '50%');
	}


	jQuery("#advance").on("click", function() {
		var leftmargin = jQuery(".gchart-sc header").css("margin-left");

		var margin = parseInt(leftmargin);
		margin = margin - offsetStep;

		jQuery(".gchart-sc header").css("margin-left", margin + 'px');
	});


	jQuery("#reverse").on("click", function() {
		var leftmargin = jQuery(".gchart-sc header").css("margin-left");

		var margin = parseInt(leftmargin);
		margin = margin + offsetStep;

		jQuery(".gchart-sc header").css("margin-left", margin + 'px');
	});

	jQuery("#zoom").on("click", function() {
		var zoomsetting = jQuery(".gchart").css("zoom");

		var zoom = parseFloat(zoomsetting);

		if (zoom==1)
		{
			zoom = 50;
		} else {
			zoom = 100;
		}

		jQuery(".gchart").css("zoom", zoom + '%');
	});

});
</script>
<?php

	$gantt_graph = new GanttChart\GanttChart( 'pt_BR' );


	$gantt_graph->setCellWidth($defaultwidth);

	$gantt_graph->setData( $array_data )
            #->setDataLegend($array_legend_data)
            ->render();
	
	 batch_form();

    $html = ob_get_clean();
    return $html;
	
}



function nss_all_portfolios_handler() {

	require_once(__DIR__ . '/ganttchartphp/ganttloader.php');


	#$array_data = include __DIR__ . '/ganttchartphp/tests/array_data.php';
	#$array_legend_data = include __DIR__ . '/ganttchartphp/tests/array_legend_data.php';

	ob_start();
	$opts = array();
    $batch_code = '200539';
    $opts = array( 'Batch_Number' => $batch_code );
    $list = GetTransferList( $opts); 
#print_r($list);

	$array_data = array();
	foreach ($list as $row) {
		$t = array();
		$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
		$t['series'] = array();
		$array_data[$row['Batch_Number']] = $t;
	}



	foreach ($array_data as $key=>$process) {

		$batch_code = $key;
		$opts = array( 'Batch_Number' => $batch_code );
		$list = GetTransferList( $opts); 
		$t = array();
		foreach ($list as $row){
			#$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
			$t[] = array('label' => $row['WorkCentre'], 'allocations' => array( link_allocation($row) ) ) ;
		}
		$array_data[$key]['series'] = $t;
	}
	#print_r($array_data);
	#$array_data[0]['label'] = 'Ibuprofen & Codeine Tabs';
	#$array_data[0]['series'][] = array( 'label' => 'Sub-Activitie 1',
 #                           'allocations' => Array
  #                              (
                                #   Array
                                #        (
                                #            'label' => 'Task 1',
                                 #           'start' => '2013-09-15',
                                #            'end' => '2013-09-29',
                                 #           'description' => 'Description x',
                                 ##           'color' => '#00ff00',
                                  #      )
								#);
#						);

#

	#$t = $array_data[0]['series'][0]['allocations'][2];
	#unset($array_data[0]['series'][0]['allocations'][2]);
	#$array_data[0]['series'][] = array( 'label' => 'xxxx', 'allocations' => array( $t) );
#	print_r($array_data);
#	$array_legend_data[2]['color'] = '#0000ff';

	#print_r($array_legend_data);

	$gantt_graph = new GanttChart\GanttChart( 'pt_BR' );

	$gantt_graph->setCellWidth(100);

	$gantt_graph->setData( $array_data )
            #->setDataLegend($array_legend_data)
            ->render();
	
    $html = ob_get_clean();
    return $html;
    

}







class ResourceBlock {

    

    var $startime ;

    var $totalDuration = '';

    

    var $setupTime = '';

    var $reducedSetupTime = '';

    

    var $processTime = '';

    

    var $cleaningTime = '';

    

    var $name = '';

    var $processParent = '';

    

    var $cleaning = 0;

    var $repeat = 0;

    

    function __construct( $params = array() ) {

        

        if (!empty($params)) {

            foreach ($params as $key=>$value) {

                $this->{$key} = $value;

            }

            

        }

    }

    

    function TotalTime() {

        $t = $this->setupTime;

        if ($this->repeat){

            $t = $this->reducedSetupTime;

        }

        $t += $this->processTime;

        

        if ($this->cleaning) {

            $t += $this->cleaningTime;

        }

        

        

        $totalDuration = $t;

        return $t;

    }

    

    

}



class ProcessBlock {

    

    var $processList = array();

    

    function __construct() {

        

    }   

    

    function addResource() {

        

    }

 

}







add_shortcode("cp_test_gantt", "cp_test_gantt");

function cp_test_gantt() {

 
	error_reporting(-1);
	ini_set("display_errors", 1);
	

	require_once(__DIR__ . '/ganttchartphp/ganttloader.php');




	#$array_data = include __DIR__ . '/ganttchartphp/tests/array_data.php';
	#$array_legend_data = include __DIR__ . '/ganttchartphp/tests/array_legend_data.php';

	ob_start();
	$opts = array();
    $batch_code = '200539';
    $opts = array( 'Batch_Number' => $batch_code );
    $list = GetTransferList( $opts); 
#print_r($list);

	$array_data = array();
	foreach ($list as $row) {
		$t = array();
		$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
		$t['series'] = array();
		$array_data[$row['Batch_Number']] = $t;
	}



	foreach ($array_data as $key=>$process) {

		$batch_code = $key;
		$opts = array( 'Batch_Number' => $batch_code );
		$list = GetTransferList( $opts); 
		$t = array();
		foreach ($list as $row){
			#$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
			$t[] = array('label' => $row['WorkCentre'], 'allocations' => array( link_allocation($row) ) ) ;
		}
		$array_data[$key]['series'] = $t;
	}
	#print_r($array_data);
	#$array_data[0]['label'] = 'Ibuprofen & Codeine Tabs';
	#$array_data[0]['series'][] = array( 'label' => 'Sub-Activitie 1',
 #                           'allocations' => Array
  #                              (
                                #   Array
                                #        (
                                #            'label' => 'Task 1',
                                 #           'start' => '2013-09-15',
                                #            'end' => '2013-09-29',
                                 #           'description' => 'Description x',
                                 ##           'color' => '#00ff00',
                                  #      )
								#);
#						);

#

	#$t = $array_data[0]['series'][0]['allocations'][2];
	#unset($array_data[0]['series'][0]['allocations'][2]);
	#$array_data[0]['series'][] = array( 'label' => 'xxxx', 'allocations' => array( $t) );
#	print_r($array_data);
#	$array_legend_data[2]['color'] = '#0000ff';

	#print_r($array_legend_data);

	$gantt_graph = new GanttChart\GanttChart( 'pt_BR' );

	$gantt_graph->setCellWidth(100);

	$gantt_graph->setData( $array_data )
            #->setDataLegend($array_legend_data)
            ->render();
	

    $html = ob_get_clean();

    return $html;

   

}



