<?php

class DisplayGantt {
	var $title = 'Production Schedule';

	function __construct() {
		
	}

	######################################################
	function output_custom() {
		echo '<div><input type="button" id="check_tasks" value="Check Tasks"></div>';
	}


	function RenderOutput() {

		error_reporting(-1);
		ini_set("display_errors", 1);

		ob_start();
		$workstations = array();
		if (!empty($_POST['field_id'])) {
			$wrks = json_decode(stripslashes($_POST['field_id']), true);
			if (!empty($wrks)) {
				foreach ($wrks as $wrk) {
					$workstations[] = "'" .  $wrk['id'] . "'";
				}
			}
		}

		require_once(cpg_plugin_dir_path() . '/ganttchartphp/ganttloader.php');

		$gantt_graph = new GanttChart\GanttChart(  );
		$gantt_graph->setCellWidth(100);

		$start = microtime(true);

		if (!empty($workstations)) {
			$array_data = $this->get_workstation_data($workstations);
		} else {
			$array_data = $this->get_test_data();
		}
		$stop = microtime(true);
		#echo "<br>Elapsed time: " . ($stop-$start) ;
		#echo "<br>Count = ". count($array_data);


		$day_data = $this->getFreeDays( $array_data);
		$gantt_graph->active_days($day_data);

		if (empty($_REQUEST['full'])) {
			$array_data = array_slice($array_data, 0, 50, true);
		} else {
			$array_data = array_slice($array_data, 0, 80, true);
		}

#print_r($array_data);
		echo '<div class=""><div class="progress-container"><div class="progress-bar" id="myProgressBar"></div></div></div>';

?>
[su_accordion]
[su_spoiler title="Batch Controls" style="fancy"] 
<?php
		if (!empty($array_data) && is_array($array_data)) {
			echo '<div><input type="checkbox" id="all_products">&nbsp;&nbsp;Toggle All?</div>';
			echo '<div class="batch-chk-wrapper wrapper-closed">';
			foreach ($array_data as $key=>$data) {
				echo '<div><input class="hide-batch-chk" type="checkbox" id="'. $key.'">'.$key.'</div>';
			}
			echo '</div>';
		}
?>
[/su_spoiler]
[su_spoiler title="Work Station Control" style="fancy"] 
<?php
		#if (!empty($array_data) && is_array($array_data)) {
			echo '<div><input type="checkbox" id="all_workareas">&nbsp;&nbsp;Toggle All?</div>';
			echo '<div class="work-chk-wrapper wrapper-closed">';
			$batch_names = GetWorkStations();
			foreach ($batch_names as $data) {
				if ($data['U_RscCode']=='QC Testing'){
					continue;
				}
				echo '<div><input class="hide-works-chk" type="checkbox" data-tag="'. $data['U_RscCode'].'" id="'. str_replace("/", "", str_replace(" ", "", $data['U_RscCode'])).'">'.$data['U_RscCode'].'</div>';
			}
			echo '</div>';
			echo '<div><input type="button" id="filter_workstations" value="Filter By"></div>';
		#}
?>
[/su_spoiler]

<!--[su_spoiler title="Views" style="fancy"] Hidden content [/su_spoiler]-->
[/su_accordion]
<?php
		echo '<div id="cpg_message"></div>';
		#echo "<div id=\"posdiag\">memory=" . memory_get_usage()/1000000 . "</div>";

		if (method_exists($this, 'output_custom')) {
			echo '<div class="custom_header_wrapper">';
			$this->output_custom();
			echo '</div>';
		}

		echo '<div class=""><div class="slider-container"><div class="slider-bar" id="mySliderBar"></div></div></div>';

#print_r(reset($array_data));

		$gantt_graph->setData( $array_data )
			    #->setDataLegend($array_legend_data)
				->render();

		$html = ob_get_clean();

		return do_shortcode($html);
	} # end of RenderOutput
#####################################################################

	function RenderBarOutput() {
		global $cpg_options;

		error_reporting(-1);
		ini_set("display_errors", 1);

		echo '<div class="bar-graph-title">'. $this->title . '</div>';

		ob_start();
		$params = array();
		$workstations = array();
		#print_r($_POST);
		if (!empty($_POST['action'])) {
			if (!empty($_POST['field_id']) && $_POST['action']=='workstation_gantt') {
				$wrks = json_decode(stripslashes($_POST['field_id']), true);
				if (!empty($wrks)) {
					foreach ($wrks as $wrk) {
						$workstations[] = "'" .  $wrk['id'] . "'";
					}
					$params['workstations'] = $workstations;
				}
			} elseif (!empty($_POST['field_id']) && $_POST['action']=='search_text') {
				$wrks = json_decode(stripslashes($_POST['field_id']), true);
				if (!empty($wrks)) {
					#print_r($wrks);
					foreach ($wrks as $key=>$wrk) {
						$params['search_text'][] = $wrk['value'];
						#$params['search_text'][] = $wrk['value'];
					}
				}
			}		
		}
		#print_r($workstations);

		require_once(cpg_plugin_dir_path() . '/ganttchartphp/ganttloader.php');

		#$gantt_graph = new GanttChart\GanttChart( 'pt_BR' );
		$gantt_graph = new BarChart\BarChart(  );
		#$params = array();
		#$params['conflict_color'] = !empty($cpg_options['conflict_color']) ? $cpg_options['conflict_color'] : '';
		$gantt_graph->setSiteDefaults($cpg_options);
		$gantt_graph->setCellWidth(100);

		$start = microtime(true);

		#print_r($params);
		if (!empty($params)) {
			$array_data = $this->get_product_data(false, $params);
		} else {
			$array_data = $this->get_product_data();
		}
		$stop = microtime(true);
		#echo "<br>Elapsed time: " . ($stop-$start) ;
#echo "Count=" . count($array_data);


		$day_data = $this->getFreeDays( $array_data);
		$gantt_graph->active_days($day_data);

		if (empty($_REQUEST['full'])) {
			#$array_data = array_slice($array_data, 0,10, true);
		} else {
			$array_data = array_slice($array_data, 0, 80, true);
		}

		ksort($array_data);
		#print_r($array_data);
		echo '<div class=""><div class="progress-container"><div class="progress-bar" id="myProgressBar"></div></div></div>';
?>
[su_accordion]
[su_spoiler title="Product Controls" style="fancy"] 
<?php
		if (!empty($array_data) && is_array($array_data)) {
			echo '<div class="toggleall"><input type="checkbox" id="all_products">&nbsp;Toggle All?</div>';
			echo '<div class="batch-chk-wrapper wrapper-closed">';
			foreach ($array_data as $key=>$data) {
				echo '<div><input title="'.$data['label'].'" class="hide-batch-chk" type="checkbox" id="'. $key.'">'.$key.'</div>';
			}
			echo '</div>';
		}
?>
[/su_spoiler]
[su_spoiler title="Work Station Control" style="fancy"] 
<?php
		#if (!empty($array_data) && is_array($array_data)) {
			echo '<div  class="toggleall"><input type="checkbox" id="all_workareas">&nbsp;Toggle All?</div>';
			echo '<div class="work-chk-wrapper wrapper-closed">';
			$batch_names = GetWorkStations();
			foreach ($batch_names as $data) {
				if ($data['U_RscCode']=='QC Testing'){
					continue;
				}
				echo '<div><input class="hide-works-chk" type="checkbox" data-tag="'. $data['U_RscCode'].'" id="'. str_replace("/", "", str_replace(" ", "", $data['U_RscCode'])).'">'.$data['U_RscCode'].'</div>';
			}
			echo '</div>';
			#echo '<div><input type="button" id="filter_workstations" value="Filter By"></div>';
		#}
?>
[/su_spoiler]

<!--[su_spoiler title="Views" style="fancy"] Hidden content [/su_spoiler]-->
[/su_accordion]
<?php
		echo '<div id="cpg_message"></div>';
		#echo "<div id=\"posdiag\">memory=" . memory_get_usage()/1000000 . "</div>";

		if (method_exists($this, 'output_custom')) {
			echo '<div class="custom_header_wrapper">';
			$this->output_custom();
			echo '</div>';
		}

		echo '<div class=""><div class="slider-container"><div class="slider-bar" id="mySliderBar"></div></div></div>';

		#print_r(reset($array_data));

		if (!empty($array_data)) {
			$gantt_graph->setData( $array_data )
				    #->setDataLegend($array_legend_data)
					->render();
		}

		$html = ob_get_clean();

		return do_shortcode($html);
	} # end of RenderBarOutput

	###########################################################

	function RenderUnifiedOutput() {
		global $cpg_options;

		ob_start();

		global $cpg_options;

		error_reporting(-1);
		ini_set("display_errors", 1);

		echo '<div class="bar-graph-title">'. $this->title . '</div>';

		$params = array();
		$workstations = array();
		#print_r($_POST);
		if (!empty($_POST['action'])) {
			if (!empty($_POST['field_id']) && $_POST['action']=='workstation_gantt') {
				$wrks = json_decode(stripslashes($_POST['field_id']), true);
				if (!empty($wrks)) {
					foreach ($wrks as $wrk) {
						$workstations[] = "'" .  $wrk['id'] . "'";
					}
					$params['workstations'] = $workstations;
				}
			} elseif (!empty($_POST['field_id']) && $_POST['action']=='search_text') {
				$wrks = json_decode(stripslashes($_POST['field_id']), true);
				if (!empty($wrks)) {
					#print_r($wrks);
					foreach ($wrks as $key=>$wrk) {
						$params['search_text'][] = $wrk['value'];
						#$params['search_text'][] = $wrk['value'];
					}
				}
			}		
		}
		#print_r($workstations);

		require_once(cpg_plugin_dir_path() . '/ganttchartphp/ganttloader.php');

		#$gantt_graph = new GanttChart\GanttChart( 'pt_BR' );
		$gantt_graph = new BarChart\BarChart(  );
		#$params = array();
		#$params['conflict_color'] = !empty($cpg_options['conflict_color']) ? $cpg_options['conflict_color'] : '';
		$gantt_graph->setSiteDefaults($cpg_options);
		$gantt_graph->setCellWidth(100);

		$start = microtime(true);

		#print_r($params);
		if (!empty($params)) {
			$array_data = $this->get_workstation_schedule(false, $params);
		} else {
			$array_data = $this->get_workstation_schedule();
		}
		$stop = microtime(true);
		#echo "<br>Elapsed time: " . ($stop-$start) ;
#echo "Count=" . count($array_data);
		$batches = sortBy::multisort($array_data, array('order', 'asc'));
		
		$wrkstatorder = GetWorkstationOrder();

		$new_array = array();
		foreach ($wrkstatorder as $order=>$workstation) {
			if (isset($array_data[$order])) {
				$new_array[] = $array_data[$order];
				unset($array_data[$order]);
			}
		}
		ksort($array_data);
		$array_data = array_merge($new_array, $array_data);
		#$array_data = $new_array;

#echo '<pre>';
#print_r($array_data);
#echo '</pre>';

		$day_data = $this->getFreeDays( $array_data);
		$gantt_graph->active_days($day_data);

		if (empty($_REQUEST['full'])) {
			#$array_data = array_slice($array_data, 0,10, true);
		} else {
			$array_data = array_slice($array_data, 0, 80, true);
		}

		ksort($array_data);
		#print_r($array_data);
		echo '<div class=""><div class="progress-container"><div class="progress-bar" id="myProgressBar"></div></div></div>';
?>
[su_accordion]
[su_spoiler title="Product Controls" style="fancy"] 
<?php
		if (!empty($array_data) && is_array($array_data)) {
			echo '<div class="toggleall"><input type="checkbox" id="all_products">&nbsp;Toggle All?</div>';
			echo '<div class="batch-chk-wrapper wrapper-closed">';
			foreach ($array_data as $key=>$data) {
				echo '<div><input title="'.$data['label'].'" class="hide-batch-chk" type="checkbox" id="'. $key.'">'.$key.'</div>';
			}
			echo '</div>';
		}
?>
[/su_spoiler]
[su_spoiler title="Work Station Control" style="fancy"] 
<?php
		#if (!empty($array_data) && is_array($array_data)) {
			echo '<div  class="toggleall"><input type="checkbox" id="all_workareas">&nbsp;Toggle All?</div>';
			echo '<div class="work-chk-wrapper wrapper-closed">';
			$batch_names = GetWorkStations();
			foreach ($batch_names as $data) {
				if ($data['U_RscCode']=='QC Testing'){
					continue;
				}
				echo '<div><input class="hide-works-chk" type="checkbox" data-tag="'. $data['U_RscCode'].'" id="'. str_replace("/", "", str_replace(" ", "", $data['U_RscCode'])).'">'.$data['U_RscCode'].'</div>';
			}
			echo '</div>';
			#echo '<div><input type="button" id="filter_workstations" value="Filter By"></div>';
		#}
?>
[/su_spoiler]

<!--[su_spoiler title="Views" style="fancy"] Hidden content [/su_spoiler]-->
[/su_accordion]
<?php
		echo '<div id="cpg_message"></div>';
		#echo "<div id=\"posdiag\">memory=" . memory_get_usage()/1000000 . "</div>";

		if (method_exists($this, 'output_custom')) {
			echo '<div class="custom_header_wrapper">';
			$this->output_custom();
			echo '</div>';
		}

		echo '<div class=""><div class="slider-container"><div class="slider-bar" id="mySliderBar"></div></div></div>';

		#print_r(reset($array_data));

		if (!empty($array_data)) {
			$gantt_graph->setData( $array_data )
#				    #->setDataLegend($array_legend_data)
					->render();
		}

		$html = ob_get_clean();

		return do_shortcode($html);
	}

	###########################################################
	function get_workstation_schedule( $list=array(), $params = array() ) {
		global $cpg_options;

		// this gets all production processes schedule for workstation in single workstation threads
		$array_data = array();

		error_reporting(-1);
		ini_set("display_errors", 1);

		$opts = array();
		$product_code = "'M2973'";
		$product_code = "'CF139'";

		$where = '';
		#$where =  ' a.U_ItemCode=' . $product_code ;
		if (!empty($params['workstations']) && is_array($params['workstations'])) {
			$where .= " b.U_RscCode in (" . implode(",", $params['workstations']) . ") ";
		} elseif (!empty($params['search_text']) && is_array($params['search_text'])) {
			$sep = '';
			foreach ($params['search_text'] as $search) {
				$where .= $sep . " a.U_Description LIKE '%%" . $search."%%' ";
				$sep = ' OR ';
			}
			$where = " (" . $where . ") ";
		} else {
		#	$where .= " b.U_RscCode= " . "'Bosch C/Weigher' ";
		}
		#echo $where;

		if (empty($list)) {
			$list = GetBatchList( $opts, $where );
		}

		#echo "<pre>";
		#print_r($list);
		#echo "</pre>";
		$wrkstatorder = GetWorkstationOrder();
		#print_r($wrkstatorder);


		$array_data = array();
		$alloc[]  = array();
		$lastbatch = '';
		foreach ($list as $row) {
			$t = array();
			if ($row['U_RscCode']== 'QC Testing'){
				continue;
			}
			if ($row['U_RscCode']!= 'Bosch C/Weigher'){
			#	continue;
			}
			#echo '<pre>';
			#print_r($row);
			#echo '</pre>';
			$wrkkey = str_replace("/", "", str_replace(" ", "", $row['U_RscCode'])) ;

			#$t = array();
			$t['label'] = $row['U_RscCode']; #$row['U_DistNumber'] . ' ' . substr($row['U_Description'], 0, 10);'
			$t['class'] = str_replace("/", "", str_replace(" ", "", $row['U_RscCode'])) ;
			$t['product'] = $row['U_RscCode'];
			$t['lastbatch'] = $lastbatch;
			$t['first'] = '';
			$t['last'] = '';
			$t['order'] = !empty($wrkstatorder[$wrkkey]) ? $wrkstatorder[$wrkkey] : 0;

			#$t['watch'][$wrkkey] = array('label' => $row['U_RscCode'], 'class' => $class, 'allocations' => array( link_product_allocation($row, $product_match) ) ) ;

			$class = 'dummy'; #str_replace(" ", "", $row['U_DistNumber']) ;
			#$t['watch'][$wrkkey]['label'] = $row['U_RscCode'];
			#$t['watch'][$wrkkey]['class'] = $class;
			#echo $row['U_DistNumber'];
			$product_match = false;
			if ($t['lastbatch']==$row['DocNum']) {
				$product_match = true;
			}

			$alloc[$wrkkey][] = link_product_allocation($row, $product_match );
			#$t['watch'][$wrkkey]['allocations'][] =  link_product_allocation($row, $product_match ) ;
			#$t['watch'][$wrkkey][] =  array('label'=>  $row['U_RscCode'],'class'=>$class, 'allocations' => array(link_product_allocation($row, $product_match )) );
			$t['watch'][$wrkkey][] =  array('label'=>  $row['U_RscCode'], 'class'=>$class, 'nrblocks'=> count($alloc[$wrkkey]), 'allocations' => $alloc[$wrkkey] );
			$lastbatch = $row['DocNum'];

			$array_data[$wrkkey] = $t;
		}
		#echo '<pre>';
		#print_r($alloc);
		#echo '</pre>';
			

		return $array_data;

		#print_r(reset($list));
		$newlist = array();
		$tbatch  = array();
		$wbatch = array();
		$today = new DateTime;
		$lastbatch = '';
		foreach ($list as $row) {
			#print_r($row);
			if ($row['U_RscCode']!= 'Bay 6 Packing'){
				continue;
			}
			$wrkkey = str_replace("/", "", str_replace(" ", "", $row['U_RscCode'])) ;
			#print_r($row);
			$t = array();
			$t['label'] = $row['U_RscCode']; #$row['U_DistNumber'] . ' ' . substr($row['U_Description'], 0, 10);'
			$t['class'] = str_replace("/", "", str_replace(" ", "", $row['U_RscCode'])) ;
			$t['product'] = $row['U_RscCode'];
			$t['watch'] = array();


			$wrkstation = str_replace("/", "", str_replace(" ", "", $row['U_RscCode']));
			#$wbatch[$row['U_ItemCode']][substr('0'.$row['U_LineNum'],0,2) . $wrkstation] = array();
			$wbatch[$wrkstation][$row['U_DistNumber']] = array();
			
			#$t['batch']= array();
			if (!empty($row['U_ItemCode'])){
				if (!array_key_exists($row['U_DistNumber'], $tbatch)) {
					$tbatch[$row['U_ItemCode']][$row['U_DistNumber']] = array();
				}
			}
			$t['lastbatch'] = $lastbatch;
			$t['first'] = '';
			$t['last'] = '';
			if (empty($row['U_SetupStartDate']) || $row['U_SetupStartDate']=='NULL') {
			#	continue;
			}
			$dte = new DateTime($row['U_SetupStartDate']);
			if ($dte<$today){ 
			#	continue;
			}

			$array_data[$wrkkey] = $t;
			if (!empty($newlist[$wrkkey][$row['U_DistNumber']]['A'.$row['U_LineNum']])) {
				#echo "fail";
				#print_r($row);
			}
			#$newlist[$row['U_RscCode']][$row['U_DistNumber']]['A'.$row['U_LineNum']] = $row;
			#$newlist[$wrkkey][$row['U_DistNumber']][] = $row;
			$newlist[$wrkkey][] = $row;
			$lastbatch = $row['DocNum'];
		}
		#echo "<pre>";
		#print_r($newlist);
		#echo "</pre>";
		foreach ($wbatch as $key=>$watch) {
			$array_data[$key]['watch'] = $watch;
		}

	#	array_slice($array_data, 0, 4);
		#echo "<pre>";
		#print_r($array_data);
		#echo "</pre>";

		$i = 0;
		foreach ($array_data as $wrkstnkey=>$process) {

			#$batch_code = $key;
			#$opts = array( 'a.U_ItemCode' => $batch_code );
			#$where = ' a.U_ItemCode=' . $batch_code . ' ';
			#$sort = ' b.U_LineNum asc ';
			#$list = GetBatchList( $opts, $where, $sort); 

			if (!array_key_exists($wrkstnkey, $newlist)) {
				continue;
			}
		#echo $wrkstnkey;
			$list = $newlist[$wrkstnkey];
			#ksort($list);
			echo '<pre>';
			#print_r($list);
			echo '</pre>';

			#echo count($list);
			if (empty($process['watch'])){
			#	continue;
			}
			if ((memory_get_usage()/1000000)>100 && !empty($cpg_options['memorywarning'])){
				echo "<br>Memory=" . memory_get_usage()/1000000;
			}

			$key=$wrkstnkey;
			$breakkeys = array_keys($process['watch']);
			#print_r($breakkeys);
			
			foreach ($breakkeys as $breakkey) {
				#echo " "  . $breakkey;



			$t = array();
		#	foreach ($list as $listrow){
			foreach ($list as $row){
			##	foreach ($listrow as $key2=>$row) {
					#echo "<br>$key2=";
			#echo '<pre>';
			#print_r($row);
			#echo '</pre>';
				#	print_r($row);
				$wrkstation = str_replace("/", "", str_replace(" ", "", $row['U_RscCode']));
				if ($wrkstation!='DispGrp') {
				#	continue;
				}

				#if ($row['U_RscCode']=='QC Testing' || $wrkstation!=$breakkey) {
				#	continue;
				#}
				#$row = setConflicts( $row ) ;

				if (empty($array_data[$key]['first'])){
					$array_data[$key]['first'] = str_replace("-", "", $row['U_SetupStartDate']).str_replace(":", "", substr('00'.$row['U_SetupStartTime'],-4));
				}
				$newstart = str_replace("-", "", $row['U_SetupStartDate']).str_replace(":", "", substr('00'.$row['U_SetupStartTime'],-4));
				if ($newstart<$array_data[$key]['first']){
					$array_data[$key]['first'] = $newstart;
				}
				if (empty($array_data[$key]['last'])){
					$array_data[$key]['last'] = str_replace("-", "", $row['U_RunEndDate']).str_replace(":", "", substr('00'.$row['U_RunEndTime'],-4));
				}
				$newfinish = str_replace("-", "", $row['U_RunEndDate']).str_replace(":", "", substr('00'.$row['U_RunEndTime'],-4));
				if ($newfinish>$array_data[$key]['last']){
					$array_data[$key]['last'] = $newfinish;
				}
				#$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
				$product_match = false;
				if ($array_data[$key]['lastbatch']==$row['DocNum']) {
					$product_match = true;
				}
				$class = str_replace(" ", "", $row['U_DistNumber']) ;
				if ($breakkey==$class) {
					$t[] = array('label' => $row['U_RscCode'], 'class' => $class, 'allocations' => array( link_product_allocation($row, $product_match) ) ) ;
				}
			#	}
			}
			echo "<pre>";
			print_r($t);
			echo "</pre>";
			$array_data[$key]['watch'] = $t;
			}
			echo '<pre>';
			#print_r($array_data);
			echo '</pre>';

			#$array_data[$key]['series'] = $t;
			$i++;
			if ($i>=1) {
				break;
			}
		}
		unset($newlist);  
		#print_r(array_keys($array_data));
		$array_data = array_slice($array_data, 0, 1);
		echo "<pre>";
		#print_r($array_data);
		#print_r($array_data['Bay6Packing']['watch']);
		echo "</pre>";
		return $array_data;


		return array();

	} # end of get_workstation_schedule

	###########################################################
	function get_product_data($list = array(), $params = array() ) {
		global $cpg_options;

		$array_data = array();

		error_reporting(-1);
		ini_set("display_errors", 1);

		$opts = array();
		$product_code = "'M2973'";
		$product_code = "'CF139'";

		$where = '';
		#$where =  ' a.U_ItemCode=' . $product_code ;
		if (!empty($params['workstations']) && is_array($params['workstations'])) {
			$where .= " b.U_RscCode in (" . implode(",", $params['workstations']) . ") ";
		} elseif (!empty($params['search_text']) && is_array($params['search_text'])) {
			$sep = '';
			foreach ($params['search_text'] as $search) {
				$where .= $sep . " a.U_Description LIKE '%%" . $search."%%' ";
				$sep = ' OR ';
			}
			$where = " (" . $where . ") ";
		#} else {
			#$where .= " b.U_RscCode= " . "'DispGrp' ";
		}
		#echo $where;

		if (empty($list)) {
			$list = GetBatchList( $opts, $where );
		}
#echo "Count=" . count($list);

	#	$list = apply_filters("custp_merge_modified_batch", $list, false) ;

		$array_data = array();
		$newlist = array();
		$tbatch  = array();
		$wbatch = array();
		$today = new DateTime;
		$lastbatch = '';
		foreach ($list as $row) {
			#print_r($row);
			$t = array();
			$t['label'] = substr($row['U_Description'], 0, 15); #$row['U_DistNumber'] . ' ' . substr($row['U_Description'], 0, 10);'
			$t['class'] = str_replace(" ", "", $row['U_DistNumber']) ;
			$t['product'] = $row['U_ItemCode'];

			$wrkstation = str_replace("/", "", str_replace(" ", "", $row['U_RscCode']));
			#$wbatch[$row['U_ItemCode']][substr('0'.$row['U_LineNum'],0,2) . $wrkstation] = array();
			$wbatch[$row['U_ItemCode']][$wrkstation] = array();
			
			#$t['batch']= array();
			if (!empty($row['U_ItemCode'])){
				if (!array_key_exists($row['U_DistNumber'], $tbatch)) {
					$tbatch[$row['U_ItemCode']][$row['U_DistNumber']] = array();
				}
			}
			$t['lastbatch'] = $lastbatch;
			$t['first'] = '';
			$t['last'] = '';
			if (empty($row['U_SetupStartDate']) || $row['U_SetupStartDate']=='NULL') {
			#	continue;
			}
			$dte = new DateTime($row['U_SetupStartDate']);
			if ($dte<$today){ 
			#	continue;
			}
			$array_data[$row['U_ItemCode']] = $t;
			$newlist[$row['U_ItemCode']]['A'.$row['U_LineNum']] = $row;
			$lastbatch = $row['DocNum'];
		}
		#print_r($tbatch);
		foreach ($tbatch as $key=>$batch) {
			#$array_data[$key]['batch'] = $batch;
		}
		foreach ($wbatch as $key=>$batch) {
			if (array_key_exists($key, $array_data)) {
				$array_data[$key]['watch'] = $batch;
			}
		}
		#echo count($array_data);
		#echo '<pre>';
		#print_r($array_data);
		#echo '</pre>';
		unset($list);
#echo "Count array=" . count($array_data);

		if ((memory_get_usage()/1000000)>30){
		#	echo "<br>Memory=" . memory_get_usage()/1000000 ;
		}

		#$array_data = array_slice($array_data, 0, 6, true);
		$i = 0;
		foreach ($array_data as $key=>$process) {

			$batch_code = $key;
			$opts = array( 'a.U_ItemCode' => $batch_code );
			$where = ' a.U_ItemCode=' . $batch_code . ' ';
			$sort = ' b.U_LineNum asc ';
			#$list = GetBatchList( $opts, $where, $sort); 

			$list = $newlist[$batch_code];
			ksort($list);
			#echo count($list);
			if ((memory_get_usage()/1000000)>100 && !empty($cpg_options['memorywarning'])){
				echo "<br>Memory=" . memory_get_usage()/1000000;
			}

			$breakkeys = array_keys($process['watch']);
			
			foreach ($breakkeys as $breakkey) {

			$t = array();
			foreach ($list as $row){
				$wrkstation = str_replace("/", "", str_replace(" ", "", $row['U_RscCode']));
				if ($wrkstation!='DispGrp') {
				#	continue;
				}

				if ($row['U_RscCode']=='QC Testing' || $wrkstation!=$breakkey) {
					continue;
				}
				#$row = setConflicts( $row ) ;


				if (empty($array_data[$key]['first'])){
					$array_data[$key]['first'] = str_replace("-", "", $row['U_SetupStartDate']).str_replace(":", "", substr('00'.$row['U_SetupStartTime'],-4));
				}
				$newstart = str_replace("-", "", $row['U_SetupStartDate']).str_replace(":", "", substr('00'.$row['U_SetupStartTime'],-4));
				if ($newstart<$array_data[$key]['first']){
					$array_data[$key]['first'] = $newstart;
				}
				if (empty($array_data[$key]['last'])){
					$array_data[$key]['last'] = str_replace("-", "", $row['U_RunEndDate']).str_replace(":", "", substr('00'.$row['U_RunEndTime'],-4));
				}
				$newfinish = str_replace("-", "", $row['U_RunEndDate']).str_replace(":", "", substr('00'.$row['U_RunEndTime'],-4));
				if ($newfinish>$array_data[$key]['last']){
					$array_data[$key]['last'] = $newfinish;
				}

				#$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
				$product_match = false;
				if ($array_data[$key]['lastbatch']==$row['DocNum']) {
					$product_match = true;
				}
				$class = str_replace(" ", "", $row['U_DistNumber']) ;
				$t[] = array('label' => $row['U_RscCode'], 'class' => $class, 'allocations' => array( link_product_allocation($row, $product_match) ) ) ;
			}
			$array_data[$key]['watch'][$breakkey] = $t;
			}
			#$array_data[$key]['series'] = $t;
			$i++;
		}
		unset($newlist);
		#echo "<pre>";
		#print_r($array_data);
		#echo "</pre>";
		return $array_data;
	}
	################################################################################################

	function get_test_data() {
		global $cpg_options;

		$opts = array();
		$batch_code = '200539';
		$where = '';
		#$where =  ' a.U_DistNumber=' . $batch_code ;
		$list = GetBatchList( $opts, $where );

		$array_data = array();
		$newlist = array();
		$today = new DateTime;
		$lastbatch = '';
		foreach ($list as $row) {
			$t = array();
			$t['label'] = substr($row['U_Description'], 0, 15); #$row['U_DistNumber'] . ' ' . substr($row['U_Description'], 0, 10);
			$t['class'] = str_replace(" ", "", $row['U_DistNumber']) ;
			$t['series'] = array();
			$t['lastbatch'] = $lastbatch;
			$t['first'] = '';
			$t['last'] = '';
			if (empty($row['U_SetupStartDate']) || $row['U_SetupStartDate']=='NULL') {
				continue;
			}
			$dte = new DateTime($row['U_SetupStartDate']);
			if ($dte<$today){ 
				continue;
			}
			$array_data[$row['U_DistNumber']] = $t;
			$newlist[$row['U_DistNumber']]['A'.$row['U_LineNum']] = $row;
			$lastbatch = $row['DocNum'];
		}
		#echo count($array_data);

		unset($list);
		if ((memory_get_usage()/1000000)>100 && !empty($cpg_options['memorywarning'])){
			echo "<br>Memory=" . memory_get_usage()/1000000 ;
		}

		#$array_data = array_slice($array_data, 0, 2, true);
		$i = 0;
		foreach ($array_data as $key=>$process) {
			#echo "key = " . $key;

			if ($i>20) {
			#	$array_data = array_slice($array_data, 0, $i);
			#	break;
			}

			$batch_code = $key;
			$opts = array( 'a.U_DistNumber' => $batch_code );
			$where = ' a.U_DistNumber=' . $batch_code . ' ';
			$sort = ' b.U_LineNum asc ';
			#$list = GetBatchList( $opts, $where, $sort); 

			$list = $newlist[$batch_code];
			ksort($list);
			#echo count($list);
			if ((memory_get_usage()/1000000)>100 && !empty($cpg_options['memorywarning'])){
				echo "<br>Memory=" . memory_get_usage()/1000000;
			}

			$t = array();
			foreach ($list as $row){
				if ($row['U_RscCode']=='QC Testing') {
					continue;
				}

				if (empty($array_data[$key]['first'])){
					$array_data[$key]['first'] = str_replace("-", "", $row['U_SetupStartDate']).str_replace(":", "", substr('00'.$row['U_SetupStartTime'],-4));
				}
				$newstart = str_replace("-", "", $row['U_SetupStartDate']).str_replace(":", "", substr('00'.$row['U_SetupStartTime'],-4));
				if ($newstart<$array_data[$key]['first']){
					$array_data[$key]['first'] = $newstart;
				}
				if (empty($array_data[$key]['last'])){
					$array_data[$key]['last'] = str_replace("-", "", $row['U_RunEndDate']).str_replace(":", "", substr('00'.$row['U_RunEndTime'],-4));
				}
				$newfinish = str_replace("-", "", $row['U_RunEndDate']).str_replace(":", "", substr('00'.$row['U_RunEndTime'],-4));
				if ($newfinish>$array_data[$key]['last']){
					$array_data[$key]['last'] = $newfinish;
				}

				#$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
				$product_match = false;
				if ($array_data[$key]['lastbatch']==$row['DocNum']) {
					$product_match = true;
				}
				$class = str_replace(" ", "", $row['U_DistNumber']) ;
				$t[] = array('label' => $row['U_RscCode'], 'class' => $class, 'allocations' => array( link_allocation($row, $product_match) ) ) ;
			}
			$array_data[$key]['series'] = $t;
			$i++;
		}
		unset($newlist);
		return $array_data;
	} # end of get_test_data

	function get_workstation_data($workstations = array() ) {
		global $cpg_options;

		$opts = array();
		$batch_code = '200539';
		$where = '';
		#$where =  ' a.U_DistNumber=' . $batch_code ;
		
		if (!empty($workstations) && is_array($workstations)) {
			$where .= " b.U_RscCode in (" . implode(",", $workstations) . ") ";
		} else {
			$where .= " b.U_RscCode= " . "'DispGrp' ";
		}
		#echo $where;
		$list = GetBatchList( $opts, $where );

		$array_data = array();
		$newlist = array();
		$today = new DateTime;
		$lastbatch = '';
		foreach ($list as $row) {
			$t = array();
			$t['label'] = substr($row['U_Description'], 0, 25); #$row['U_DistNumber'] . ' ' . substr($row['U_Description'], 0, 10);
			$t['class'] = str_replace(" ", "", $row['U_DistNumber']) ;
			$t['series'] = array();
			$t['lastbatch'] = $lastbatch;
			$t['first'] = '';
			$t['last'] = '';
			if (empty($row['U_SetupStartDate']) || $row['U_SetupStartDate']=='NULL') {
				continue;
			}
			$dte = new DateTime($row['U_SetupStartDate']);
			if ($dte<$today){ 
				continue;
			}
			$array_data[$row['U_DistNumber']] = $t;
			$newlist[$row['U_DistNumber']]['A'.$row['U_LineNum']] = $row;
			$lastbatch = $row['DocNum'];
		}
		#echo count($array_data);

		#print_r($array_data);
		unset($list);
		if ((memory_get_usage()/1000000)>30){
			echo "<br>Memory=" . memory_get_usage()/1000000 ;
		}

		#$array_data = array_slice($array_data, 0, 2, true);
		$i = 0;
		foreach ($array_data as $key=>$process) {
			#echo "key = " . $key;

			if ($i>20) {
			#	$array_data = array_slice($array_data, 0, $i);
			#	break;
			}

			$batch_code = $key;
			$opts = array( 'a.U_DistNumber' => $batch_code );
			$where = ' a.U_DistNumber=' . $batch_code . ' ';
		if (!empty($workstations) && is_array($workstations)) {
			$where .= " and b.U_RscCode in (" . implode(",", $workstations) . ") ";
		} else {
			$where .= " and b.U_RscCode= " . "'DispGrp' ";
		}

			#$where .= " and b.U_RscCode= " . "'DispGrp'";
			$sort = ' b.U_LineNum asc ';
			#$list = GetBatchList( $opts, $where, $sort); 

			$list = $newlist[$batch_code];
			ksort($list);

			#echo count($list);
			if ((memory_get_usage()/1000000)>100 && !empty($cpg_options['memorywarning'])){
				echo "<br>Memory=" . memory_get_usage()/1000000;
			}

			$t = array();
			foreach ($list as $row){
				if ($row['U_RscCode']=='QC Testing') {
					continue;
				}
				if (empty($array_data[$key]['first'])){
					$array_data[$key]['first'] = str_replace("-", "", $row['U_SetupStartDate']).str_replace(":", "", substr('00'.$row['U_SetupStartTime'],-4));
				}
				$newstart = str_replace("-", "", $row['U_SetupStartDate']).str_replace(":", "", substr('00'.$row['U_SetupStartTime'],-4));
				if ($newstart<$array_data[$key]['first']){
					$array_data[$key]['first'] = $newstart;
				}
				if (empty($array_data[$key]['last'])){
					$array_data[$key]['last'] = str_replace("-", "", $row['U_RunEndDate']).str_replace(":", "", substr('00'.$row['U_RunEndTime'],-4));
				}
				$newfinish = str_replace("-", "", $row['U_RunEndDate']).str_replace(":", "", substr('00'.$row['U_RunEndTime'],-4));
				if ($newfinish>$array_data[$key]['last']){
					$array_data[$key]['last'] = $newfinish;
				}

				$product_match = false;
				if ($array_data[$key]['lastbatch']==$row['DocNum']) {
					$product_match = true;
				}
				$class = str_replace(" ", "", $row['U_DistNumber']) ;
				$t[] = array('label' => $row['U_RscCode'], 'class' => $class, 'allocations' => array( link_allocation($row, $product_match) ) ) ;
			}
			$array_data[$key]['series'] = $t;
			$i++;
		}
		unset($newlist);
		return $array_data;

	}

	function getFreeDays( $data = array()){ 
		global $cpg_options;
			
		$dayArray = array();
		$first = '';
		$last = '';
		#foreach ($data as $key=>$datarow) {
			#echo "<br>" . $key;
		foreach ($data as $row) {
			#print_r($row);
			if (empty($first) || $row['first']<$first) {
				$first = $row['first'];
			}
			if (empty($last) || $row['last']>$last) {
				$last = $row['last'];
			}
			$fd = substr($row['first'], 0, 8);
			$ld = substr($row['last'], 0, 8);
			for ($i=$fd; $i<=$ld; $i++) {
				$dayArray[$i] = 1;
			}
		}
		#}

		#echo "<br>" . $first  . '  ' . $last;

		ksort($dayArray);
		return $dayArray;
	}



} # end of DisplayGantt

class DisplayHistoricalGantt extends DisplayGantt {
	var $title = 'Overdue Batches';
	function __construct() {
		parent::__construct();
	}

	function get_product_data( $list = array(), $params=array() ) {

		$batches = GetHistoricalBatchList();
		#print_r($batches);


		return parent::get_product_data($batches, $params);
	}

} # end of DisplayHistoricalGantt

class DisplayChangesGantt extends DisplayGantt {
	var $title = 'Product Changes';
	function __construct() {
		parent::__construct();
	}

	function changeBaseBatchColor( $basewatch, $color='#addbff' ) {

		foreach ($basewatch['allocations'] as $key=>$allocation){
			$basewatch['allocations'][$key]['color'] = $color;
			$basewatch['allocations'][$key]['class'] .= ' notDraggable ';
		}

		return $basewatch;
	}

	function output_custom() {
		echo '<div><input type="button" id="toggle_original_tasks" value="Toggle Original"></div>';
		parent::output_custom();
	}

	function get_product_data( $list = array(), $params=array() ) {

		$batches = GetChangesBatchList();

		if (empty($batches)) {
			echo '<div class="import-warning-message">No data was found</div>';
			return array();
		}

		$keys = array();
		foreach ($batches as $row) {
			$keys[] = $row['bid'];
		}
		$where = " b.id in ( " . implode(", ", $keys) . ") ";
		$base_batches = GetBatchList( null, $where );
	
		#$batches = array_merge($batches, $base_batches);

		$batches =  parent::get_product_data($batches, $params);

		$base_batches =  parent::get_product_data($base_batches, $params);

		foreach ($batches as $key=>$batch) {
			foreach ($batch['watch'] as $key2=>$subbatch) {
				foreach ($base_batches as $base_batch) {
					if ($base_batch['label']==$batch['label']) {
						foreach ($base_batch['watch'][$key2] as $basewatch){
							$batches[$key]['watch'][$key2][] = $this->changeBaseBatchColor($basewatch);
						}
					}
				}

			}
		}
		#print_r(reset($batches));

		return $batches;
	}

} # end of DisplayHistoricalGantt


class DisplayTable {
	var $batches = array();

	function __construct() {
	}

	function GetData() {
		$this->batches = GetHistoricalBatchList();

	}

	function RenderTable($batches = array()) {

		if (empty($this->batches)) {
			$this->GetData();
		}

		$batches = $this->batches;

		$batches = sortBy::multisort($batches, array('U_SetupStartDate', 'asc'));

		echo '<div class="Table-header Table-row cursor" data-value="sort">';
		echo '<div class="Table-row-item id" data-key="id"><div>DocNum</div></div>';
		echo '<div class="Table-row-item itemcode" data-key="ItemCode"><div>ItemCode</div></div>';
		echo '<div class="Table-row-item product" data-key="Product"><div>Product</div></div>';
		echo '<div class="Table-row-item distnumber" data-key="DistNumber"><div>DistNumber</div></div>';
		echo '<div class="Table-row-item rsccode" data-key="RscCode"><div>RscCode</div></div>';
		echo '<div class="Table-row-item setupdate" data-key="Setup Date"><div>Setup Date</div></div>';
		echo '<div class="Table-row-item sc_status" data-key="Status"><div>Status</div></div>';
		echo '</div>';

		foreach ($batches as $product) {
			#print_r($product);
			echo '<div class="Table-row cursor  list-'.$oddeven.'-row '.$hideClass.'" data-key="id" data-value="'.$product['DocNum'].'">';
			echo '<div data-key="id" data-header="ID" class="Table-row-item id"><div>'.$product['DocNum'].'</div></div>';
			echo '<div data-key="itemcode" data-header="ItemCode" class="Table-row-item itemcode"><div>'.$product['U_ItemCode'].'</div></div>';
			echo '<div data-key="product" data-header="Product" class="Table-row-item product"><div>'.$product['U_Description'].'</div></div>';
			echo '<div data-key="distnumber" data-header="DistNumber" class="Table-row-item distnumber "><div>'.$product['U_DistNumber'].'</div></div>';
			echo '<div data-key="rsccode" data-header="RscCode" class="Table-row-item rsccode "><div>'.$product['U_RscCode'].'</div></div>';
			echo '<div data-key="setupdate" data-header="Setup Date" class="Table-row-item setupdate "><div>'.$product['U_SetupStartDate'].'</div></div>';
			echo '<div data-key="sc_status" data-header="Status" class="Table-row-item sc_status "><div>'.$product['U_Status'].'</div></div>';
			echo '</div>';

		}
	}

/*
	function ExportExcel() {
 		if (empty($this->batches)) {
			$this->GetData();
		}
		$batches = $this->batches;

		$headers = array(  'DocNum','U_ItemCode', 'U_Description', 'U_Status', 'U_DistNumber', 'U_LineNum', 'U_RscCode', 'U_SetupStartDate');

		$tArray = array();
		foreach ($batches as $batch) {

			$tmp = array();

			foreach ($headers as $header) {
				$tmp[$header] = $batch[$header];
			}
			$tArray[] = $tmp;
		}
		array_unshift($tArray, $headers);
		#print_r($tArray);

 		$ExcelIO = new PHPExcelInterface;
  		$url = $ExcelIO->WriteCSVFile($tArray,  'overdue_sheet.csv');

		echo '<div style="margin-top:50px;margin-bottom:20px;">The list of overdue production items has been generated. Click the link below to download the spreadsheet.</div>';

		echo '<div style="text-align:center;"><a href="' . $url . '">Overdue Excel Spreadsheet</a></div>';
  		#$file = $ExcelIO->createProductExcel( $array );
  	

	}
*/

	function RenderIterationsTable($batches = array()) {

		if (empty($this->batches)) {
			#$this->GetData();
			$this->batches = GetBatchIterations();
		}

		$batches = $this->batches;

		#print_r($batches);

		$batches = sortBy::multisort($batches, array('update_time', 'desc'));


		echo '<div class="Table-header Table-row cursor" data-value="sort">';
		echo '<div class="Table-row-item id" data-key="id"><div>Update Code</div></div>';
		echo '<div class="Table-row-item id" data-key="id"><div>Update Time</div></div>';
		echo '<div class="Table-row-item itemcode" data-key="ItemCode"><div>ItemCode</div></div>';
		echo '<div class="Table-row-item product" data-key="Product"><div>Product</div></div>';
		echo '<div class="Table-row-item distnumber" data-key="LineNum"><div>LineNum</div></div>';
		echo '<div class="Table-row-item rsccode" data-key="RscCode"><div>RscCode</div></div>';
		echo '<div class="Table-row-item setupdate" data-key="Setup Date"><div>Setup Date</div></div>';
		echo '<div class="Table-row-item sc_status" data-key="Status"><div>Status</div></div>';
		echo '<div class="Table-row-item sc_status" data-key="Active"><div>Active</div></div>';
		echo '<div class="Table-row-item sc_status" data-key="Delete"><div>Delete</div></div>';
		echo '</div>';

		$lastrow = '';

		$i = 0;
		foreach ($batches as $product) {
			$i++;

			$oddeven = $i % 2 == 0 ? 'even' : 'odd';

			#print_r($product);
			if ($lastrow == $product['update_code']) {
				$hideClass = ' hideRow hidden ' ;
				$link = '';
			} else { 
				$hideClass = ' showRow ';
				$link = '<a class="iteration-link" data-tag="switch_iteration" data-ref="'.$product['update_code'].'" href="">x</a>';
			}
			$lastrow = $product['update_code'];
		
			echo '<div data-tag="'.$product['update_code'].'" class="Table-row cursor  list-'.$oddeven.'-row '.$hideClass.'" data-key="id" data-value="'.$product['DocNum'].'">';
			echo '<div data-key="id" data-header="ID" class="Table-row-item id"><div>'.$product['update_code'].'</div></div>';
			echo '<div data-key="id" data-header="ID" class="Table-row-item id"><div>'.$product['update_time'].'</div></div>';
			echo '<div data-key="itemcode" data-header="ItemCode" class="Table-row-item itemcode"><div>'.$product['U_ItemCode'].'</div></div>';
			echo '<div data-key="product" data-header="Product" class="Table-row-item product"><div>'.$product['U_Description'].'</div></div>';
			echo '<div data-key="distnumber" data-header="LineNum" class="Table-row-item distnumber "><div>'.$product['U_LineNum'].'</div></div>';
			echo '<div data-key="rsccode" data-header="RscCode" class="Table-row-item rsccode "><div>'.$product['U_RscCode'].'</div></div>';
			echo '<div data-key="setupdate" data-header="Setup Date" class="Table-row-item setupdate "><div>'.$product['U_SetupStartDate'].'</div></div>';
			echo '<div data-key="sc_status" data-header="Status" class="Table-row-item sc_status "><div>'.$product['U_Status'].'</div></div>';
			echo '<div data-key="sc_status" data-header="Active" class="Table-row-item sc_status "><div>'.!$product['deleted'].'</div></div>';
			echo '<div data-key="sc_status" data-header="Delete" class="Table-row-item sc_status "><div>'.$link.'</div></div>';
			echo '</div>';


		}
	} # end of RenderIterationsTable

}
?>