<?php

/*
    @id BIGINT,
    @bid BIGINT = NULL,
    @update_code NVARCHAR(50) = NULL,
    @update_time DATETIME = NULL,
    @DocEntry NVARCHAR(255) = NULL,
    @LineId NVARCHAR(255) = NULL,
    @VisOrder NVARCHAR(255) = NULL,
    @Object NVARCHAR(255) = NULL,
    @LogInst NVARCHAR(255) = NULL,
    @U_LineNum NVARCHAR(255) = NULL,
    @U_MorCode NVARCHAR(255) = NULL,
    @U_RevCode NVARCHAR(255) = NULL,
    @U_RgtCode NVARCHAR(255) = NULL,
    @U_RtgOprCode NVARCHAR(255) = NULL,
    @U_OprCode NVARCHAR(255) = NULL,
    @U_RtgOprRscCode NVARCHAR(255) = NULL,
    @U_QueueTime NVARCHAR(255) = NULL,
    @U_QTimeCost NVARCHAR(255) = NULL,
    @U_QFixedCost NVARCHAR(255) = NULL,
    @U_QVariableCost NVARCHAR(255) = NULL,
    @U_SetupTime NVARCHAR(255) = NULL,
    @U_STimeCost NVARCHAR(255) = NULL,
    @U_SFixedCost NVARCHAR(255) = NULL,
    @U_SVariableCost NVARCHAR(255) = NULL,
    @U_RunTime NVARCHAR(255) = NULL,
    @U_RTimeCost NVARCHAR(255) = NULL,
    @U_RFixedCost NVARCHAR(255) = NULL,
    @U_RVariableCost NVARCHAR(255) = NULL,
    @U_StockTime NVARCHAR(255) = NULL,
    @U_LTimeCost NVARCHAR(255) = NULL,
    @U_LFixedCost NVARCHAR(255) = NULL,
    @U_LVariableCost NVARCHAR(255) = NULL,
    @U_RunRate NVARCHAR(20)  = NULL,
    @U_StockRate NVARCHAR(20) = NULL,
    @U_SetupRate NVARCHAR(20) = NULL,
    @U_QueueRate NVARCHAR(20) = NULL,
    @U_Remarks NVARCHAR(255) = NULL,
    @U_RscCode NVARCHAR(30) = NULL,
    @U_HasCycles NVARCHAR(20) = NULL,
    @U_NrOfResources NVARCHAR(255) = NULL,
    @U_CycleCap NVARCHAR(255) = NULL,
    @U_RunTotal NVARCHAR(255) = NULL,
    @U_SetupTotal NVARCHAR(255) = NULL,
    @U_QueueTotal NVARCHAR(255) = NULL,
    @U_StockTotal NVARCHAR(255) = NULL,
    @U_ActRun NVARCHAR(255) = NULL,
    @U_ActSetup NVARCHAR(255) = NULL,
    @U_ActQueue NVARCHAR(255) = NULL,
    @U_ActStock NVARCHAR(255) = NULL,
    @U_ActCost NVARCHAR(255) = NULL,
    @U_RunStartDate NVARCHAR(255) = NULL,
    @U_RunStartTime NVARCHAR(255) = NULL,
    @U_SetupStartDate NVARCHAR(255) = NULL,
    @U_SetupStartTime NVARCHAR(255) = NULL,
    @U_QueueStartDate NVARCHAR(255) = NULL,
    @U_QueueStartTime NVARCHAR(255) = NULL,
    @U_StockStartDate NVARCHAR(255) = NULL,
    @U_StockStartTime NVARCHAR(255) = NULL,
    @U_TotalSeconds NVARCHAR(255) = NULL,
    @U_RunEndDate NVARCHAR(255) = NULL,
    @U_RunEndTime NVARCHAR(255) = NULL,
    @U_SetupEndDate NVARCHAR(255) = NULL,
    @U_SetupEndTime NVARCHAR(255) = NULL,
    @U_QueueEndDate NVARCHAR(255) = NULL,
    @U_QueueEndTime NVARCHAR(255) = NULL,
    @U_StockEndDate NVARCHAR(255) = NULL,
    @U_StockEndTime NVARCHAR(255) = NULL,
    @U_RscType NVARCHAR(10) = NULL,
    @U_MachineCode NVARCHAR(255) = NULL,
    @U_IssueType NVARCHAR(10) = NULL,
    @U_Active NVARCHAR(10) = NULL,
    @U_BaseRscLine NVARCHAR(10) = NULL,
    @U_Qty NVARCHAR(255) = NULL,
    @U_PlannedQty NVARCHAR(255) = NULL,
    @U_Project NVARCHAR(10) = NULL,
    @U_OcrCode NVARCHAR(10) = NULL,
    @U_OcrCode2 NVARCHAR(10) = NULL,
    @U_OcrCode3 NVARCHAR(10) = NULL,
    @U_OcrCode4 NVARCHAR(10) = NULL,
    @U_OcrCode5 NVARCHAR(10) = NULL,
    @U_Freeze NVARCHAR(10) = NULL,
    @Last_Refresh NVARCHAR(255) = NULL,
    @active int = 1,
    @deleted int = 0,
    @created DATETIME = NULL,
    @modified DATETIME = NULL
*/

class dbSQL_Class {

	var $conn = null;

	function __construct() {

	}

	function open_connection() {
		global $cpg_options;

		$serverName = !empty($cpg_options['sql_host']) ? $cpg_options['sql_host'] : "77.68.5.26";
		$userName = !empty($cpg_options['sql_user']) ? $cpg_options['sql_user'] : "sa";
		$password = !empty($cpg_options['sql_password']) ? $cpg_options['sql_password'] : "";
		$database = !empty($cpg_options['sql_database']) ? $cpg_options['sql_database'] : "";
		$connectionInfo = array("Database"=>$database, 'ReturnDatesAsStrings'=> true, "UID"=>$userName, "PWD"=>$password, "TrustServerCertificate"=>true);
		$conn = sqlsrv_connect($serverName, $connectionInfo);
		if ($conn === false) {
		   echo "Could not connect.\n";
		   die(print_r(sqlsrv_errors(), true));
		}
		$this->conn = $conn;

		return $conn;
	} # end of open_connection;

	function close_connection( $conn = null ) {
		if (empty($conn)) {
			$conn = $this->conn;
		}
		sqlsrv_close($conn);
	} # end of close_connection

	function get_table_row_count( $tablename ) {
		$sql = 'select count(*) as count from ' . $tablename;
		$rowcount = -1;

		$params = array();

		if (empty($conn) && empty($this->conn)) {
			$conn = $this->open_connection();
		} elseif (empty($conn)) {
			$conn = $this->conn;
		}

		if ($stmt = sqlsrv_prepare($conn, $sql, $params)) {
			#echo "Statement prepared.<br><br>\n";  
		} else {  
			echo "Statement could not be prepared.\n";  
			die(print_r(sqlsrv_errors(), true));  
		} 

		if( sqlsrv_execute( $stmt ) === false ) {
			die( print_r( sqlsrv_errors(), true));
		} else {
			$result = sqlsrv_fetch_array($stmt);
			if (is_array($result)) {
				if (!empty($result['count'])) {
					$rowcount = $result['count'];
				} elseif (!empty($result[0])) {
					$rowcount = $result[0];
				}
			}
		}

		sqlsrv_free_stmt($stmt);

		return $rowcount;

	}

	function run_query( $sql, $params=array(), $conn=null) {
		$id = 0;
		sqlsrv_configure('WarningsReturnAsErrors',0);

		if (empty($conn) && empty($this->conn)) {
			$conn = $this->open_connection();
		} elseif (empty($conn)) {
			$conn = $this->conn;
		}

		if ($stmt = sqlsrv_prepare($conn, $sql, $params)) {
			#echo "Statement prepared.<br><br>\n";  
		} else {  
			echo "Statement could not be prepared.\n";  
			die(print_r(sqlsrv_errors(), true));  
		} 

		if( sqlsrv_execute( $stmt ) === false ) {
			die( print_r( sqlsrv_errors(), true));
		} else {
			$result = sqlsrv_fetch_array($stmt);
			#print_r($result);
			if (is_array($result)) {
				if (!empty($result['ReturnIndex'])) {
					$id = $result['ReturnIndex'];
				} elseif (!empty($result[0])) {
					$id = $result[0];
				}
			}
		}

		sqlsrv_free_stmt($stmt);

		return $id;
	} # end of run_query

	function get_data_query( $sql, $params=array(), $conn=null) {
		$id = 0;
		$result = array();

		sqlsrv_configure('WarningsReturnAsErrors',0);

		if (empty($conn) && empty($this->conn)) {
			$conn = $this->open_connection();
		} elseif (empty($conn)) {
			$conn = $this->conn;
		}

		if ($stmt = sqlsrv_prepare($conn, $sql, $params)) {
			#echo "Statement prepared.<br><br>\n";  
		} else {  
			echo "Statement could not be prepared.\n";  
			die(print_r(sqlsrv_errors(), true));  
		} 

		if( sqlsrv_execute( $stmt ) === false ) {
			die( print_r( sqlsrv_errors(), true));
		} else {
			while ($row = sqlsrv_fetch_array($stmt, SQLSRV_FETCH_ASSOC  )) {
				$result[] = $row;
			#	print_r($row);
			}
		}

		sqlsrv_free_stmt($stmt);

		return $result;
	} # end of get_data_query

	function get_opt1_params() {
		$opts = array(
		'id' => null,
		'DocEntry' => null,
        'DocNum' => null,
        'Canceled' => null,
        'UserSign' => null,
        'Transfered' => null,
        'Status' => null,
        'CreateDate' => null,
        'CreateTime' => null,
        'UpdateDate' => null,
        'UpdateTime' => null,
        'DataSource' => null,
        'RequestStatus' => null, 
        'Creator' => null, 
        'Remark'  => null,
        'U_ItemCode' => null,
        'U_Description' => null,
        'U_Status' => null,
        'U_Revision' => null,
        'U_RevisionName' => null,
        'U_Quantity' => null,
        'U_ActualQty' => null,
        'U_InventoryUoM' => null,
        'U_RequiredDate' => null,
        'U_RequiredTime' => null,
        'U_PlannedStartDate' => null,
        'U_PlannedEndDate' => null,
        'U_Priority' => null,
        'U_Warehouse' => null,
        'U_Factor' => null,
        'U_BOMCode' => null,
        'U_AbsManTime' => null,
        'U_PlannedStartTime' => null,
        'U_PlannedEndTime' => null,
        'U_BatchSize' => null,
        'U_DistNumber' => null,
        'U_ReworkQty' => null,
        'U_TotalQty' => null,
        'U_Yield' => null,
        'U_ActualYield' => null,
        'U_ItemYield' => null,
        'U_CoproductYield' => null,
        'U_ScrapYield' => null,
        'U_Instructions' => null,
        'U_TechInstructions' => null,
        'U_FixedCost' => null,
        'U_VariableCost' => null,
        'U_ActCost' => null,
        'U_ItemCost' => null,
        'U_ItemResources' => null,
        'U_CostTotal' => null,
        'U_IsRescheduled' => null,
        'U_RecommendationStartTime' => null,
        'U_RecommendationEndTime' => null,
        'U_RecommendationStartDate' => null,
        'U_RecommendationEndDate' => null,
        'Last_Refresh' => null,
		'active' => 1,
		'deleted' => 0,
		'created' => NULL,
		'modified' => NULL);

		return $opts;
	} # end of get_opt1_params

	function get_opt2_params() {
		$opts = array(
	'id' => null,
    'bid' => 0,
   'update_code' => NULL,
    'update_time' =>NULL,
    'DocEntry' => NULL,
    'LineId' => NULL,
    'VisOrder' => NULL,
    'Object' => NULL,
    'LogInst' => NULL,
    'U_LineNum' => NULL,
    'U_MorCode' => NULL,
    'U_RevCode' => NULL,
    'U_RgtCode' => NULL,
    'U_RtgOprCode' => NULL,
    'U_OprCode' => NULL,
    'U_RtgOprRscCode' => NULL,
    'U_QueueTime' => NULL,
    'U_QTimeCost' => NULL,
    'U_QFixedCost' => NULL,
    'U_QVariableCost' => NULL,
    'U_SetupTime' => NULL,
    'U_STimeCost' => NULL,
    'U_SFixedCost' => NULL,
    'U_SVariableCost' => NULL,
    'U_RunTime' => NULL,
    'U_RTimeCost' => NULL,
    'U_RFixedCost' => NULL,
    'U_RVariableCost' => NULL,
    'U_StockTime' => NULL,
    'U_LTimeCost' => NULL,
    'U_LFixedCost' => NULL,
    'U_LVariableCost' => NULL,
    'U_RunRate' => NULL,
    'U_StockRate' => NULL,
    'U_SetupRate' => NULL,
    'U_QueueRate' => NULL,
    'U_Remarks'=> NULL,
    'U_RscCode'=> NULL,
    'U_HasCycles' => NULL,
    'U_NrOfResources' => NULL,
    'U_CycleCap' => NULL,
    'U_RunTotal' => NULL,
    'U_SetupTotal' => NULL,
    'U_QueueTotal' => NULL,
    'U_StockTotal' => NULL,
    'U_ActRun' => NULL,
    'U_ActSetup' => NULL,
    'U_ActQueue' => NULL,
    'U_ActStock' => NULL,
    'U_ActCost' => NULL,
    'U_RunStartDate' => NULL,
    'U_RunStartTime' => NULL,
    'U_SetupStartDate' => NULL,
    'U_SetupStartTime' => NULL,
    'U_QueueStartDate' => NULL,
    'U_QueueStartTime' => NULL,
    'U_StockStartDate' => NULL,
    'U_StockStartTime' => NULL,
    'U_TotalSeconds' => NULL,
    'U_RunEndDate' => NULL,
    'U_RunEndTime' => NULL,
    'U_SetupEndDate' => NULL,
    'U_SetupEndTime' => NULL,
    'U_QueueEndDate' => NULL,
    'U_QueueEndTime' => NULL,
    'U_StockEndDate' => NULL,
    'U_StockEndTime' => NULL,
    'U_RscType' => NULL,
    'U_MachineCode' => NULL,
    'U_IssueType' => NULL,
    'U_Active' => NULL,
    'U_BaseRscLine' => NULL,
    'U_Qty' => NULL,
    'U_PlannedQty' => NULL,
    'U_Project' => NULL,
    'U_OcrCode' => NULL,
    'U_OcrCode2' => NULL,
    'U_OcrCode3' => NULL,
    'U_OcrCode4' => NULL,
    'U_OcrCode5' => NULL,
    'U_Freeze' => NULL,
    'Last_Refresh' => NULL,
    'active' => 1,
    'deleted' => 0,
    'created' => NULL,
    'modified' => NULL);

		return $opts;
	} # end of get_opt2_params

	function truncate_table( $tablename ) {
		echo "truncate $table" ;
		$sql = 'truncate table ' . $tablename;
		$rowcount = -1;

		$params = array();

		if (empty($conn) && empty($this->conn)) {
			$conn = $this->open_connection();
		} elseif (empty($conn)) {
			$conn = $this->conn;
		}

		if ($stmt = sqlsrv_prepare($conn, $sql, $params)) {
			#echo "Statement prepared.<br><br>\n";  
		} else {  
			echo "Statement could not be prepared.\n";  
			die(print_r(sqlsrv_errors(), true));  
		} 

		if( sqlsrv_execute( $stmt ) === false ) {
			die( print_r( sqlsrv_errors(), true));
		} else {
			$result = $this->get_table_row_count($tablename);
			if (is_array($result)) {
				if (!empty($result['count'])) {
					$rowcount = $result['count'];
				} elseif (!empty($result[0])) {
					$rowcount = $result[0];
				}
			}
		}

		sqlsrv_free_stmt($stmt);

		return $rowcount;

	}

	function insert_table1_row($row){
		global $cpg_options;

		$stored_proc = !empty($cpg_options['sql_output_stored_proc1']) ?  $cpg_options['sql_output_stored_proc1'] : 'InsertOrUpdate_OMOR';

		$conn = $this->open_connection() ;


		$opts = $this->get_opt1_params();
		unset($opts['id']);
		unset($opts['bid']);
		unset($opts['update_code']);
		unset($opts['update_time']);
		unset($opts['active']);
		unset($opts['deleted']);
		unset($opts['created']);
		unset($opts['modified']);

#print_r($opts);

		$queries = array_fill( 0, count($opts), '?');
		foreach ($row as $key=>$value) {
			if (array_key_exists($key, $opts)) {
				if ($value=='NULL') {
					$value = null;
				} elseif( preg_match("/([0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9])/", $value) ) {
					$value .= "T00:00:00";
				}
				$opts[$key] = $value;
			}
		}
#print_r($opts);

		$params = array_values($opts);
		if (!empty($cpg_options['superdebugging'])){
			echo '<pre>';
			print_r($params);
			echo '</pre>';
		}

		$sql = "{call " . $stored_proc. "(" . implode(", ", $queries) . ")}";

		$result = $this->run_query($sql, $params) ;
#print_r($sql);
		$this->close_connection();
	}

	function insert_table2_row( $row) { 
		global $cpg_options;

		$stored_proc = !empty($cpg_options['sql_output_stored_proc2']) ?  $cpg_options['sql_output_stored_proc2'] : 'InsertOrUpdate_tMOR16';

		$conn = $this->open_connection() ;

		$opts = $this->get_opt2_params();
		unset($opts['id']);
		unset($opts['bid']);
		unset($opts['update_code']);
		unset($opts['update_time']);
		unset($opts['active']);
		unset($opts['deleted']);
		unset($opts['created']);
		unset($opts['modified']);


		$queries = array_fill( 0, count($opts), '?');
		foreach ($row as $key=>$value) {
			if (array_key_exists($key, $opts)) {
				if ($value=='NULL') {
					$value = null;
				} elseif( preg_match("/([0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9])/", $value) ) {
					$value .= "T00:00:00";
					#echo $value;
				}
				$opts[$key] = $value;
			}
		}
#print_r($opts);

		$params = array_values($opts);
		if (!empty($cpg_options['superdebugging'])){
			echo '<pre>';
			print_r($params);
			echo '</pre>';
		}

		$sql = "{call ".$stored_proc."(" . implode(", ", $queries) . ")}";
		#$sql = "{call TesttMOR16_input(" . implode(", ", $queries) . ")}";

		$result = $this->run_query($sql, $params) ;
		$this->close_connection();
	}

} # end of dbSQL_Class


class ImportExportClass {

	var $table_list = array();
	var $variables_list = array();

	function __construct() {

		$this->table_list[] = 'tCT_PF_MOR16';
		$this->variables_list['tCT_PF_MOR16'] = 'DocEntry, LineId';

	#	$this->table_list[] = 'tCT_PF_OMOR';
	#	$this->variables_list['tCT_PF_OMOR'] = 'DocEntry';


	}

	function ExportChanges() {

		echo '<div>Export Changes Spreadsheet to SQL Server</div>';

		$start = microtime(true);
     
  		error_reporting(-1)	 ;	
		ini_set("display_errors", 1); 
		set_time_limit(0);

		$import1 = GetModifiedBatchData();
		if (empty($import1)) {
			echo '<div class="import-warning-message">There is nothing to export</div>';
			return false;
		}

		$batchsize = count($import1);
		$exp = new dbSQL_Class;
		foreach ($import1 as $row) {
			#print_r($row);
			$exp->insert_table2_row( $row) ;
		}
		
		$end = microtime(true);

		echo "<div>No of rows exported = $batchsize</div>";

		echo "<div id=\"posdiag\">Memory=" . memory_get_usage()/1000000 . "</div>";
		echo '<div class="resource-used">Overall processing time = ' . number_format(($end - $start), 2) . ' seconds</div>';


	}

	function importRemoteSQL() {

		if (empty($this->table_list)) {
			echo "No import tables specified";
			return false;
		}

		$batch_in_progress = get_option('tMOR' . "_import_loop", false );
		if ($batch_in_progress) {
			echo '<div>Batch is already running by another user...please wait a few minutes</div>';
			return false;
		}
		update_option('tMOR' . "_import_loop", true );


		$start = microtime(true);


		truncate_import_tables();

		foreach ($this->table_list as $importtable) {
			$tablesize = $this->GetTableSize($importtable);

			$batchsize = 1000;
			$db = new dbSQL_Class;

			$batchcount  = 0;

			for ($i=0; $i<=$tablesize; $i=$i+$batchsize) {

				$sql = "SELECT  ROW_NUMBER() OVER (Order by " . $this->variables_list[$importtable] . ") AS RowNumber, * FROM " . $importtable ; 
				$sql .= " order by " . $this->variables_list[$importtable] . " offset $i ROWS FETCH NEXT $batchsize rows only";

				$results = $db->get_data_query( $sql) ;

				$batchcount = $batchcount + count($results);

				$headers = array_keys(reset($results));
				$newheaders = array();
				foreach ($headers as $key=>$header) {
					$newheaders[$header] = $header;
				}

				process_tMOR16( $results, $newheaders ) ;

				#echo "<div>$sql</div>";
#echo '<pre>';
#				print_r($results);
#echo '</pre>';

			}

			update_option('tMOR' . "_import_loop", false );


			$end = microtime(true);

			echo "<div>Table rows = $tablesize.  No of rows retrieved = $batchcount</div>";

			echo '<div class="resource-used">Overall processing time = ' . number_format(($end - $start), 2) . ' seconds</div>';
			echo "<div id=\"posdiag\">memory=" . memory_get_usage()/1000000 . "</div>";


		}

		#GetSQLImportTable2();
	}

	function GetTableSize( $tablename='') {
		$db = new dbSQL_Class;

		$rowcount = $db->get_table_row_count( $tablename ) ;
		return $rowcount;
	}
/*
SELECT  ROW_NUMBER() OVER (Order by DocEntry, LineId) AS RowNumber, *
FROM tCT_PF_MOR16 
order by DocEntry, LineId
offset 100 ROWS
FETCH NEXT 1000 rows only
*/
}


?>
