<?php

/**

 * @package CPGantt

 */

/*

Plugin Name: CPGantt

Plugin URI: http://www.nufocus.co.uk/plugins/cpgantt/?return=true

Description: NuFocus Gantt Chart Planning 

Version: 1.1.12

Author: David Coates

Author URI: http://www.nufocus.co.uk/

License: GPLv2 or later

*/



/*

This program is not free software; you can only use this plugin with written permission for the copyright owner.

*/


if (!defined('WP_CPG_MANAGEMENT_PERMISSION')){//This will allow the user to define custom capability for this constant in wp-config file
    define('WP_CPG_MANAGEMENT_PERMISSION', 'manage_options');
}

global $cpg_options;
$cpg_options = get_option('cpg_settings');

global $cpg_files_root;
$cpg_files_root = 'custpharma/';


global $cpg_db_tables;
$cpg_db_tables = array( 

						// first 2 tables are not currently used
                        'input_transfer' => 'z_input_transfer',
                        'input_sample' => 'z_input_sample',

						'diagnostics' => 'z_diagnostics', 

                        
                        'import_table1' => 'z_tOMOR',
                        'import_table2' => 'z_tMOR16',
						'batch_output' => 'z_tMOR16_output',

                        'import_tableA' => 'z_tOMOR',   # this may be overridden in init if test mode
                        'import_tableB' => 'z_tMOR16',  # ditto
						'WrkStatOrder' => 'z_WrkStatOrder',

					);


function cpg_plugin_dir_path() {
	return plugin_dir_path( __FILE__ );
}

function cpg_plugin_url() {
	return plugins_url() . '/cpgantt';
}


include(cpg_plugin_dir_path() . "classes/cpg_client_classes.php");
include(cpg_plugin_dir_path() . "functions/cpg_function_library.php");
include(cpg_plugin_dir_path() . "functions/cpg_hook_library.php");
include(cpg_plugin_dir_path() . "dashboard_handler.php");
#include(cpg_plugin_dir_path() . "/classes/excel_library_functions.php");
include(cpg_plugin_dir_path() . "/classes/excel_library_classes.php");
include(cpg_plugin_dir_path() . "/classes/cpg_display_classes.php");
include(cpg_plugin_dir_path() . "/classes/personalized_login_handler.php");
include(cpg_plugin_dir_path() . "/classes/sql_server_classes.php");


if(!function_exists('makepath')) {
	function makepath($path)  {
		if(@mkdir($path) or file_exists($path)) return true;
		return (makepath(dirname($path)) and mkdir($path));
	}
}


function cpg_get_document_root_folder() {
	global $cpg_files_root;

	return $cpg_files_root;
}
function cpg_get_document_path() {
	global $cpg_files_root;

	// later we can make this an options setting
	$docPath = ABSPATH . 'wp-content/uploads/' . rtrim($cpg_files_root, "/") . "/";

	// this will make the path if it does not exist
	makepath($docPath);

	return $docPath;
}

function cpg_get_document_url() {
	global $cpg_files_root;

	$url = home_url() . '/wp-content/uploads/'  . rtrim($cpg_files_root, "/") . "/";

	return $url;
}
function cpg_get_document_relative_url() {
	global $cpg_files_root;

	$url = '/wp-content/uploads/'  . rtrim($cpg_files_root, "/") . "/";

	return $url;
}


###########################################################

add_shortcode('cpg_main_dashboard', 'cpg_main_dashboard');
function cpg_main_dashboard( $atts, $content = "" ) {
    
    ob_start();
    
    run_dashboard();
    
    
    $content = ob_get_clean();
    
    return $content;
}


class cpGantt {

    var $cpg_main_menu_slug = 'cpg-portal-main';

    var $cpg_transfer_menu_slug = 'cpg-transfer-data';

    var $cpg_buildbatch_menu_slug = 'cpg-build-batch';

	var $cpg_testfunction_menu_slug = 'cpg-test-function';

	var $cpg_testbarfunction_menu_slug = 'cpg-test-bar-function';

	var $cpg_initSQLDBfunction_menu_slug = 'cpg-init-sql-db';


    function __construct() {
		global $personalize_login_pages_plugin;

 	    add_action('admin_menu', array($this, 'add_menus_link') );

	    add_action('init', array($this, 'cpg_init') );

		#add_action( 'wp_footer', array($this, 'diagnostic_panel') );

		#add_action('in_admin_footer', array($this, 'diagnostic_panel') );


		add_action( 'admin_notices', array($this, 'custom_error_notice') );

		#add_action('wp_dashboard_setup', array($this, 'custom_dashboard_widgets'));

		date_default_timezone_set('Europe/London');

    }

    

    function cpg_init() {
		global $cpg_options;
		global $cpg_db_tables;
		global $nuf_db_tables;

		if (!empty($cpg_options['importtestmode'])) {
			$cpg_db_tables['import_tableA'] = 'a_tOMOR';
			$cpg_db_tables['import_tableB'] = 'a_tMOR16';
			$cpg_db_tables['batch_output'] = 'a_tMOR16_output';

			$nuf_db_tables = $cpg_db_tables;  // this needs to be updated for the client classes module

		}
 		#print_r($cpg_db_tables); 
  
 		wp_enqueue_script( 'cpg_ui_js', 'https://code.jquery.com/ui/1.14.0/jquery-ui.js', array(), null, array('strategy'  => 'defer',)  );
 		wp_enqueue_script('cpg_jquery', 'https://code.jquery.com/jquery-3.7.1.js', array(),null, array('strategy'  => 'defer',) );
 		wp_enqueue_script('cpg_jqueryui', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.1/jquery-ui.min.js', array(),null, array('strategy'  => 'defer',) );
		wp_enqueue_script( 'cpg_main_js', cpg_plugin_url() . '/js/cpg_main.js', array(), null, array('strategy'  => 'defer',)  );
		wp_localize_script( 'cpg_main_js', 'ajax_object',
			    array( 'cpg_ajax_url' => cpg_plugin_url(). '/handle_ajax_page.php',  'cpg_admin_ajax' => admin_url( 'admin-ajax.php' ),  'we_value' => 7890, 'nonce' => wp_create_nonce('ajax-nonce') ) );
#		wp_enqueue_script( 'jquery_ui_widget_js', cpg_plugin_url() . '/js/jquery_ui_widget.js', array(), '', true );

       
		wp_register_style('cpg_style', cpg_plugin_url() . '/css/cpg_styles.css', array(), null, 'all' );
		wp_enqueue_style('cpg_style');

    }

    

    function add_menus_link() {

 		$enable_menus = false;

		$user = wp_get_current_user();

		if ($user->ID <=2) {

			$enable_menus = true;

		}


		if ($enable_menus) { 

		add_menu_page(__('Custom Pharma Gantt', 'BLD'), __('Custom Pharma Gantt', 'BLD'), WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_main_menu_slug , 'cpg_main_handler', $menu_icon_url, 4);

	    add_submenu_page($this->cpg_main_menu_slug, __('Transfer Data', 'BLD'),  __('Transfer Data', 'BLD') , WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_transfer_menu_slug, 'cpg_input_transfer_handler');



	    add_submenu_page($this->cpg_main_menu_slug, __('Build Batch Block', 'BLD'),  __('Build Batch Block', 'BLD') , WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_buildbatch_menu_slug, 'cpg_build_batch_handler');

	
	    add_submenu_page($this->cpg_main_menu_slug, __('Test Function', 'BLD'),  __('Test Function', 'BLD') , WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_testfunction_menu_slug, 'cpg_test_function');

	    add_submenu_page($this->cpg_main_menu_slug, __('Bar Function', 'BLD'),  __('Bar Function', 'BLD') , WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_testbarfunction_menu_slug, 'cpg_test_bar_function');


#	    add_submenu_page($this->cpg_main_menu_slug, __('All Portfolios', 'BLD'),  __('All Portfolios', 'BLD') , WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_transfer_menu_slug, 'cpg_all_portfolios_handler');

			add_submenu_page($this->cpg_main_menu_slug, __('Initialise SQL DB', 'BLD'),  __('Initialise SQL DB', 'BLD') , WP_CPG_MANAGEMENT_PERMISSION, $this->cpg_initSQLDBfunction_menu_slug, 'HandleSQLSetupProcess');


		}      

    }
    
    function custom_error_notice() {
        
        echo '<div><a href="/dashboard/">Dashboard</a></div>';
    }

    

    

} # end of cpGantt

$cpGantt = new cpGantt;



function cpg_test_bar_function() {

	$gantt = new DisplayGantt();
	echo $gantt->RenderBarOutput();

}


function cpg_test_function(){

#	$gantt = new DisplayGantt();
#	echo $gantt->RenderOutput();

return false;



}


function cpg_main_handler() {

    

}



function cpg_input_transfer_handler() {

    echo '<h1>Transfer Data</h1>';

	import_spreadsheets();

	#  importTransferList();

}

function cpg_build_batch_handler() {
	global $offsets;

    echo '<h1>Build Work Centre Conflict Chart</h1>';
	
	error_reporting(-1);
	ini_set("display_errors",1);

    

    $batch_code = '200539';

    
	$opts = array();

   # $opts = array( 'Batch_Number' => $batch_code );

  #  $list = GetTransferList( $opts); 

    
    $list = LoadBatchList();

	
	

    $batches = array();

    foreach ($list as $row) {
		$row = offsetProcessTime( $row ) ;
		if (!array_key_exists($row['Batch_Number'], $batches)) {
			#print_r($row);
			$batch = new BatchClass;
			$batch->MOLineId = $row['MOLineId'];
			$batch->Batch_Number = $row['Batch_Number'];
			$batch->DocNum = $row['DocNum'];
			$batch->ItemCode = $row['ItemCode'];
			$batch->ItemDescription = $row['ItemDescription'];
			$batch->starttime = getBatchTime($row['SetupStartDate'], $row['SetupStartTime'] );
			$batch->endtime = getBatchTime($row['RunEndDate'], $row['RunEndTime'] );
			$batches[$row['Batch_Number']] = $batch;
		}
		$batch = $batches[$row['Batch_Number']];
		$starttime = getBatchTime($row['SetupStartDate'], $row['SetupStartTime'] );
		if ($starttime<$batch->starttime) {
			$batch->starttime = $starttime;
		}
		$endtime = getBatchTime($row['RunEndDate'], $row['RunEndTime'] );
		if ($endtime>$batch->endtime) {
			$batch->endtime = $endtime;
		}

	#	$process = new BatchItemClass($row['id']);
		$process = LoadBatchItem( $row );

		$batch->processes[$row['MOLineId']] = $process;

    }
	

    echo '<pre>';

   # print_r($batches);

    echo '</pre>';

	

    foreach ($batches as $key=>$batch) {

	#	$endtime = $batch->RecalculateBatch();
	#	print_r($endtime);
    }

	#$batches = array_slice($batches, 0, 2);
	
	BuildResourceStructure( $batches );



} # end of cpg_build_batch_handler
	
function BuildResourceStructure( $batches ) {
    echo '<pre>';
   # print_r(reset($batches));
    echo '</pre>';

	$resources = array();

	foreach ($batches as $batch) {

		foreach ($batch->processes as $process) {
		#	echo "<br>" .  $process->WorkCentre;
			$t = array();
			$t['start'] = $process->starttime;
			$t['end'] = $process->endtime;
			$t['process'] = $process;
			$resources[$process->WorkCentre][$process->Batch_Number] = $t;
		}

	}

    echo '<pre>';
    #print_r($resources);
    echo '</pre>';
	echo show_resource_gantt($resources);
}

function show_resource_gantt($resources) {
	
	require_once(__DIR__ . '/ganttchartphp/ganttloader.php');

	ob_start();
	$opts = array();
   # $batch_code = '200539';
   # $opts = array( 'Batch_Number' => $batch_code );
  #  $list = GetTransferList( $opts); 
#print_r($list);

	$array_data = array();
	foreach ($resources as $key=>$row) {
		print_r($row);
		$t = array();
		$array_data[$key]['label'] = $key;  #$row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
		#$t['series'] = array();
		$it = array();

		$row = setConflicts( $row ) ;

		foreach ($row as $key2=>$item) {
			#$start = getBatchTime($row['start'], $row['SetupStartTime']);
			#$end = getBatchTime($row['RunEndDate'], $row['RunEndTime']);
			$conflict = !empty($item['conflict']) ? $item['conflict'] : 0;
			switch ($conflict) {
				case 1:
					$color = '#ff0000';
					break;
				case -1:
					$color = '#ec990b'; ;
					break;
				default: 
					$color = '#20bc5d';
			}

			$i = array('label' => $key2, 'allocations' => array( Array
                                        (
                                            'label' => $item['process']->ItemCode,
                                            'start' => $item['start']->format("Y-m-d H:i:s"),
                                            'end' => $item['end']->format("Y-m-d H:i:s"),
                                            'description' => $item['start']->format("Y-m-d H:i:s") . ' ' . $item['end']->format("Y-m-d H:i:s") . ' '. $item['process']->ItemDescription,
                                            'color' => $color,
                                        ) ) ) ;
			$it[]  = $i;
		}
		$array_data[$key]['series'] = $it;
	}


/*
	foreach ($array_data as $key=>$process) {

		#$batch_code = $key;
		#$opts = array( 'Batch_Number' => $batch_code );
		#$list = GetTransferList( $opts); 
		$t = array();
		foreach ($list as $row){
			#$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
			$t[] = array('label' => $row['WorkCentre'], 'allocations' => array( link_allocation($row) ) ) ;
		}
		$array_data[$key]['series'] = $t;
	}
*/
echo "<pre>";
#print_r($array_data);
echo "</pre>";

/*
	#print_r($array_data);
	#$array_data[0]['label'] = 'Ibuprofen & Codeine Tabs';
	#$array_data[0]['series'][] = array( 'label' => 'Sub-Activitie 1',
 #                           'allocations' => Array
  #                              (
                                #   Array
                                #        (
                                #            'label' => 'Task 1',
                                 #           'start' => '2013-09-15',
                                #            'end' => '2013-09-29',
                                 #           'description' => 'Description x',
                                 ##           'color' => '#00ff00',
                                  #      )
								#);
#						);

#

	#$t = $array_data[0]['series'][0]['allocations'][2];
	#unset($array_data[0]['series'][0]['allocations'][2]);
	#$array_data[0]['series'][] = array( 'label' => 'xxxx', 'allocations' => array( $t) );
	print_r($array_data);
#	$array_legend_data[2]['color'] = '#0000ff';

	#print_r($array_legend_data);
*/


	$defaultwidth = 100;
	if (!empty($_GET['width'])) {
		$defaultwidth = intval($_GET['width']);
	}
	$zoom = 0;
	if (!empty($_GET['zoom'])) {
		$zoom = intval($_GET['zoom']);
	}



echo '<div><input id="reverse" type="button" value="Reverse">&nbsp;&nbsp;<input id="advance" type="button" value="Advance"><input id="zoom" type="button" value="Zoom"></div>';
?>
<script>
jQuery(document).ready(function() {

	var widthscalar = <?php echo $defaultwidth; ?>;
	var startzoom = <?php echo $zoom; ?>;

	var offsetStep = 1200;

	if (startzoom)
	{
		jQuery(".gchart").css("zoom", '50%');
	}


	jQuery("#advance").on("click", function() {
		var leftmargin = jQuery(".gchart-sc header").css("margin-left");

		var margin = parseInt(leftmargin);
		margin = margin - offsetStep;

		jQuery(".gchart-sc header").css("margin-left", margin + 'px');
	});


	jQuery("#reverse").on("click", function() {
		var leftmargin = jQuery(".gchart-sc header").css("margin-left");

		var margin = parseInt(leftmargin);
		margin = margin + offsetStep;

		jQuery(".gchart-sc header").css("margin-left", margin + 'px');
	});

	jQuery("#zoom").on("click", function() {
		var zoomsetting = jQuery(".gchart").css("zoom");

		var zoom = parseFloat(zoomsetting);

		if (zoom==1)
		{
			zoom = 50;
		} else {
			zoom = 100;
		}

		jQuery(".gchart").css("zoom", zoom + '%');
	});

});
</script>
<?php

	$gantt_graph = new GanttChart\GanttChart( 'pt_BR' );


	$gantt_graph->setCellWidth($defaultwidth);

	$gantt_graph->setData( $array_data )
            #->setDataLegend($array_legend_data)
            ->render();
	
	 batch_form();

    $html = ob_get_clean();
    return $html;
	
}



function cpg_all_portfolios_handler() {

	require_once(__DIR__ . '/ganttchartphp/ganttloader.php');


	#$array_data = include __DIR__ . '/ganttchartphp/tests/array_data.php';
	#$array_legend_data = include __DIR__ . '/ganttchartphp/tests/array_legend_data.php';

	ob_start();
	$opts = array();
    $batch_code = '200539';
    $opts = array( 'Batch_Number' => $batch_code );
    $list = GetTransferList( $opts); 
#print_r($list);

	$array_data = array();
	foreach ($list as $row) {
		$t = array();
		$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
		$t['series'] = array();
		$array_data[$row['Batch_Number']] = $t;
	}



	foreach ($array_data as $key=>$process) {

		$batch_code = $key;
		$opts = array( 'Batch_Number' => $batch_code );
		$list = GetTransferList( $opts); 
		$t = array();
		foreach ($list as $row){
			#$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
			$t[] = array('label' => $row['WorkCentre'], 'allocations' => array( link_allocation($row) ) ) ;
		}
		$array_data[$key]['series'] = $t;
	}
	#print_r($array_data);
	#$array_data[0]['label'] = 'Ibuprofen & Codeine Tabs';
	#$array_data[0]['series'][] = array( 'label' => 'Sub-Activitie 1',
 #                           'allocations' => Array
  #                              (
                                #   Array
                                #        (
                                #            'label' => 'Task 1',
                                 #           'start' => '2013-09-15',
                                #            'end' => '2013-09-29',
                                 #           'description' => 'Description x',
                                 ##           'color' => '#00ff00',
                                  #      )
								#);
#						);

#

	#$t = $array_data[0]['series'][0]['allocations'][2];
	#unset($array_data[0]['series'][0]['allocations'][2]);
	#$array_data[0]['series'][] = array( 'label' => 'xxxx', 'allocations' => array( $t) );
#	print_r($array_data);
#	$array_legend_data[2]['color'] = '#0000ff';

	#print_r($array_legend_data);

	$gantt_graph = new GanttChart\GanttChart( 'pt_BR' );

	$gantt_graph->setCellWidth(100);

	$gantt_graph->setData( $array_data )
            #->setDataLegend($array_legend_data)
            ->render();
	
    $html = ob_get_clean();
    return $html;
    

}







class ResourceBlock {

    

    var $startime ;

    var $totalDuration = '';

    

    var $setupTime = '';

    var $reducedSetupTime = '';

    

    var $processTime = '';

    

    var $cleaningTime = '';

    

    var $name = '';

    var $processParent = '';

    

    var $cleaning = 0;

    var $repeat = 0;

    

    function __construct( $params = array() ) {

        

        if (!empty($params)) {

            foreach ($params as $key=>$value) {

                $this->{$key} = $value;

            }

            

        }

    }

    

    function TotalTime() {

        $t = $this->setupTime;

        if ($this->repeat){

            $t = $this->reducedSetupTime;

        }

        $t += $this->processTime;

        

        if ($this->cleaning) {

            $t += $this->cleaningTime;

        }

        

        

        $totalDuration = $t;

        return $t;

    }

    

    

}



class ProcessBlock {

    

    var $processList = array();

    

    function __construct() {

        

    }   

    

    function addResource() {

        

    }

 

}







add_shortcode("cp_test_gantt", "cp_test_gantt");

function cp_test_gantt() {

 
	error_reporting(-1);
	ini_set("display_errors", 1);
	

	require_once(__DIR__ . '/ganttchartphp/ganttloader.php');




	#$array_data = include __DIR__ . '/ganttchartphp/tests/array_data.php';
	#$array_legend_data = include __DIR__ . '/ganttchartphp/tests/array_legend_data.php';

	ob_start();
	$opts = array();
    $batch_code = '200539';
    $opts = array( 'Batch_Number' => $batch_code );
    $list = GetTransferList( $opts); 
#print_r($list);

	$array_data = array();
	foreach ($list as $row) {
		$t = array();
		$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
		$t['series'] = array();
		$array_data[$row['Batch_Number']] = $t;
	}



	foreach ($array_data as $key=>$process) {

		$batch_code = $key;
		$opts = array( 'Batch_Number' => $batch_code );
		$list = GetTransferList( $opts); 
		$t = array();
		foreach ($list as $row){
			#$t['label'] = $row['Batch_Number'] . ' ' . substr($row['ItemDescription'], 0, 10);
			$t[] = array('label' => $row['WorkCentre'], 'allocations' => array( link_allocation($row) ) ) ;
		}
		$array_data[$key]['series'] = $t;
	}
	#print_r($array_data);
	#$array_data[0]['label'] = 'Ibuprofen & Codeine Tabs';
	#$array_data[0]['series'][] = array( 'label' => 'Sub-Activitie 1',
 #                           'allocations' => Array
  #                              (
                                #   Array
                                #        (
                                #            'label' => 'Task 1',
                                 #           'start' => '2013-09-15',
                                #            'end' => '2013-09-29',
                                 #           'description' => 'Description x',
                                 ##           'color' => '#00ff00',
                                  #      )
								#);
#						);

#

	#$t = $array_data[0]['series'][0]['allocations'][2];
	#unset($array_data[0]['series'][0]['allocations'][2]);
	#$array_data[0]['series'][] = array( 'label' => 'xxxx', 'allocations' => array( $t) );
#	print_r($array_data);
#	$array_legend_data[2]['color'] = '#0000ff';

	#print_r($array_legend_data);

	$gantt_graph = new GanttChart\GanttChart( 'pt_BR' );

	$gantt_graph->setCellWidth(100);

	$gantt_graph->setData( $array_data )
            #->setDataLegend($array_legend_data)
            ->render();
	

    $html = ob_get_clean();

    return $html;

   

}


/**
 * Proper ob_end_flush() for all levels
 *
 * This replaces the WordPress `wp_ob_end_flush_all()` function
 * with a replacement that doesn't cause PHP notices.
 */
remove_action( 'shutdown', 'wp_ob_end_flush_all', 1 );
add_action( 'shutdown', function() {
   while ( @ob_end_flush() );
} );



/*
add_action( 'init', 'wpsites_remove_contributor_capabilities' );

function wpsites_remove_contributor_capabilities() {

	$contributor = get_role( 'cpgCustPTeam' );
	$admin_role_set = get_role( 'administrator' )->capabilities;

	$caps = $admin_role_set;
	#print_r($admin_role_set);

	$user = wp_get_current_user();

	if (empty($contributor)) {
		// the role doesn't seem to exist so add it for next time
		add_role( 'cpgCustPTeam', 'Custom Pharma Team', array('custp_admin' => 1) );
		return false;
	}

	// this list is definitely not for general team members
	$unwanted_caps = array(
		'switch_themes', 
		'edit_themes',
		'delete_themes',
		'update_themes',
		'install_themes',
		'edit_theme_options',
		'update_core',
		'activate_plugins',
		'edit_plugins',
		'update_plugins',
		'install_plugins',
		'delete_plugins',
	#	'delete_posts',
	#	'manage_options',
	);

	foreach ($admin_role_set as $key=>$val) {
	#	echo "<br>$key === $val ";
		if (!array_key_exists($key, $contributor->capabilities) && !in_array($key, $unwanted_caps) && !empty($val) ) {
		#	echo "  add key" . " --"  .$val;
			$contributor->add_cap( $key );
		} elseif ((array_key_exists($key, $contributor->capabilities) && in_array($key, $unwanted_caps)) || empty($val) ) {
		#	echo "  remove key"  . " --"  .$val;
			$contributor->remove_cap( $key );
		} else {
		#	echo " no change ";
		}
	}
	#print_r($user->roles);
	#print_r($contributor->capabilities);
	#print_r($admin_role_set);

 //[survey_admin] => 1 [switch_themes] => 1 [edit_themes] => 1 [activate_plugins] => 1 [edit_plugins] => 1 [edit_users] => 1 [edit_files] => 1 [manage_options] => 1 [moderate_comments] => 1 [manage_categories] => 1 [manage_links] => 1 [upload_files] => 1 [import] => 1 [unfiltered_html] => 1 [edit_posts] => 1 [edit_others_posts] => 1 [edit_published_posts] => 1 [publish_posts] => 1 [edit_pages] => 1 [read] => 1 [level_10] => 1 [level_9] => 1 [level_8] => 1 [level_7] => 1 [level_6] => 1 [level_5] => 1 [level_4] => 1 [level_3] => 1 [level_2] => 1 [level_1] => 1 [level_0] => 1 [edit_others_pages] => 1 [edit_published_pages] => 1 [publish_pages] => 1 [delete_pages] => 1 [delete_others_pages] => 1 [delete_published_pages] => 1 [delete_posts] => 1 [delete_others_posts] => 1 [delete_published_posts] => 1 [delete_private_posts] => 1 [edit_private_posts] => 1 [read_private_posts] => 1 [delete_private_pages] => 1 [edit_private_pages] => 1 [read_private_pages] => 1 [delete_users] => 1 [create_users] => 1 [unfiltered_upload] => 1 [edit_dashboard] => 1 [update_plugins] => 1 [delete_plugins] => 1 [install_plugins] => 1 [update_themes] => 1 [install_themes] => 1 [update_core] => 1 [list_users] => 1 [remove_users] => 1 [promote_users] => 1 [edit_theme_options] => 1 [delete_themes] => 1 [export] => 1 ) 

return false;

} # end of wpsites_remove_contributor_capabilities

add_action('edit_user_profile', 'cpg_check_set_user_metadata', 10, 1 );
add_action('show_user_profile', 'cpg_check_set_user_metadata', 10, 1 ); // editing your own profile

function cpg_check_set_user_metadata( $profileuser ) {

	print_r($profileuser) ;

	if (!empty($profileuser->ID)) {

		$roles = ( array ) $profileuser->roles;
		if (in_array( 'cpgCustPTeam', $roles)) {
			// only show custom fields for survey team members
			$surveyor_tag = get_user_meta( $profileuser->ID, 'doesSurveys', false) ;

			if (empty($surveyor_tag)) {
				// either tag does not exist or it is empty... we need it to appear in the page list so add
				// blank field to ensure placeholder exists
				update_user_meta( $profileuser->ID, 'doesSurveys', false);
			}

			$surveyor_tag = get_user_meta( $profileuser->ID, 'doesdelete', false) ;

			if (empty($surveyor_tag)) {
				// either tag does not exist or it is empty... we need it to appear in the page list so add
				// blank field to ensure placeholder exists
				update_user_meta( $profileuser->ID, 'doesdelete', false);
			}

			$surveyor_tag = get_user_meta( $profileuser->ID, 'initials', false) ;

			if (empty($surveyor_tag)) {
				// either tag does not exist or it is empty... we need it to appear in the page list so add
				// blank field to ensure placeholder exists
				update_user_meta( $profileuser->ID, 'initials', false);
			}

?>

<h2>Custom Pharma Team Roles</h2>
    <table class="form-table">
       <tr>
            <th><label for="user_birthday">Delete Records?</label></th>
            <td>
                <input
                    type="checkbox"
					value="yes"
                    <?php echo get_user_meta($profileuser->ID, 'doesdelete', true)!=false ? 'checked' : '' ; ?>
                    name="doesdelete"
                    id="doesdelete"
                >
                <span class="description">This user can delete records like Quotes?</span>
            </td>
        </tr>
        <tr>
            <th><label for="user_birthday">Initials (unique)?</label></th>
            <td>
                <input
                    type="text"
					value="<?php echo get_user_meta($profileuser->ID, 'initials', true) ; ?>"
                    name="initials"
                    id="initials"
                >
                <span class="description">Unique initials used to look up cost codes.</span>
            </td>
        </tr>
    </table>
<?php

		}
	}
} # end of cpg_check_set_user_metadata


function cpg_CheckAuthorisedUser($role = '') {
	global $personalize_login_pages_plugin;

	if ( is_user_logged_in() ) {

		$login_string = 'Logout';
		$link_url = wp_logout_url();

		$user = wp_get_current_user();
		$roles = ( array ) $user->roles;
		$caps = array_keys( $user->allcaps );
		if (in_array("manage_options", $caps) || in_array("cpgCustPTeam", $caps) || in_array("cpgCustomer", $caps) || in_array("custp_admin", $caps)) {
			if (empty($role)) {
				return true;
			} else {
				// we need to check against specific role
				if (in_array($role, $caps)) {
					return true;
				}
				return false;
			}
		} else {
			// logged in user, but does not have the correct permissions
			die("Sorry you don't have permission to access this page");
		} 
	} else {
		$login_string = 'Login';
		$link_url = '/login/';

		echo '<div style="max-width:500px;>';
		echo "login here?";

		$args = array(
        'echo' => true,
        'redirect' => '/dashboard/',
        'form_id' => 'loginform',
        'label_username' => __( 'Username or Email Address' ),
        'label_password' => __( 'Password' ),
        'label_remember' => __( 'Remember Me' ),
        'label_log_in' => __( 'Log In' ),
        'id_username' => 'user_login',
        'id_password' => 'user_pass',
        'id_remember' => 'rememberme',
        'id_submit' => 'wp-submit',
        'remember' => true,
        'value_username' => NULL,
        'value_remember' => false );

		echo $personalize_login_pages_plugin->render_login_form(array());
		#wp_login_form($args);
		echo "</div>";
		return false;
	}
}
*/


function cpg_add_options_link() {
	add_options_page('Custom Pharma Schedular Configuration', 'Custom Pharma Schedular Configuration', 'manage_options', 'cpg_options', 'cpg_options_page');	
}
add_action('admin_menu', 'cpg_add_options_link');

function cpg_register_settings() {
	// creates our settings in the options table
	register_setting('cpg_settings_group', 'cpg_settings');
}
add_action('admin_init', 'cpg_register_settings');


/*************************************
* Admin Page
*************************************/

function cpg_options_page() {
	global $cpg_options;

	ob_start();
?>
	<div class="wrap">
		<h2>Custom Pharma Schedular Configuration</h2>
 
		<form method="post" action="options.php">
 
			<?php settings_fields('cpg_settings_group'); ?>

			 
			<h4><?php _e('Custom Pharma Configuration Settings', 'cpg_domain'); ?></h4>

			<table width="50%" cellpadding="5" cellspacing="0" border="0">

	<!--		<tr><td><?php _e('Enable Customer 365 Importer?', 'cpg_domain'); ?></td><td><input id="cpg_settings[use_365_importer]" type="checkbox" name="cpg_settings[use_365_importer]" value="1" <?php checked("1", $cpg_options['use_365_importer']) ?> /></td></tr>-->

			<tr><td><strong><span>Import Marshalling Folder&nbsp;<br></span></strong></td><td><input id="cpg_settings[cpg_marshalling_folder]" type="textbox" name="cpg_settings[cpg_marshalling_folder]" size="40" value="<?php echo !empty($cpg_options['cpg_marshalling_folder']) ? $cpg_options['cpg_marshalling_folder'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

			<tr><td><strong><span>Standard Colour&nbsp;<br></span></strong></td><td><input id="cpg_settings[std_color]" type="textbox" name="cpg_settings[std_color]" size="40" value="<?php echo !empty($cpg_options['std_color']) ? $cpg_options['std_color'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

			<tr><td><strong><span>Conflict Colour&nbsp;<br></span></strong></td><td><input id="cpg_settings[conflict_color]" type="textbox" name="cpg_settings[conflict_color]" size="40" value="<?php echo !empty($cpg_options['conflict_color']) ? $cpg_options['conflict_color'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

			<tr><td><strong><span><?php _e('Import Test Mode?', 'cpg_domain'); ?></span></strong></td><td><input id="cpg_settings[importtestmode]" type="checkbox" name="cpg_settings[importtestmode]" value="1" <?php checked("1", isset($cpg_options['importtestmode']) ? $cpg_options['importtestmode'] : '') ?> /></td></tr>


			<tr><td><strong><span><?php _e('Super Admin Debugging?', 'cpg_domain'); ?></span></strong></td><td><input id="cpg_settings[superdebugging]" type="checkbox" name="cpg_settings[superdebugging]" value="1" <?php checked("1", isset($cpg_options['superdebugging']) ? $cpg_options['superdebugging'] : '') ?> /></td></tr>

			<tr><td><strong><span><?php _e('Show memory warnings?', 'cpg_domain'); ?></span></strong></td><td><input id="cpg_settings[memorywarning]" type="checkbox" name="cpg_settings[memorywarning]" value="1" <?php checked("1", isset($cpg_options['memorywarning']) ? $cpg_options['memorywarning'] : '') ?> /></td></tr>

			<tr><td><strong><span>SQL Server Host&nbsp;<br></span></strong></td><td><input id="cpg_settings[conflict_color]" type="textbox" name="cpg_settings[sql_host]" size="40" value="<?php echo !empty($cpg_options['sql_host']) ? $cpg_options['sql_host'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

			<tr><td><strong><span>SQL Database&nbsp;<br></span></strong></td><td><input id="cpg_settings[sql_database]" type="textbox" name="cpg_settings[sql_database]" size="40" value="<?php echo !empty($cpg_options['sql_database']) ? $cpg_options['sql_database'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

			<tr><td><strong><span>SQL Username&nbsp;<br></span></strong></td><td><input id="cpg_settings[sql_user]" type="textbox" name="cpg_settings[sql_user]" size="40" value="<?php echo !empty($cpg_options['sql_user']) ? $cpg_options['sql_user'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

			<tr><td><strong><span>SQL Password&nbsp;<br></span></strong></td><td><input id="cpg_settings[sql_password]" type="password" name="cpg_settings[sql_password]" size="40" value="<?php echo !empty($cpg_options['sql_password']) ? $cpg_options['sql_password'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

			<tr><td><strong><span>SQL DB Source Table 1&nbsp;<br></span></strong></td><td><input id="cpg_settings[sql_source_table1]" type="textbox" name="cpg_settings[sql_source_table1]" size="40" value="<?php echo !empty($cpg_options['sql_source_table1']) ? $cpg_options['sql_source_table1'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

			<tr><td><strong><span>SQL DB Source Table 2&nbsp;<br></span></strong></td><td><input id="cpg_settings[sql_source_table2]" type="textbox" name="cpg_settings[sql_source_table2]" size="40" value="<?php echo !empty($cpg_options['sql_source_table2']) ? $cpg_options['sql_source_table2'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

			<tr><td><strong><span>SQL DB Output StoredProc1&nbsp;<br></span></strong></td><td><input id="cpg_settings[sql_output_stored_proc1]" type="textbox" name="cpg_settings[sql_output_stored_proc1]" size="40" value="<?php echo !empty($cpg_options['sql_output_stored_proc1']) ? $cpg_options['sql_output_stored_proc1'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

			<tr><td><strong><span>SQL DB Output StoredProc2&nbsp;<br></span></strong></td><td><input id="cpg_settings[sql_output_stored_proc2]" type="textbox" name="cpg_settings[sql_output_stored_proc2]" size="40" value="<?php echo !empty($cpg_options['sql_output_stored_proc2']) ? $cpg_options['sql_output_stored_proc2'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>

	<!--		<tr><td><strong><span>Actual Installation Height Field ID&nbsp;</span></strong></td><td><input id="cpg_settings[actualinstall_customised_field]" type="textbox" name="cpg_settings[actualinstall_customised_field]" size="40" value="<?php echo !empty($cpg_options['actualinstall_customised_field']) ? $cpg_options['actualinstall_customised_field'] : ''; ?>" /><span style="color:grey;">&nbsp;</span></td></tr>




			<tr><td><?php _e('Enable Additional Info Tab Handling?', 'cpg_domain'); ?></td><td><input id="cpg_settings[add_info_events]" type="checkbox" name="cpg_settings[add_info_events]" value="1" <?php checked("1", isset($cpg_options['add_info_events']) ? $cpg_options['add_info_events'] : '') ?> /></td></tr>-->

	
			</table>


			<p class="submit">
				<input type="submit" class="button-primary" value="<?php _e('Save Options', 'cpg_domain'); ?>" />
			</p>
 
		</form>


	</div>
<hr style="border:1px solid #cccccc;width: 90%;">

<div style="margin-top:50px;">The options below will remove the diagnostics logs from the system</div>
	<div style="margin-top:20px;width:50%;display:flex;justify-content:space-around;">
<div><a href="/wp-admin/options-general.php?page=blnd_purge_log"><input class="button-primary" type="button" value="Clean Log"></a></div>
<div><a href="/wp-admin/options-general.php?page=blnd_delete_log"><input class="button-primary" type="button" value="Delete Log Table"></a></div>
	</div>
	<?php
	echo ob_get_clean();
	echo (isset($diagnostic) ? $diagnostic : '' );
}

