<?php


function run_dashboard() {
	global $cpg_options;

	// this is the main entry to the Dashboard
	// Check the user credentials
	if (!apply_filters("nuf_check_authorised_user", false, '')){
	#if ( !cpg_CheckAuthorisedUser() ) {
		do_action("cpg_reset_session_menu");
		return false;
	}


	if (!empty($cpg_options['importtestmode'])) {
		echo '<div id="test-mode-header">Test Mode is Active</div>';
	}
   
echo '<div id="dashboard-container">';



echo '<div id="menu-panel">' .create_tool_menu().'</div>';

echo '<div id="dash-main" style="" class="main-panel">';
echo '<div id="cpg_error_message"></div>';
echo '<div id="cpg_message"></div>';
echo ajaxLoaderGif();
echo '<div id="main-panel">';
if (!empty($_POST['action'])){
	run_direct_commands( $_POST) ;
}
echo '</div>'; // end of main panel

echo '</div>'; // end of dash main

echo '</div>'; // end of dashboard container



#test_spread();

#export_spread();

}


function run_direct_commands( $params ) {
	switch ($params['action']) {
		case 'list_overdate':
			$gantt = new DisplayHistoricalGantt();
			echo $gantt->RenderBarOutput();
			break;
		case 'export_overdate':
			#$table = new DisplayTable;
			#echo $table->ExportExcel();
			export_overdue_tasks();
			break;
		case 'table_overdate':
			$table = new DisplayTable;
			echo $table->RenderTable();
			break;
		case 'test_gantt':
			$gantt = new DisplayGantt();
			echo $gantt->RenderOutput();
			break;
		case 'production_gantt':
			// do nothing?
			$gantt = new DisplayGantt();
			echo $gantt->RenderBarOutput();
			break;
		case 'integrated_gantt':
			$gantt = new DisplayGantt();
			echo $gantt->RenderUnifiedOutput();
			break;
		case 'search_text':
			// do nothing?
			$gantt = new DisplayGantt();
			echo $gantt->RenderBarOutput();
			break;
		case 'workstation_gantt':
			#print_r($_POST);
			$gantt = new DisplayGantt();
			echo $gantt->RenderBarOutput();
			break;
		case 'table_previousversions':
			$table = new DisplayTable;
			echo $table->RenderIterationsTable();
			break;
		case 'export_full': 
			// exports all the data as a spreadsheet
			$fulldata = true;
			export_fulldataset_spreadsheet();
			break;
		case 'export_changes':
			// exports just the changes to a spreadsheet
			set_time_limit(300);
			export_changesonly_spreadsheet();
			break;
		case 'export_changes_sql':
			// exports just the changes to the sql server
			set_time_limit(300);
			$exp = new ImportExportClass;
			$exp->ExportChanges();
			break;
		case 'export_latest_dataset':
			// exports all data including any changes to a spreadsheet
			set_time_limit(600);
			export_latest_fulldataset_spreadsheet();
			break;
		case 'table_changes':
			$gantt = new DisplayChangesGantt();
			echo $gantt->RenderBarOutput();
			break;
		case 'import': // process import data
			// imports from a spreadsheet
			HandleImportProcess();
			#import_spreadsheets();
			break;
		case 'import_process':
			import_spreadsheets();
			break;
		case 'remote_import':
			// imports from the SQL Server
			$exp = new ImportExportClass;
			$exp->importRemoteSQL();
			break;
		default:
			echo "This menu is not implemented yet!";
			print_r($_POST);
	}

}


?>