<?php

class SortBy {
	private static $field = '';
	private static $array = array();
	private static $direction = 'asc';
    private static $initialized = false;

    private static function initialize($field, $direction)
    {
        if (self::$initialized)
            return;

        self::$field = $field;
		self::$direction = $direction;
        self::$initialized = true;
    }	
	
	static function process($field, &$array, $direction = 'asc') {

		self::initialize($field, $direction);

		$callable = [SortBy::class, 'SortFunction'];
		usort($array, $callable);
		return true;
	}

	static function SortFunction($a, $b) {
        $a = $a[self::$field];
        $b = $b[self::$field];

        if ($a == $b) return 0;

        $direction = strtolower(trim(self::$direction));

		if ($a == $b) return 0;
		if ($direction=='desc') {
			if ($a > $b) {
				return -1;
			} else {
				return 1;
			}
		} else {
			if ($a < $b) {
				return -1;
			} else {
				return 1;
			}
		}
    }

	static function multisort() {
		//get args of the function
		$args = func_get_args();
		$c = count($args);
		if ($c < 2) {
			return false;
		}
		//get the array to sort
		$array = array_splice($args, 0, 1);
		$array = $array[0];
		//sort with an anoymous function using args
		usort($array, function($a, $b) use($args) {

			$i = 0;
			$c = count($args);
			$cmp = 0;
			while($cmp == 0 && $i < $c)
			{ 
				#echo "  " . $a[$args[$i]];
				$order = 'asc';
				if (!is_array( $args[$i] ) ) {
					$field1 = $a [ $args[$i] ];
					$field2 = $b [ $args[$i] ];
				} else {
					$fieldArray =  $args[$i];
					$field1 = $a[$fieldArray[0]];
					$field2 = $b[$fieldArray[0]];
					$order = strtolower($fieldArray[1])=='desc' ? 'desc' : 'asc';
				}
				if (is_numeric($field1) && is_numeric($field2)) {
					if ($field1==$field2) {
						$cmp = 0;
					} elseif ($order=='asc') {
						$cmp = $field1> $field2;
						if ($cmp) {
							$cmp = 1;
						} else { 
							$cmp = -1;
						}
					} else {
						$cmp = $field1<$field2;
						if ($cmp) {
							$cmp = 1;
						} else { 
							$cmp = -1;
						}
					}
				} else {
					if ($order=='asc') {
						$cmp = strcmp($field1, $field2 );
					} else {
						$cmp = strcmp($field2, $field1 );
					}
				}
				#	echo "<br>cmp="  . $cmp;
				$i++;
			}

			return $cmp;

		});

		return $array;
	}
} # end of SortBy class

###########################################################

function randomFilename( $length='') {
	$str_length = 5;
	if (!empty($length) && is_numeric($length) && $length>1) {
		$str_length = $length-1;
	} 
	return substr(str_shuffle('ABCDEFGHIJKLMNOPQRSTUVWXYZ'),0, 1) . substr(str_shuffle('ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'),0, $str_length);
}

function ajaxLoaderGif($text = 'Please wait...', $override_class='' ) {
	return '<div id="ajax-wait" class="'.$override_class.'"><div><div><img src="'. cpg_plugin_url() . '/images/ajax-loader.gif' .'"></div><div>'.$text.'</div></div></div>';
}

function GetWorkStations( $opt_params=array(), $as_array = true) {
	global $wpdb;
	global $cpg_db_tables;

	#$sql = "select distinct u_RscCode from BatchItemView order by U_RscCode";

	$sql = "select `b`.`U_RscCode` AS `U_RscCode` from (`wpel_z_tOMOR` `a` left join `wpel_z_tMOR16` `b` on(((`a`.`DocEntry` = `b`.`DocEntry`) and (`a`.`active` = '1') and (`a`.`deleted` = '0')))) order by `b`.`U_RscCode`";

	$params = array();
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;


	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		
	return $row_arrays;
}

function GetBatchUpdateCodes( $opt_params=array(), $as_array = true) {
	global $wpdb;
	global $cpg_db_tables;

	$tablename = $wpdb->prefix . $cpg_db_tables['batch_output'];

	$sql = "select distinct update_code, max(created) as created from $tablename where 1=1 ";

	$params = array();

	$sql .= " group by update_code ";
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;


	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		
	return $row_arrays;
}

function GetBatchIterations( $opt_params=array(), $as_array = true) {
	global $wpdb;
	global $cpg_db_tables;

	$tablename1 = $wpdb->prefix . $cpg_db_tables['import_tableA'];
	$tablename2 = $wpdb->prefix . $cpg_db_tables['batch_output'];

	#$sql = "select * from batch_update_view ";

	$sql = "select `a`.`id` AS `id`,`a`.`update_code` AS `update_code`,`b`.`U_ItemCode` AS `U_ItemCode`,`b`.`U_Description` AS `U_Description`,`b`.`U_Status` AS `U_Status`,`a`.`U_RscCode` AS `U_RscCode`,`a`.`U_LineNum` AS `U_LineNum`,`a`.`U_SetupStartDate` AS `U_SetupStartDate`,`a`.`U_SetupStartTime` AS `U_SetupStartTime`,`a`.`update_time` AS `update_time`,`a`.`deleted` AS `deleted` from ($tablename2 `a` left join $tablename1 `b` on((`a`.`DocEntry` = `b`.`DocEntry`))) order by `a`.`update_time`,`a`.`U_LineNum`";

	$params = array();

	#$sql .= " group by update_code ";
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;


	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		
	return $row_arrays;
}

function GetBatchOrderSequence( $opt_params=array(), $as_array = true) {
	global $wpdb;
	global $cpg_db_tables;

	$tablename = $wpdb->prefix . $cpg_db_tables['WrkStatOrder'];

	$sql = "select * from $tablename ";

	$params = array();

	$sql .= " order by sortorder, id ";
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;


	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		
	return $row_arrays;
}

function GetWorkstationOrder() {
	$worders = GetBatchOrderSequence();
	$wrkorder = array();
	$i = 0;
	foreach ($worders as $worder) {
		$wrkstation = str_replace("/", "", str_replace(" ", "", $worder['workstation']));
		$wrkorder[$wrkstation] = $i;
		$i++;
	}
	return $wrkorder;
}


function GetModifiedBatchData( $opt_params=array(), $as_array = true) {
	global $wpdb;
	global $cpg_db_tables;

	$tablename = $wpdb->prefix . $cpg_db_tables['batch_output'];

	$opts_default  = array( 'active' => 1,
							'deleted' => 0,
							);

	// now lets merge the defaults with any passed params
	if (empty($opt_params) || !is_array($opt_params)) {
		$opt_params = array();
	}
	$opt_params = array_merge( $opts_default,  $opt_params );

	$sql = "select * from $tablename where 1=1  ";

	$params = array();
	foreach ($opt_params as $key=>$param) {
		$sql .= " AND $key = %s ";
		$params[] = $param;
	}
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;


	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		

	return $row_arrays;
}

function MergeModifiedBatchData( $list, $mods=array()) {

	if (empty($mods)) {
		$mods = GetModifiedBatchData();
	}


	$modbatch = array();
	foreach ($mods as $row) {
		$modbatch[$row['bid']] = $row;
	}
	$mods = $modbatch;
	foreach ($list as $key=>$row) {
		if (array_key_exists($row['bid'], $mods)) {
			if ($row['bid']=='9982') {
			#	print_r($row);
			#	echo "<br>";
			}
			foreach ($row as $key2=>$cell) {
				if (array_key_exists($key2, $row) && array_key_exists($key2, $mods[$row['bid']])) {
					$row[$key2] = $mods[$row['bid']][$key2]; 
				}
			}
			$list[$key] = $row;
			if ($row['bid']=='9982') {
			#	print_r($row);
			}
		}
	}
	return $list;
}

function GetImportTransferList( $opt_params=array(), $as_array = true ) {
	global $wpdb;
	global $cpg_db_tables;

	$id = false;

	$opts_default  = array( 'active' => 1,
							'deleted' => 0,
							);

	// now lets merge the defaults with any passed params
	if (empty($opt_params) || !is_array($opt_params)) {
		$opt_params = array();
	}
	$opt_params = array_merge( $opts_default,  $opt_params );

	$id = false;
	$tablename = $wpdb->prefix . $cpg_db_tables['input_sample'];

	$params = array() ;

	$sql = "select * from $tablename where 1=1 " ; #and active=%d and deleted=%d";
	foreach ($opt_params as $key=>$param) {
		$sql .= " AND $key = %s ";
		$params[] = $param;
	}
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;


	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		

	return $row_arrays;

} # end of GetImportTransferList

#################################################
# only used to import from an intermediate file
#################################################
function GetTransferList( $opt_params=array(), $as_array = true ) {
	global $wpdb;
	global $cpg_db_tables;

	$id = false;

	$opts_default  = array( 'active' => 1,
							'deleted' => 0,
							);

	// now lets merge the defaults with any passed params
	if (empty($opt_params) || !is_array($opt_params)) {
		$opt_params = array();
	}
	$opt_params = array_merge( $opts_default,  $opt_params );

	$id = false;
	$tablename = $wpdb->prefix . $cpg_db_tables['input_transfer'];

	$params = array() ;

	$sql = "select * from $tablename where 1=1 " ; #and active=%d and deleted=%d";
	foreach ($opt_params as $key=>$param) {
		$sql .= " AND $key = %s ";
		$params[] = $param;
	}
	$sql .= " ORDER BY SortOrder, Batch_Number, Id ";
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;


	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true); 
	} else {
		$row_arrays = $myrows;
	}		

	return $row_arrays;

} # end of GetImportTransferList
############################################################

function GetBatchList( $opt_params=array(), $where='', $sort='', $as_array = true ) {
	global $wpdb;
	global $cpg_db_tables;

	$opts_default  = array( 'a.active' => 1,
							'a.deleted' => 0,
							'b.active' => 1,
							'b.deleted' => 0,
							);

	// now lets merge the defaults with any passed params
	if (empty($opt_params) || !is_array($opt_params)) {
		$opt_params = array();
	}
	$opt_params = array_merge( $opts_default,  $opt_params );

	$tablename = $wpdb->prefix . $cpg_db_tables['import_table1'];
	$tablename2 = $wpdb->prefix . $cpg_db_tables['import_table2'];

	$cutoff = new DateTime;
	$cutoff->modify("+18 week");
	$cutoff_date = $cutoff->format("Y-m-d");

	$pastdate = new DateTime;
	$pastdate->modify("-4 week");
	$past_date = $pastdate->format("Y-m-d");

	$params = array() ;

	$sql = "select a.id, b.id as bid, a.DocNum, a.U_ItemCode, a.U_Description, a.U_Status, a.U_DistNumber, b.U_LineNum, b.U_RscCode, b.U_QueueTime, b.U_SetupTime, b.U_RunTime, b.U_StockTime, b.U_QueueStartDate, b.U_SetupStartDate, b.U_RunStartDate, b.U_StockStartDate, b.U_QueueStartTime, b.U_SetupStartTime, b.U_RunStartTime, b.U_StockStartTime, b.U_QueueEndDate, b.U_SetupEndDate, b.U_RunEndDate, b.U_StockEndDate, b.U_QueueEndTime, b.U_SetupEndTime, b.U_RunEndTime, b.U_StockEndTime from $tablename a left join $tablename2  b on a.docentry=b.DocEntry ";

	foreach ($opt_params as $key=>$param) {
		$sql .= " AND $key = %s ";
		$params[] = $param;
	}
	$sql .= " WHERE 1=1 ";
	$sql .= " AND b.U_SetupStartDate<'".$cutoff_date."' ";
	$sql .= " AND b.U_SetupStartDate>='".$past_date."' ";
	$sql .= " AND (a.U_Status='SC' OR a.U_Status='RL' OR a.U_Status='ST') ";
	$sql .= " AND ((b.U_QueueStartDate<>'NULL' and b.U_QueueStartDate<>'') OR (b.U_SetupStartDate<>'NULL' and b.U_SetupStartDate<>'') OR (b.U_RunStartDate<>'NULL' and b.U_RunStartDate<>'') OR (b.U_StockStartDate<>'NULL' and b.U_StockStartDate<>'')) ";
	if (!empty($where)) {
		$sql .= " AND  " . $where . ' ';
	}
	if (!empty($sort)) {
		$sql .= ' ORDER BY ' . $sort;
	}
	#echo $sql;
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;

	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		
	return $row_arrays;
}

function GetChangesBatchList( $opt_params=array(), $where='', $sort='', $as_array = true ) {
	global $wpdb;
	global $cpg_db_tables;

	$opts_default  = array( 'a.active' => 1,
							'a.deleted' => 0,
							'b.active' => 1,
							'b.deleted' => 0,
							);

	// now lets merge the defaults with any passed params
	if (empty($opt_params) || !is_array($opt_params)) {
		$opt_params = array();
	}
	$opt_params = array_merge( $opts_default,  $opt_params );

	$tablename = $wpdb->prefix . $cpg_db_tables['import_table1'];
	$tablename2 = $wpdb->prefix . $cpg_db_tables['import_table2'];
	$tablename2 = $wpdb->prefix . $cpg_db_tables['batch_output'];

	$cutoff = new DateTime;
	$cutoff->modify("+18 week");
	$cutoff_date = $cutoff->format("Y-m-d");

	$pastdate = new DateTime;
	$pastdate->modify("-4 week");
	$past_date = $pastdate->format("Y-m-d");

	$params = array() ;

	// NOTE!! we need the bid from the second table as it relates to the original input table index
	$sql = "select a.id, b.bid as bid, a.DocNum, a.U_ItemCode, a.U_Description, a.U_Status, a.U_DistNumber, b.U_LineNum, b.U_RscCode, b.U_QueueTime, b.U_SetupTime, b.U_RunTime, b.U_StockTime, b.U_QueueStartDate, b.U_SetupStartDate, b.U_RunStartDate, b.U_StockStartDate, b.U_QueueStartTime, b.U_SetupStartTime, b.U_RunStartTime, b.U_StockStartTime, b.U_QueueEndDate, b.U_SetupEndDate, b.U_RunEndDate, b.U_StockEndDate, b.U_QueueEndTime, b.U_SetupEndTime, b.U_RunEndTime, b.U_StockEndTime from $tablename a left join $tablename2  b on a.docentry=b.DocEntry ";

	foreach ($opt_params as $key=>$param) {
		$sql .= " AND $key = %s ";
		$params[] = $param;
	}
	$sql .= " WHERE 1=1 ";
	$sql .= " AND b.U_SetupStartDate<'".$cutoff_date."' ";
	$sql .= " AND b.U_SetupStartDate>='".$past_date."' ";
	$sql .= " AND (a.U_Status='SC' OR a.U_Status='RL' OR a.U_Status='ST') ";
	$sql .= " AND ((b.U_QueueStartDate<>'NULL' and b.U_QueueStartDate<>'') OR (b.U_SetupStartDate<>'NULL' and b.U_SetupStartDate<>'') OR (b.U_RunStartDate<>'NULL' and b.U_RunStartDate<>'') OR (b.U_StockStartDate<>'NULL' and b.U_StockStartDate<>'')) ";
	if (!empty($where)) {
		$sql .= " AND  " . $where . ' ';
	}
	if (!empty($sort)) {
		$sql .= ' ORDER BY ' . $sort;
	}
	#echo $sql;
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;

	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		
	return $row_arrays;
}

function GetHistoricalBatchList( $opt_params=array(), $where='', $sort='', $as_array = true ) {
	global $wpdb;
	global $cpg_db_tables;

	$opts_default  = array( 'a.active' => 1,
							'a.deleted' => 0,
							'b.active' => 1,
							'b.deleted' => 0,
							);

	// now lets merge the defaults with any passed params
	if (empty($opt_params) || !is_array($opt_params)) {
		$opt_params = array();
	}
	$opt_params = array_merge( $opts_default,  $opt_params );

	$tablename = $wpdb->prefix . $cpg_db_tables['import_table1'];
	$tablename2 = $wpdb->prefix . $cpg_db_tables['import_table2'];

	$now = new DateTime;
	#$now->modify("+18 week");
	$cutoff_date = $now->format("Y-m-d");

	$params = array() ;

	$sql = "select a.id, b.id as bid, a.DocNum, a.U_ItemCode, a.U_Description, a.U_Status, a.U_DistNumber, b.U_LineNum, b.U_RscCode, b.U_QueueTime, b.U_SetupTime, b.U_RunTime, b.U_StockTime, b.U_QueueStartDate, b.U_SetupStartDate, b.U_RunStartDate, b.U_StockStartDate, b.U_QueueStartTime, b.U_SetupStartTime, b.U_RunStartTime, b.U_StockStartTime, b.U_QueueEndDate, b.U_SetupEndDate, b.U_RunEndDate, b.U_StockEndDate, b.U_QueueEndTime, b.U_SetupEndTime, b.U_RunEndTime, b.U_StockEndTime from $tablename a left join $tablename2  b on a.docentry=b.DocEntry ";

	foreach ($opt_params as $key=>$param) {
		$sql .= " AND $key = %s ";
		$params[] = $param;
	}
	$sql .= " WHERE 1=1 ";
	$sql .= " AND b.U_SetupStartDate<'".$cutoff_date."' ";
	$sql .= " AND (a.U_Status='SC' OR a.U_Status='RL' OR a.U_Status='ST') ";
	$sql .= " AND ((b.U_QueueStartDate<>'NULL' and b.U_QueueStartDate<>'') OR (b.U_SetupStartDate<>'NULL' and b.U_SetupStartDate<>'') OR (b.U_RunStartDate<>'NULL' and b.U_RunStartDate<>'') OR (b.U_StockStartDate<>'NULL' and b.U_StockStartDate<>'')) ";
	if (!empty($where)) {
		$sql .= " AND  " . $where . ' ';
	}
	if (!empty($sort)) {
		$sql .= ' ORDER BY ' . $sort;
	}
	#echo $sql;
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;

	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		
	return $row_arrays;
}

function GetImportTable1( $opt_params=array(), $as_array = true ) {
	global $wpdb;
	global $cpg_db_tables;

	$id = false;

	$opts_default  = array( 'active' => 1,
							'deleted' => 0,
							);

	// now lets merge the defaults with any passed params
	if (empty($opt_params) || !is_array($opt_params)) {
		$opt_params = array();
	}
	$opt_params = array_merge( $opts_default,  $opt_params );

	$id = false;
	$tablename = $wpdb->prefix . $cpg_db_tables['import_tableA'];

	$params = array() ;

	$sql = "select * from $tablename where 1=1 " ; #and active=%d and deleted=%d";
	foreach ($opt_params as $key=>$param) {
		$sql .= " AND $key = %s ";
		$params[] = $param;
	}
	#$sql .= " ORDER BY SortOrder, Batch_Number, Id ";
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;


	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		

	return $row_arrays;

} # end of GetImportTable1


function GetImportTable2( $opt_params=array(), $as_array = true ) {
	global $wpdb;
	global $cpg_db_tables;

	$id = false;

	$opts_default  = array( 'active' => 1,
							'deleted' => 0,
							);

	// now lets merge the defaults with any passed params
	if (empty($opt_params) || !is_array($opt_params)) {
		$opt_params = array();
	}
	$opt_params = array_merge( $opts_default,  $opt_params );

	$id = false;
	$tablename = $wpdb->prefix . $cpg_db_tables['import_tableB'];

	$params = array() ;

	$sql = "select * from $tablename where 1=1 " ; #and active=%d and deleted=%d";
	foreach ($opt_params as $key=>$param) {
		$sql .= " AND $key = %s ";
		$params[] = $param;
	}
	#$sql .= " and id>10000 ";
	#$sql .= " ORDER BY SortOrder, Batch_Number, Id ";
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;


	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}		

	return $row_arrays;

} # end of GetImportTable2

function GetSQLImportTable2() {
	
	$db = new dbSQL_Class;
	$sql = "select * from tCT_PF_MOR16 " ;

	echo $sql;
	$array = $db->get_data_query($sql);

	#foreach ($array as $row) {
	#	print_r($row);
	#}
	echo "processed import";
}



#################################################

function importTransferList() {
    $list = GetImportTransferList();
    
   # print_r($list);
    foreach ($list as $row) {
        $tx = new InputXferClass(-1);
        $tx->DocNum = $row['DocNum'];
        $tx->MOLineId = $row['LineId'];
        $tx->ItemCode = $row['U_MorCode'];
        $tx->ItemDescription = $row['U_Description'];
        $tx->Batch_Number = $row['Batch_Number'];

        $tx->SetupTime = $row['U_SetupTime'];
        $tx->RunTime = $row['U_RunTime'];

        $tx->WorkCentre = $row['U_RscCode'];
        $tx->SetupStartDate = $row['U_SetupStartDate'];
        $tx->SetupStartTime = $row['U_SetupStartTime'];
        $tx->RunStartDate = $row['U_RunStartDate'];
        $tx->RunStartTime = $row['U_RunStartTime'];
        $tx->RunEndDate = $row['U_RunEndDate'];
        $tx->RunEndTime = $row['U_RunEndTime'];
        $tx->SetupEndDate = $row['U_SetupEndDate'];
        $tx->SetupEndTime = $row['U_SetupEndTime'];
       
        $tx->save();
    }
    
    echo '<div>Data Imported';
}

#######################################################

function getBatchTime($date, $time=''){
    if (!empty($date) && $date!='NULL') {
        $t1 = substr('0000'.$time, -2);
        $t2 = substr('0000'.$time, -4, 2);
        
       # echo '<br>'. $time . ' ' . $t1 . ' = ' . $t2;
        $time = new DateTime( $date . ' ' . $t2 . ':' . $t1 . ':00');
       # print_r($time);
        return $time;
    }
}
function splitBatchTime($date, $assoc=true){
    if (!empty($date) && is_a($date, "DateTime")) {
        $t1 = $date->format("Y-m-d");
        $t2 = $date->format("Gi");
        $times = array();
        if ($assoc)  {
            $times['date'] = $t1;
            $times['time'] = $t2;
        } else {
           $times = array($t1, $t2);
        }
        

       # echo '<br>'. $time . ' ' . $t1 . ' = ' . $t2;
        return $times;
    }
} 

function formatDateEquivalent($timestamp, $timezone) {
    // Create a DateTime object from the timestamp
    $date = new DateTime("@$timestamp");
    $date->setTimezone(new DateTimeZone($timezone));

    // Format the date using 'a' for am/pm
    return $date->format('a');
}



#if (!function_exists('strftime')) {

    function strftime2($format, $timestamp=null) {

    // PARAMETER 1 CHECK

        if (($format === null) || ($format === false))
            return false;

        if ($format === true)
            return '1';

        $type = gettype($format);

        if (preg_match('/^(array|object|resource|resource \(closed\)|unknown type)$/', $type)) {
            trigger_error('strftime() expects parameter 1 to be string, ' . $type . ' given', E_USER_WARNING);
            return false;
        }

        if (preg_match('/^(integer|double)$/', $type))
            return (string) $format;

        if ($type !== 'string')
            return false;

    // PARAMETER 2 CHECK

        $type = gettype($timestamp);

        if ($timestamp === null)
            $timestamp = time();

        elseif (
            !is_scalar($timestamp) ||
            (is_string($timestamp) && !preg_match('/^(0|[1-9]\d*)$/', $timestamp))
        ) {
            trigger_error('strftime() expects parameter 2 to be integer, ' . $type . ' given', E_USER_WARNING);
            return false;
        }

        if (!is_integer($timestamp))
            $timestamp = (int) $timestamp;

        $locale = setlocale(LC_TIME, '0');


// EASY WAY - USING SHELL TO GET DATE TEXT

        if (is_callable('shell_exec') && (stripos(ini_get('disable_functions'), 'shell_exec') === false)) {
            $cmd = 'export LC_TIME=' . escapeshellarg($locale) . '; date --date @' . escapeshellarg($timestamp) . ' +' . escapeshellarg($format);
            return preg_replace('/\r?\n$/', '', shell_exec($cmd));
        }


// HARD WAY - NOT COMPLETED

    // CHECK FORMAT

        $format = strtr($format,[
            '%r' => '%I:%M:%S %p',
            '%R' => '%H:%M',
            '%T' => '%H:%M:%S',
            '%D' => '%m/%d/%y',
            '%F' => '%Y-%m-%d'
        ]);

        $modifiers = 'aAdejuwUVWbBhmCgGyYHkIlMpPSXzZcsxnt%';
        if (!preg_match('/%[' . $modifiers . ']/', $format))
            return $format;

    // FORMAT MAP

        $map = [    // https://unicode-org.github.io/icu/userguide/format_parse/datetime/
                    // https://www.php.net/manual/en/function.strftime.php#refsect1-function.strftime-parameters

            // DAY
            '%a' => 'ccc',      // Mon - Sun
            '%A' => 'cccc',     // Monday - Sunday
            '%d' => 'dd',       // 01 - 31
            '%e' => 'd',        // 1 - 31
            '%j' => ['D'],      // 001 - 366
            '%u' => ['c'],      // 1 - 7
            '%w' => ['c'],      // 0 - 6

            // WEEK
            '%U' => ['w'],      // Week number of the given year, starting with the first Sunday as the first week
            '%V' => ['ww'],     // Week number of the given year, starting with the first week of the year with at least 4 weekdays, with Monday being the start of the week (ISO-8601:1988)
            '%W' => ['w'],      // A numeric representation of the week of the year, starting with the first Monday as the first week

            // MONTH
            '%b' => 'LLL',      // Jan - Dec
            '%B' => 'LLLL',     // January - December
            '%h' => 'LLL',      // Jan - Dec
            '%m' => 'LL',       // 01 - 12

            // YEAR
            '%C' => ['y'],      // Two digit representation of the century (year divided by 100, truncated to an integer)
            '%g' => ['yy'],     // Two digit representation of the year (ISO-8601:1988 see %V)
            '%G' => ['y'],      // Full digit representation of the year (ISO-8601:1988 see %V)
            '%y' => 'yy',       // Two digit representation of the year
            '%Y' => 'y',        // Full digit representation of the year

            // TIME
            '%H' => 'HH',       // Hour 00 - 23
            '%k' => 'H',        // Hour 0 - 23
            '%I' => 'hh',       // Hour 01 - 12
            '%l' => 'h',        // Hour 1 - 12
            '%M' => 'mm',       // Minutes 00 - 59
            '%p' => [],         // AM / PM
            '%P' => [],         // am / pm
            '%S' => 'ss',       // Seconds 00 - 59
            '%X' => [],         // Preferred time representation based on locale, without the date. Example: 03:59:16 or 15:59:16
            '%z' => 'Z',        // Time zone -0500 for US Eastern Time
            '%Z' => 'z',        // Time zone EST for Eastern Time

            // TIME AND DATA STAMPS
            '%c' => [],         // Preferred date and time stamp based on locale. Example: Tue Feb 5 00:45:10 2009
            '%s' => [],         // Unix Epoch Time timestamp (same as the time() function)
            '%x' => [],         // Preferred date representation based on locale, without the time. Example: 02/05/09

            // MISCELLANEOUS
            '%n' => [],         // \n
            '%t' => [],         // \t
            '%%' => []          // %
        ];

        $timezone = date_default_timezone_get();

        $return = '';

        $length = strlen($format);

        for ($i = 0; $i < $length; $i++) {

            $current_char = $format[$i];
            $next_char = $i < $length - 1 ? $format[$i + 1] : false;

            // NORMAL TEXT
            if ($current_char !== '%') {
                $return .= $current_char;
                continue;
            }

            // MODIFIER
            else {

                // LAST CHARACTER
                if ($next_char === false) {
                    $return .= '%';
                    continue;
                }

                $fmt = $current_char . $next_char;
                $i++;

                // NOT FOUND
                if (!isset($map[$fmt])) {
                    $return .= $fmt;
                    continue;
                }

                // SIMPLE MODIFIER
                if (is_string($map[$fmt])) {
                    //$return .= datefmt_format(datefmt_create(
                    //    $locale,
                    //    IntlDateFormatter::FULL,
                    //    IntlDateFormatter::FULL,
                    //    $timezone,
                    //    IntlDateFormatter::GREGORIAN,
                    //    $map[$fmt]
                    //), $timestamp);
                    $return = formatDateEquivalent($timestamp, $timezone);

                    continue;
                }

                // SPECIAL MODIFIERS
                if (!empty($map['fmt'])) {
                    //$str = datefmt_format(datefmt_create(
                    //    $locale,
                    //    IntlDateFormatter::FULL,
                    //    IntlDateFormatter::FULL,
                    //    $timezone,
                    //    IntlDateFormatter::GREGORIAN,
                    //    $map[$fmt][0]
                    //), $timestamp);
                    $str = formatDateEquivalent($timestamp, $timezone);
                }

                if ($fmt == '%j')
                    $return .= sprintf("%03d", $str);

                elseif ($fmt == '%u') {
    ###                $return .= (--$str ? $str : '7');

                } elseif ($fmt == '%w') {
    ###                $return .= --$str;

                } elseif ($fmt == '%U') {

                }

                elseif ($fmt == '%V') {

                }

                elseif ($fmt == '%W') {

                }

                elseif ($fmt == '%C')
                    $return .= (string) floor($str / 100);

                elseif ($fmt == '%g') {

                }

                elseif ($fmt == '%G') {

                }

                elseif (($fmt == '%p') || ($fmt == '%P')) {
                 //   $str = datefmt_format(datefmt_create(
                 //       'en_US',
                 //       IntlDateFormatter::FULL,
                 //       IntlDateFormatter::FULL,
                 //       $timezone,
                 //       IntlDateFormatter::GREGORIAN,
                 //       'a'
                 //   ), $timestamp);
                    $str = formatDateEquivalent($timestamp, $timezone);
                    $return .= ($fmt == '%p') ? strtoupper($str) : strtolower($str);
                }

                elseif ($fmt == '%X') {

                }

                elseif ($fmt == '%c') {

                }

                elseif ($fmt == '%s')
                    $return .= $timestamp;

                elseif ($fmt == '%x') {

                }

                elseif ($fmt == '%n')
                    $return .= "\n";

                elseif ($fmt == '%t')
                    $return .= "\t";

                elseif ($fmt == '%%')
                    $return .= '%';

                else
                    $return .= $fmt;

                continue;
            }

        }

        return $return;
    }


#}

function link_allocation_orig( $row = array() ) {


	$start = getBatchTime($row['SetupStartDate'], $row['SetupStartTime']);
	$end = getBatchTime($row['RunEndDate'], $row['RunEndTime']);

	$alloc = Array(
                 'label' => $row['MOLineId'] . '_' . $row['DocNum'], # $row['WorkCentre'],
                 'start' => $start->format("Y-m-d H:i:s"),
                 'end' =>  $end->format("Y-m-d H:i:s"),
                 'description' =>'Total Run: ' . ($row['SetupTime'] + $row['RunTime']),
                 'color' => '#00ff00',
                );

	return $alloc;
}


function link_allocation( $row = array(), $product_match=false ) {
	global $cpg_options;

	$normalcolor = !empty($cpg_options['std_color']) ? $cpg_options['std_color'] : '#49b449';
	$notplanned = '#ffff00';

	if ($product_match) {
		$start = getBatchTime($row['U_RunStartDate'], $row['U_RunStartTime']);
		#$normalcolor = '#ff00ff';
	} else {
		$start = getBatchTime($row['U_SetupStartDate'], $row['U_SetupStartTime']);
	}
	$end = getBatchTime($row['U_RunEndDate'], $row['U_RunEndTime']);

	if (empty($start) || empty($end)) {
		#print_r($row);
		$dte = new DateTime;
		$start = $dte->format("Y-m-d H:i:s");
		$dte->modify("+1 DAY");
		$end = $dte->format("Y-m-d H:i:s");
		$alloc = Array(
                 'label' => $row['U_ItemCode'] . '_' . $row['DocNum'], # $row['WorkCentre'],
                 'start' => $start,
                 'end' =>  $end,
                 'description' =>'No times assigned ' . ($row['U_SetupTime'] + $row['U_RunTime']),
                 'color' => $notplanned,
				 'class' => " " . trim(str_replace(" ", "", $row['U_ItemCode'])). " " . trim(str_replace("/", "", str_replace(" ", "", $row['U_RscCode']))). " ",
				 'uid' => $row['bid'],
				 'seq' => $row['U_LineNum'],
                );

		return $alloc;
	}

	$alloc = Array(
                 'label' => $row['U_DistNumber'] . '_' . $row['U_LineNum'], # $row['WorkCentre'],
                 'start' => $start->format("Y-m-d H:i:s"),
                 'end' =>  $end->format("Y-m-d H:i:s"),
                 'description' =>$row['U_DistNumber'].'_'.$row['U_ItemCode'].'_'.$row['U_LineNum'].'_'.$row['DocNum'].' Time:'.$row['U_RunStartTime'],
                 'color' => $normalcolor,
				 'class' => " " . trim(str_replace(" ", "", $row['U_DistNumber'])). " " . trim(str_replace("/", "", str_replace(" ", "", $row['U_RscCode']))). " ",
				 'uid' => $row['bid'],
				 'seq' => $row['U_LineNum'],
                );

	return $alloc;
} # end of link_allocation

function link_product_allocation( $row = array(), $product_match=false ) {
	global $cpg_options;

	$normalcolor = !empty($cpg_options['std_color']) ? $cpg_options['std_color'] : '#49b449';
	$notplanned = '#ffff00';

	if ($product_match) {
		$start = getBatchTime($row['U_RunStartDate'], $row['U_RunStartTime']);
		#$normalcolor = '#ff00ff';
	} else {
		$start = getBatchTime($row['U_SetupStartDate'], $row['U_SetupStartTime']);
	}
	$end = getBatchTime($row['U_RunEndDate'], $row['U_RunEndTime']);

	if (empty($start) || empty($end)) {
		#print_r($row);
		$dte = new DateTime;
		$start = $dte->format("Y-m-d H:i:s");
		$dte->modify("+1 DAY");
		$end = $dte->format("Y-m-d H:i:s");
		$alloc = Array(
                 'label' => $row['U_ItemCode'] . '_' . $row['DocNum'], # $row['WorkCentre'],
                 'start' => $start,
                 'end' =>  $end,
                 'description' =>'No times assigned ' . ($row['U_SetupTime'] + $row['U_RunTime']),
                 'color' => $notplanned,
				 'class' => " " . trim(str_replace(" ", "", $row['U_ItemCode'])). " " . trim(str_replace("/", "", str_replace(" ", "", $row['U_RscCode']))). " ",
				 'uid' => $row['bid'],
				 'seq' => $row['U_LineNum'],
                );

		return $alloc;
	}

	$alloc = Array(
                 'label' => $row['U_DistNumber'] . '_' . $row['U_LineNum'], # $row['WorkCentre'],
                 'start' => $start->format("Y-m-d H:i:s"),
                 'end' =>  $end->format("Y-m-d H:i:s"),
                 'description' =>$row['U_DistNumber'].'_'.$row['U_ItemCode'].'_'.$row['U_LineNum'].'_'.$row['DocNum'].' Time:'.$row['U_RunStartTime'],
                 'color' => $normalcolor,
				 'class' => " " . trim(str_replace(" ", "", $row['U_DistNumber'])). " " . trim(str_replace("/", "", str_replace(" ", "", $row['U_RscCode']))). " ",
				 'uid' => $row['bid'],
				 'seq' => $row['U_LineNum'],
                );

	return $alloc;
} # end of product_allocation


function setConflicts( $row ) {

	$keys = array_keys($row);

	foreach ($row as $key=>$line) {
		$line_start[$key] = $line['start']->format("YmdHi");
		$line_end[$key] = $line['end']->format("YmdHi");
	}
#	print_r($line_start);
#	print_r($line_end);

	foreach ($row as $key1=>$line) {
		$start = $line_start[$key1];
		$end = $line_end[$key1];
	#	echo "<br>$key1";

		foreach ($keys as $key) {
			if ($key==$key1){
				continue;
			}
	#		echo "<br>&nbsp;&nbsp;&nbsp;&nbsp;$key";
			if (($start<=$line_end[$key] && $start>=$line_start[$key]) || 
				($end<=$line_end[$key] && $end>=$line_start[$key] ) ||
				($start<=$line_start[$key] && $end>=$line_end[$key] )  
				) {
			#	echo "<br>" . $key1 . ' '.  $start .'|'. ' ' . $end . ' ' . '=' . $key . ' '. $line_start[$key] . ' ' . $line_end[$key] ;
	#		echo "<br>$key1 = $key " ;
				$row[$key1]['conflict'] = empty($row[$key1]['conflict']) ? -1 : $row[$key1]['conflict'] ;
				$row[$key]['conflict'] = empty($row[$key]['conflict']) ? 1 : $row[$key]['conflict'];;
			}
		}



	}

	return $row;
}


function offsetProcessTime( $row, $offset=0 ) {
	global $offsets;

	if (!empty($offsets[$row['Batch_Number']])) {
		$offset = $offsets[$row['Batch_Number']];
#		print_r($offset);
	}

	$time = getBatchTime( $row['SetupStartDate'], $row['SetupStartTime'] );
	$time->modify("+" . $offset . " min");
	$timeparts = splitBatchTime( $time, true);
	$row['SetupStartDate'] = $timeparts['date'];
	$row['SetupStartTime'] = $timeparts['time'];

	$time = getBatchTime( $row['SetupEndDate'], $row['SetupEndTime'] );
	$time->modify("+" . $offset . " min");
	$timeparts = splitBatchTime( $time, true);
	$row['SetupEndDate'] = $timeparts['date'];
	$row['SetupEndTime'] = $timeparts['time'];

	$time = getBatchTime( $row['RunStartDate'], $row['RunStartTime'] );
	$time->modify("+" . $offset . " min");
	$timeparts = splitBatchTime( $time, true);
	$row['RunStartDate'] = $timeparts['date'];
	$row['RunStartTime'] = $timeparts['time'];

	$time = getBatchTime( $row['RunEndDate'], $row['RunEndTime'] );
	$time->modify("+" . $offset . " min");
	$timeparts = splitBatchTime( $time, true);
	$row['RunEndDate'] = $timeparts['date'];
	$row['RunEndTime'] = $timeparts['time'];

	return $row;
}



function LoadBatchItem( $row) {

	$process = new BatchItemClass($row['id']);

	$process->SetupStartDate = $row['SetupStartDate'];
	$process->SetupStartTime = $row['SetupStartTime'];

	$process->SetupEndDate = $row['SetupEndDate'];
	$process->SetupEndTime = $row['SetupEndTime'];

	$process->RunStartDate = $row['RunStartDate'];
	$process->RunStartTime = $row['RunStartTime'];

	$process->RunEndtDate = $row['RunEndDate'];
	$process->RunEndTime = $row['RunEndTime'];

	$process->starttime = getBatchTime( $row['SetupStartDate'], $row['SetupStartTime']);
	$process->endtime = getBatchTime( $row['RunEndDate'], $row['RunEndTime']);

	return $process;
}

function LoadBatchList() {
	global $offsets;

	$newstarts = array();

	$preset = !empty($_GET['preset']) ? $_GET['preset'] : 0;

	switch ($preset) {
		case 1:
			$newstarts = array('200539' =>'2880', '200540'=>'', '200433'=>'', '200536'=>'', '200508'=>'0', '200537'=>'', '200538'=>'', '200535'=>'', '200468'=>'', '200541'=>'', '200542'=>'');
			break;
		case 2:
			$newstarts = array('200539' =>'2880', '200540'=>'', '200433'=>'', '200536'=>'', '200508'=>'1440', '200537'=>'', '200538'=>'', '200535'=>'', '200468'=>'', '200541'=>'', '200542'=>'');
			break;
		case 3:
			$newstarts = array('200539' =>'2880', '200540'=>'', '200433'=>'', '200536'=>'', '200508'=>'1440', '200537'=>'', '200538'=>'', '200535'=>'720', '200468'=>'', '200541'=>'', '200542'=>'');
			break;
		case 4:
			$newstarts = array('200539' =>'2880', '200540'=>'', '200433'=>'', '200536'=>'500', '200508'=>'1440', '200537'=>'', '200538'=>'', '200535'=>'1050', '200468'=>'', '200541'=>'', '200542'=>'');
			break;
		case 5:
			$newstarts = array('200539' =>'2960', '200540'=>'1000', '200433'=>'', '200536'=>'570', '200508'=>'1525', '200537'=>'', '200538'=>'780', '200535'=>'1200', '200468'=>'', '200541'=>'1250', '200542'=>'');
			break;
		default:
			$newstarts = array('200539' =>'', '200540'=>'', '200433'=>'', '200536'=>'', '200508'=>'75', '200537'=>'', '200538'=>'', '200535'=>'', '200468'=>'', '200541'=>'', '200542'=>'');
	}
	
	$offsets = array();
	foreach ($newstarts as $key=>$newstart) {
		if (isset($_GET[$key])) {
			$newstart = $_GET[$key];
		}
		#echo "<br>" . $key .'-'. $newstart;
		$offsets[$key] = $newstart;
	}

    $batch_code = '200539';
	$opts = array();
   # $opts = array( 'Batch_Number' => $batch_code );

    $list = GetTransferList( $opts); 

	return $list;
}

function batch_form() {


}

function truncate_import_tables(){ 
	global $wpdb;
	global $cpg_db_tables;

	$tablename1 = $wpdb->prefix . $cpg_db_tables['import_tableA'];
	$tablename2 = $wpdb->prefix . $cpg_db_tables['import_tableB'];
	$tablename3 = $wpdb->prefix . $cpg_db_tables['batch_output'];

	$sql = "truncate $tablename1 ";
	$wpdb->query($sql);
	$sql = "truncate $tablename2 ";
	$wpdb->query($sql);
	$sql = "truncate $tablename3 ";
	$wpdb->query($sql);

}

function import_spreadsheets() {
		global $cpg_options;

		error_reporting(-1)	 ;
		ini_set("display_errors", 1); 
		set_time_limit(0);
		$start = microtime(true);

		$masters_folder = !empty($cpg_options['cpg_marshalling_folder']) ? $cpg_options['cpg_marshalling_folder'] : 'production_marshalling';
	

		makepath(cpg_get_document_path() . $masters_folder);
		$filename = cpg_get_document_path() . "$masters_folder" . '/import.xlsx';
		
		if (!file_exists($filename)) {
		    echo '<div>File does not exist</div>';
		    return false;
		}

		truncate_import_tables();

		$spout = new OpenSpoutExcel;

		$sheets = array( 'tOMOR', 'tMOR16');

		$result = $spout->ImportSheetByName($filename, $sheets);

		#$result = $spout->ReadExcel($filename, $sheets) ;
		if (is_wp_error($result)){
			echo '<div class="error-group">The following error(s) occurred</div>';
			foreach ($array->get_error_messages() as $message) {
				echo '<div class="error-list">' . $message. '</div>';
			}
		} else {
			#print_r(array_keys($result));
			echo '<div class="resource-used">';
			echo $spout->memory;
			echo $spout->runtime;

			if (is_array($result)) {
				foreach ($result as $key=>$row) {
					echo '<div>Sheet name: '.$key.' Row count=' . $row['count'].'</div>';
				}
			}
			echo '</div>';
			#echo '<pre>';
			#print_r($result);
		#	foreach ($result as $key=>$sheet) {
		#		$headers = array_values(array_shift($sheet));
		#		$loop = processImport( $key, $headers, $sheet);
		#		echo '<div class="processed-info">Processed ' .$loop . ' records for  sheet ' . $key . '</div>';
		#	}
			#echo '</pre>';
			$end = microtime(true);

			echo '<div class="resource-used">Overall processing time = ' . number_format(($end - $start), 2) . ' seconds</div>';

		}
} # end of import_spreadsheets

/*
function old_import_spreadsheets() {
		global $cpg_options;
    

		error_reporting(-1)	 ;
		ini_set("display_errors", 1); 
		set_time_limit(0);

  		$ExcelIO = new PHPExcelInterface;
		#$filename = ABSPATH .  "/wp-content/uploads/production_marshalling/"  . "import.xlsx";
		$masters_folder = !empty($cpg_options['cpg_marshalling_folder']) ? $cpg_options['cpg_marshalling_folder'] : 'production_marshalling';
		
		makepath(cpg_get_document_path() . $masters_folder);
		$filename = cpg_get_document_path() . "$masters_folder" . '/import.xlsx';
		
		if (!file_exists($filename)) {
		    echo '<div>File does not exist</div>';
		    return false;
		}
		$sheetnames = $ExcelIO->GetSheetnames($filename);
	
		if (!in_array("tOMOR", $sheetnames) && !in_array('tMOR16', $sheetnames)) {
		    echo '<div style="color:red;">Could not find either the tab called "tOMOR" or "tMOR16" - please load the correct spreadsheet or rename the appropriate tab(s).</div>';
		    echo "<div>Spreadsheet tabs found: " .  implode(", ", $sheetnames );
		    return false;
		}
		$sheetnames = array( "tOMOR", "tMOR16");
#		echo "loading sheet";
		#$sheetnames = array_slice($sheetnames, 0,1);

		foreach ($sheetnames as $sheetname) {
			// this calls the appropriate import routine and handles the data in chunks
			$sheets = $ExcelIO->ReadExcel($filename, $sheetname, false) ;  
		}

		#print_r($sheets);
		if (!empty($ExcelIO->status_messages['progress'])){
			foreach ($ExcelIO->status_messages['progress'] as $message) {
				echo $message;
			}
		}
		return false;
 }

*/
 function processImport( $sheetname, $headers, $spreadsheet) {

	$loop = false;
	switch ($sheetname) {
		case 'tOMOR':
			#echo $sheetname;
			$loop = process_tOMOR( $spreadsheet, $headers) ;
			break;
		case 'tMOR16':
			$loop = process_tMOR16( $spreadsheet, $headers) ;
			break;
		default:
	}
	return $loop;
 }

 function process_tOMOR($sheet, $headers=array()) {
     if (empty($sheet) || !is_array($sheet)) {
         return false;
     }
     if (empty($headers)) {
		$headers = array_shift( $sheet );
	 }

	 $headerkeys = array();
	 foreach ($headers as $key=>$header) {
		 $headerkeys[$header] = $key;
	 }

     $loop = 0;
     foreach ($sheet as $row) {
         $imp = new ImportXferClassA(-1);
         foreach ($headers as $key=>$header) {
            #echo $header;
            switch ($header) {
                case 'CreateDate':
                case 'UpdateDate':
                case 'U_RequiredDate':
                case 'U_PlannedStartDate':
                case 'U_PlannedEndDate':
                case 'U_RecommendationStartDate':
                case 'U_RecommendationEndDate':
                case 'Last_Refresh':
					if (!empty($row[$headerkeys[$header]]) && $row[$headerkeys[$header]]!='NULL') {
						if (is_a($row[$headerkeys[$header]], 'DateTime')) {
							$dte = $row[$headerkeys[$header]];
							$imp->{$header} = $dte->format("Y-m-d");
						} elseif (is_string($row[$headerkeys[$header]])){
							$dte = new DateTime($row[$headerkeys[$header]]);
							# $dte = \PhpOffice\PhpSpreadsheet\Shared\Date::excelToDateTimeObject($row[$headerkeys[$header]]);
							$imp->{$header} = $dte->format("Y-m-d");
						}
					}
                    break;
                default:
                    $imp->{$header} = $row[$headerkeys[$header]];
            }
         } 
         $imp->save();
		 $loop++;
     }
	 return $loop;
 }
 function process_tMOR16($sheet, $headers=array()) {
     if (empty($sheet) || !is_array($sheet)) {
         return false;
     }
     if (empty($headers)) {
		$headers = array_shift( $sheet );
	 }

	 $headerkeys = array();
	 foreach ($headers as $key=>$header) {
		 $headerkeys[$header] = $key;
	 }
	#print_r($headerkeys);

	 $loop = 0;
     foreach ($sheet as $row) {
		if (empty(array_filter($row))) {
			continue;
		}
		# print_r(array_filter($row));

         $imp = new ImportXferClassB(-1);
       
         foreach ($headers as $key=>$header) {
           #echo $header;
            switch ($header) {
                case 'U_RunStartDate':
                case 'U_SetupStartDate':
                case 'U_QueueStartDate':
                case 'U_StockStartDate':
                case 'U_RunEndDate':
                case 'U_SetupEndDate':
                case 'U_QueueEndDate':
                case 'U_StockEndDate':
                case 'Last_Refresh':
 					if (!empty($row[$headerkeys[$header]]) && $row[$headerkeys[$header]]!='NULL') {
						if (is_a($row[$headerkeys[$header]], 'DateTime')) {
							$dte = $row[$headerkeys[$header]];
							$imp->{$header} = $dte->format("Y-m-d");
						} elseif (is_string($row[$headerkeys[$header]])){
							$dte = new DateTime($row[$headerkeys[$header]]);
							# $dte = \PhpOffice\PhpSpreadsheet\Shared\Date::excelToDateTimeObject($row[$headerkeys[$header]]);
							$imp->{$header} = $dte->format("Y-m-d");
						}
					}
                 # if (!empty($row[$header]) && $row[$header]!='NULL') {
                  #      $dte = \PhpOffice\PhpSpreadsheet\Shared\Date    ::excelToDateTimeObject($row[$header]);
                  #      $imp->{$header} = $dte->format("Y-m-d");
                   #}
                  #  break;
                default:
                    $imp->{$header} = $row[$headerkeys[$header]];
            }
         } 
         $imp->save();
		 #echo $imp->DebugPrint();
		 $loop++;
     }
	 return $loop;

 }

 function processSheet1 ( $sheet, $headers=array()) {
     if (empty($sheet) || !is_array($sheet)) {
         return false;
     }
     if (empty($headers)) {
		$headers = array_shift( $sheet );
	 }
     
   #  print_r($headers);
     $loop = 0;
     foreach ($sheet as $row) {
         $imp = new ImportXferClass(-1);
         foreach ($headers as $key=>$header) {
           #echo $header;
            switch ($header) {
                case 'CreateDate':
                case 'UpdateDate':
                case 'U_RequiredDate':
                case 'U_PlannedStartDate':
                case 'U_PlannedEndDate':
                case 'U_RecommendationStartDate':
                case 'U_RecommendationEndDate':
                case 'Last_Refresh':
                   if (!empty($row[$header]) && $row[$header]!='NULL') {
                        $dte = \PhpOffice\PhpSpreadsheet\Shared\Date    ::excelToDateTimeObject($row[$header]);
                        $imp->{$header} = $dte->format("Y-m-d");
                   }
                    break;
                default:
                    $imp->{$header} = $row[$header];
            }
         } 
         $imp->save();
		 $loop++;
     }
	 return $loop;
 }
 
  function processSheet2 ( $sheet, $headers=array() ) {
     if (empty($sheet) || !is_array($sheet)) {
         return false;
     }
     if (empty($headers)) {
		$headers = array_shift( $sheet );
	 }


	 $loop = 0;
     foreach ($sheet as $row) {
		if (empty(array_filter($row))) {
			continue;
		}
		 #print_r(array_filter($row));

         $imp = new ImportXferClass2(-1);

       
         foreach ($headers as $key=>$header) {
           #echo $header;
            switch ($header) {
                case 'U_RunStartDate':
                case 'U_SetupStartDate':
                case 'U_QueueStartDate':
                case 'U_StockStartDate':
                case 'U_RunEndDate':
                case 'U_SetupEndDate':
                case 'U_QueueEndDate':
                case 'U_StockEndDate':
                case 'Last_Refresh':
                   if (!empty($row[$header]) && $row[$header]!='NULL') {
                        $dte = \PhpOffice\PhpSpreadsheet\Shared\Date    ::excelToDateTimeObject($row[$header]);
                        $imp->{$header} = $dte->format("Y-m-d");
                   }
                    break;
                default:
                    $imp->{$header} = $row[$header];
            }
         } 
         $imp->save();
		 $loop++;
     }
	 return $loop;
 }

 function convertToAssociatedKeys($headers, $sheet) {
	$named = [];
	
	// to loop the remaining array 
	$index = null;
	foreach($sheet as $ln => $vals) {
		$key = !is_null($index) ? $vals[$index] : $ln;
		$named[$key] = array_combine($headers, $vals);
	}
	return $named;
 }
 
 
function export_spread() {
	/*
    echo '<div>Export Spreadsheet</div>';
     
     
	$import1 = GetModifiedBatchData();
#	$import1 = GetImportTable2(array(), false);


	$export_dir = cpg_get_document_path() . 'exports/';
	$export_url = cpg_get_document_url() . 'exports';

	makepath( $export_dir );


	$headers = array_keys(reset($import1));
	$skip_array = array('id', 'bid', 'update_code', 'update_date', 'update_time', 'active', 'deleted', 'created', 'modified');

	$hdrs = array();
	foreach ($headers as $key) {
		if (in_array($key, $skip_array)) {
			continue;
		}
		$hdrs[$key] = $key;
	}
	$headers = $hdrs;

	$tArray = array();
	foreach ($import1 as $batch) {
		$tmp = array();

		foreach ($headers as $header) {
			$tmp[$header] = $batch[$header];
		}
		$tArray[] = $tmp;
	}
	array_unshift($tArray, $headers);
	$array = $tArray;

#$import2 = GetImportTable2();
$array['tOMOR'] = $import1;
#$array['tMOR16'] = $import2;

	$ExcelIO = new PHPExcelInterface;
  	$file = $ExcelIO->WriteCSVFile($tArray, $export_dir . 'test.csv', true);
  #	$file = $ExcelIO->createProductExcel( $array );
  	
  	echo '<a href="'.$export_url . $file.'">Click to Download Output</a>';
	*/
}


function export_overdue_tasks() {
		
	$table = new DisplayTable;

 	if (empty($table->batches)) {
		$table->GetData();
	}
	$batches = $table->batches;

	$headers = array(  'DocNum','U_ItemCode', 'U_Description', 'U_Status', 'U_DistNumber', 'U_LineNum', 'U_RscCode', 'U_SetupStartDate');

	$tArray = array();
	foreach ($batches as $batch) {

		$tmp = array();

		foreach ($headers as $header) {
			$tmp[$header] = $batch[$header];
		}
		$tArray[] = $tmp;
	}
	#array_unshift($tArray, $headers);
	#print_r($tArray);

	$export_dir = cpg_get_document_path() . 'exports/';
	$export_url = cpg_get_document_url() . 'exports/';

	makepath( $export_dir );

	$filename = "overdue_sheet.xlsx";
	$file = $export_dir . $filename ;

	$spout = new OpenSpoutExcel;
	$result = $spout->WriteLargeExcel($tArray, $file );
	if (is_wp_error($result)){
		echo '<div class="error-group">The following error(s) occurred</div>';
		foreach ($array->get_error_messages() as $message) {
			echo '<div class="error-list">' . $message. '</div>';
		}
	} else {
		echo '<div style="margin-top:50px;margin-bottom:20px;">The list of overdue production items has been generated. Click the link below to download the spreadsheet.</div>';
		echo '<div class="file_download_link"><a href="'.$export_url. $filename.'">'.$filename.'</a></div>';

		echo '<div class="resource-used">';
		echo $spout->memory;
		echo $spout->runtime;
		echo '</div>';
	}
}


function export_fulldataset_spreadsheet() {
	// this exports the original imported data - allows QA checking that import was accurate
    echo '<div>Export Dataset Spreadsheet</div>';
          
	error_reporting(-1)	 ;	
	ini_set("display_errors", 1); 
	set_time_limit(0);

	$export_dir = cpg_get_document_path() . 'exports/';
	$export_url = cpg_get_document_url() . 'exports/';

	makepath( $export_dir );

	$filename = "export_original_dataset.xlsx";
	$file = $export_dir . $filename ;

	$spout = new OpenSpoutExcel;

	$array1 = GetImportTable1(false, false);
	$array2 = GetImportTable2(false, false);

	$array = array();
	$array['tOMAR'] = $array1;
	$array['tMOR16'] = $array2;

	$result = $spout->WriteLargeExcel($array, $file, array( 'tOMAR', 'tMOR16'  ) );
	if (is_wp_error($result)){
		echo '<div class="error-group">The following error(s) occurred</div>';
		foreach ($array->get_error_messages() as $message) {
			echo '<div class="error-list">' . $message. '</div>';
		}
	} else {
		echo '<div class="file_download_link"><a href="'.$export_url. $filename.'">'.$filename.'</a></div>';

		echo '<div class="resource-used">';
		echo $spout->memory;
		echo $spout->runtime;
		echo '</div>';
	}
} # end of export_fulldataset_spreadsheet

function export_changesonly_spreadsheet() {
	// this exports only the changes made since the last successful import
	echo '<div>Export Changes Spreadsheet</div>';
     
     
	error_reporting(-1)	 ;	
	ini_set("display_errors", 1); 
	set_time_limit(0);

	$export_dir = cpg_get_document_path() . 'exports/';
	$export_url = cpg_get_document_url() . 'exports/';

	makepath( $export_dir );

	$filename = "export_changes_only.xlsx";
	$file = $export_dir . $filename ;



	$spout = new OpenSpoutExcel;

	#$array1 = GetImportTable1(false, false);
	#$array2 = GetImportTable2(false, false);
	$import1 = GetModifiedBatchData();


	$array = array();
	$array['tMOR16'] = $import1;

	$result = $spout->WriteLargeExcel($array, $file, array(  'tMOR16' ) );
	if (is_wp_error($result)){
		echo '<div class="error-group">The following error(s) occurred</div>';
		foreach ($array->get_error_messages() as $message) {
			echo '<div class="error-list">' . $message. '</div>';
		}
	} else {
		echo '<div class="file_download_link"><a href="'.$export_url. $filename.'">'.$filename.'</a></div>';

		echo '<div class="resource-used">';
		echo $spout->memory;
		echo $spout->runtime;
		echo '</div>';
	}

} # end of export_changesonly_spreadsheet

function export_latest_fulldataset_spreadsheet() {
	// this exports the full data with the changes integrated 
	// only needed if the SAP cannot import just the changes from the previous function
    echo '<div>Export Latest Full Dataset</div>';
     
	error_reporting(-1)	 ;	
	ini_set("display_errors", 1); 
	set_time_limit(0);

	$export_dir = cpg_get_document_path() . 'exports/';
	$export_url = cpg_get_document_url() . 'exports/';

	makepath( $export_dir );

	$filename = "export_fulldataset_with_changes.xlsx";
	$file = $export_dir . $filename ;

	$spout = new OpenSpoutExcel;

	$array2 = GetImportTable2(false, false);
	$import1 = GetModifiedBatchData(false, false);
	// need to merge import1 with array2
	foreach ($array2 as $key=>$row) {
		foreach ($import1 as $line) {
			if ($line->bid==$row->id) {
				#echo "<br>" . $row->id;
				$newline = clone $line;
				unset($newline->bid);
				unset($newline->update_code);
				unset($newline->update_time);
				$array2[$key] = $newline;
			}
		}
	}
	unset($import1);

	// now we get the other table here (after releasing memory from previous task)
	$array1 = GetImportTable1(false, false);

	$array = array();
	$array['tOMAR'] = $array1;
	$array['tMOR16'] = $array2;

	$result = $spout->WriteLargeExcel($array, $file, array(  'tMOR16' ) );
	if (is_wp_error($result)){
		echo '<div class="error-group">The following error(s) occurred</div>';
		foreach ($array->get_error_messages() as $message) {
			echo '<div class="error-list">' . $message. '</div>';
		}
	} else {
		echo '<div class="file_download_link"><a href="'.$export_url. $filename.'">'.$filename.'</a></div>';

		echo '<div class="resource-used">';
		echo $spout->memory;
		echo $spout->runtime;
		echo '</div>';
	}

	return false;
} # end of export_latest_fulldataset_spreadsheet

function export_spread_old(){

	$array = $spout->ReadExcel('hugexx.xlsx');
	if (is_wp_error($array)){
		echo '<div class="error-group">The following error(s) occurred</div>';
		foreach ($array->get_error_messages() as $message) {
			echo '<div class="error-list">' . $message. '</div>';
		}
	} else {
		$array = array_slice($array, 0, 4);

		print_r($array);
	
		echo $spout->memory;
		echo $spout->runtime;
	}




	return false;

}

 #############################################################
function GetTableRecordCount( $tablename, $passed_sql='', $as_array = true ) {
	global $wpdb;
	global $cpg_db_tables;

	$id = false;

	$opts_default  = array( 'active' => 1,
							'deleted' => 0,
							);

	// now lets merge the defaults with any passed params
	if (empty($opt_params) || !is_array($opt_params)) {
		$opt_params = array();
	}
	$opt_params = array_merge( $opts_default,  $opt_params );

	if (stripos($tablename, $wpdb->prefix)===false) {
		$tablename = $wpdb->prefix . $cpg_db_tables[$tablename];
	}

	$params = array() ;

	$sql = "select count(*) as count from $tablename where 1=1 " ; #and active=%d and deleted=%d";
	foreach ($opt_params as $key=>$param) {
		$sql .= " AND $key = %s ";
		$params[] = $param;
	}
	#$sql .= " ORDER BY SortOrder, Batch_Number, Id ";
	if (!empty($passed_sql)) {
		$sql = $passed_sql;
		$params = array();
	}
	$prepared_query = $wpdb->prepare($sql, $params);
	#echo $prepared_query;


	$myrows = $wpdb->get_results($prepared_query);
	if ($as_array) {
		$row_arrays = json_decode(json_encode($myrows), true);
	} else {
		$row_arrays = $myrows;
	}
	if (empty($myrows)) {
		return -1;
	} else {
		return $myrows[0]->count;
	}

	return $row_arrays;

} # end of GetTableRecordCount

 #############################################################

function remove_array_cols( $array, $delete_cols=array()) {

	$default_delete_keys = array('id', 'active','deleted', 'created', 'modified') ;
	if (!is_array($delete_cols)) {
		$delete_cols = array();
	}

	$delete_keys = array_merge( $default_delete_keys, $delete_cols);

	$newArray = array();
	foreach ($array as $row) {
		$newrow = array();
		foreach ($row as $key=>$cell){
			if (in_array($key, $delete_keys )) {
				continue;
			}
			$newrow[$key] = $cell;
		}
		$newArray[] = $newrow;
	}

	return $newArray;
}

function remove_row_cols( $row, $delete_cols=array()) {

	$default_delete_keys = array('id', 'active','deleted', 'created', 'modified') ;
	if (!is_array($delete_cols)) {
		$delete_cols = array();
	}

	$delete_keys = array_merge( $default_delete_keys, $delete_cols);

	$newrow = array();
	foreach ($row as $key=>$cell){
		if (in_array($key, $delete_keys )) {
			continue;
		}
		$newrow[$key] = $cell;
	}
	return $newrow;
}

if (!function_exists('array_is_list')) {
    function array_is_list(array $arr)
    {
        if ($arr === []) {
            return true;
        }
        return array_keys($arr) === range(0, count($arr) - 1);
    }
}

 #############################################################

 	function HandleImportProcess() {
		global $cpg_options;



		$messages = array();

		$uploads = wp_upload_dir( ) ;
	
		$masters_folder = !empty($cpg_options['cpg_marshalling_folder']) ? $cpg_options['cpg_marshalling_folder'] : 'production_marshalling';
		$folder = cpg_get_document_path() . "$masters_folder";

		makepath($folder); // create if does not exist

		$files = scandir( $folder ) ;

		if (count($files)==2) {
			$messages['error'][] = "No upload file was found...use the form to upload  an import spreadsheet";
		} elseif (count($files)>3) {  // takes into account .   and  .. in folder list
			$messages['error'][] = "Too many import sheets are in the import folder...please purge the list and upload just one spreadsheet";
		}


		if (empty($messages['error'])) {
			foreach ( $files as $file) {
				if ($file=='.' || $file=='..') {
					continue;
				}
				$fileparts = explode(".", $file);
				$ext = array_pop($fileparts);
				$basefile = str_replace(".".$ext, "",  $file); 

				$finfo = new finfo();
				$fileinfo = $finfo->file($folder . "/" . $file, FILEINFO_MIME_TYPE);
				if (!in_array($fileinfo, array( 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet') ) ) {
					#$messages['error'][] = "The uploaded file is not a valid spreadsheet file or not suitable for import";
				} else {
				  echo "The import file was last modified: " . date ("F d Y H:i:s.", filemtime($folder . "/" . $file)) . '<br><br>';
				}


			}
		}
		if (!empty($messages)) {

			foreach ($messages['error'] as $error) {
				echo '<div class="import-error">'. $error . '</div>';
			}
		} else {
			echo '<div class="import-ready">You can now import this spreadsheet into the database using the left hand menu.</div>';

			#echo '<div style="position:relative;">' . ajaxLoaderGif('Please wait for up to a minute while the processing completes') . '</div>';

?><!--
<form action="" method="post" onsubmit="jQuery('#ajax-wait').show();">
  <input type="hidden" name="action" value="process_import_file">
  <input type="submit" class="process-import" value="Process Import File">
</form>-->
<?php
            $user = wp_get_current_user();
            if ($user->user_login=='nufocus' && 1==0){
?>
<br><br><form action="" method="post" onsubmit="jQuery('#ajax-wait').show();">
  <input type="hidden" name="action" value="process_patch_file">
  <input type="submit" class="process-import" value="Process Patch File">
</form>
<?php
            }

		}
?>

<hr style="width:60%;margin:auto;border:1px solid #777777;margin-top:20px;">

<div class="import-guidance">
The import process will delete all the information currently held in the database and replace it with a new Dataset.<br>Ensure you have exported into Excel any data you need before performing the import.

<div class="import-warning-message">Proceed with caution!</div>


<form id="import_process_form"  action="/dashboard/" method="post">
  <input type="hidden" name="action" value="import_process">
  <input type="submit" value="Run Import Process" id="import-process-submit" class="import-upload">
</form>
</div>
<hr style="width:60%;margin:auto;border:1px solid #999999;margin-top:20px;">


<?php
	} # end of HandleImportProcess

#################################################


	function HandleMarshallingFolder() {
		global $cpg_options;



		$messages = array();

		$uploads = wp_upload_dir( ) ;
	
		$masters_folder = !empty($cpg_options['cpg_marshalling_folder']) ? $cpg_options['cpg_marshalling_folder'] : 'production_marshalling';
		$folder = cpg_get_document_path() . "$masters_folder";

		makepath($folder); // create if does not exist

		$files = scandir( $folder ) ;

		if (count($files)==2) {
			$messages['error'][] = "No upload file was found...use the form to upload  an import spreadsheet";
		} elseif (count($files)>3) {  // takes into account .   and  .. in folder list
			$messages['error'][] = "Too many import sheets are in the import folder...please purge the list and upload just one spreadsheet";
		}


		if (empty($messages['error'])) {
			foreach ( $files as $file) {
				if ($file=='.' || $file=='..') {
					continue;
				}
				$fileparts = explode(".", $file);
				$ext = array_pop($fileparts);
				$basefile = str_replace(".".$ext, "",  $file); 

				$finfo = new finfo();
				$fileinfo = $finfo->file($folder . "/" . $file, FILEINFO_MIME_TYPE);
				if (!in_array($fileinfo, array( 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet') ) ) {
					#$messages['error'][] = "The uploaded file is not a valid spreadsheet file or not suitable for import";
				} else {
				  echo "The import file was last modified: " . date ("F d Y H:i:s.", filemtime($folder . "/" . $file)) . '<br><br>';
				}


			}
		}
		if (!empty($messages)) {

			foreach ($messages['error'] as $error) {
				echo '<div class="import-error">'. $error . '</div>';
			}
		} else {
			echo '<div class="import-ready">You can now import this spreadsheet into the database.</div>';

			#echo '<div style="position:relative;">' . ajaxLoaderGif('Please wait for up to a minute while the processing completes') . '</div>';

?><!--
<form action="" method="post" onsubmit="jQuery('#ajax-wait').show();">
  <input type="hidden" name="action" value="process_import_file">
  <input type="submit" class="process-import" value="Process Import File">
</form>-->
<?php
            $user = wp_get_current_user();
            if ($user->user_login=='nufocus' && 1==0){
?>
<br><br><form action="" method="post" onsubmit="jQuery('#ajax-wait').show();">
  <input type="hidden" name="action" value="process_patch_file">
  <input type="submit" class="process-import" value="Process Patch File">
</form>
<?php
            }

		}
?>

<hr style="width:60%;margin:auto;border:1px solid #777777;margin-top:20px;">

<div style="margin-top:30px;">
To upload a new spreadsheet click on Choose File and navigate to the spreadsheet on your computer. Once selected you must click on the Upload Now button.

<form id="upload_import_form" action="" method="post" enctype="multipart/form-data">
  <input type="hidden" name="action" value="cpg_fileupload">
  <input type="file" id="myFile" name="filename"><br>
  <input type="submit" value="Upload now" class="import-upload">
</form>
</div>
<hr style="width:60%;margin:auto;border:1px solid #999999;margin-top:20px;">
<div style="margin-top:30px;">
You can empty the import folder at any time, but you should definitely do this if there are errors or too many files warnings showing above.
<form id="purge_input_form" action="" method="post">
  <input type="hidden" name="action" value="purge_imports">
  <input type="submit" class="import-upload" value="Empty Import Folder">
</form>
</div>
<script>
jQuery(document).ready(function() {
	jQuery("#upload_import_form").on("submit", function(e) {
		//e.stopPropagation();
		e.preventDefault();

		upload_import_form(this);
	});
	jQuery("#purge_input_form").on("submit", function(e) {
		e.stopPropagation();
		e.preventDefault();

		empty_marshalling_folder();
	});
});
</script>

<?php
	} # end of HandleMarshallingFolder

#################################################

 	function HandleSQLSetupProcess() {
		global $cpg_options;



		$exp = new dbSQL_Class;
		$table1 = $table2 = '';
		if (!empty($cpg_options['sql_source_table1'])){
			$table1 = $cpg_options['sql_source_table1'] ;
			echo '<div>Table '.$cpg_options['sql_source_table1'].' has '.$exp->get_table_row_count( $cpg_options['sql_source_table1']).' rows</div>' ;
		}
		if (!empty($cpg_options['sql_source_table2'])){
			$table2 = $cpg_options['sql_source_table2'] ;
			echo '<div>Table '.$cpg_options['sql_source_table2'].' has '.$exp->get_table_row_count( $cpg_options['sql_source_table2']).' rows</div>' ;
		}

		if (!empty($_POST)) {
			#print_r($_POST);

			$truncate = false;

			if (!empty($_POST['action']) && $_POST['action']=='sql_transfer_process') {
			
				if (!empty($_POST['truncate'])) {
					$truncate = true;
				}

				if (!empty($_POST['sourcetable']) && $_POST['sourcetable']=='sourcetable1') {
					initialise_test_sql_database($table1, $truncate);

				} elseif (!empty($_POST['sourcetable']) && $_POST['sourcetable']=='sourcetable2') {
					initialise_test_sql_database($table2, $truncate);
				}
			
			}
		}

?>

<hr style="width:60%;margin:auto;border:1px solid #777777;margin-top:20px;">

<div class="import-guidance">
This SQL setup process is only used to initialise test datatables in the SQL Server. It is not for use on a production system so take great care<br>Ensure you have backed up any data you need before performing the transfer process. Allow at least 10 minutes for this process to run...the browser may timeout, but processing will proceed in the background.

<div class="import-warning-message">Proceed with caution!</div>


<form id="sql_transfer_process_form"  action="/wp-admin/admin.php?page=cpg-init-sql-db" method="post">
  <input type="hidden" name="action" value="sql_transfer_process">
  No table: <input type="radio" id="" name="sourcetable" value="nothing">
  <?php echo $table1; ?> <input type="radio" id="" name="sourcetable" value="sourcetable1">
  <?php echo $table2; ?> <input type="radio" id="" name="sourcetable" value="sourcetable2">
  <br>Truncate Table? <input type="checkbox" name="truncate" value="on"><br>
  <input type="submit" value="Run SQL Transfer Process" id="sql-transfer-process-submit" class="import-upload">
</form>
</div>
<hr style="width:60%;margin:auto;border:1px solid #999999;margin-top:20px;">


<?php
	} # end of HandleSQLSetupProcess

#################################################

 function getInstanceForStorage($src) {
    $storageCart = new BatchItemUpdateClass(-1);
    foreach(get_object_vars($src) as $k => $v){
		if (in_array($k, array('id', 'basetable')) ) {
			continue;
		}
        $storageCart->{$k}=$v;
    }
	$storageCart->bid = $src->id;
	#$storageCart->__myclone();
    return $storageCart;
}

function deleteObsoluteBatchItemUpdates( $bid='') {
	if (!empty($bid) && is_numeric($bid)){
		$b = new BatchItemUpdateClass( array( 'bid' => $bid, 'active' => 1, 'deleted' => 0 )) ;
		while (!empty($b->id)) {
			$b->deleted = 1;
			$b->save();

			$b = new BatchItemUpdateClass( array( 'bid' => $bid, 'active' => 1, 'deleted' => 0 )) ;
		}
	}
}

#####################################################################

function initialise_test_sql_database( $tablename = '', $truncate=false ) {
	global $cpg_options;

	echo "<div>this is only for testing purposes</div>";

	if (empty($tablename)) {
		return false;
	}

	set_time_limit(2000);

	if ($tablename==$cpg_options['sql_source_table1']) {

		$import1 = GetImportTable1(false, false);
		$db = new dbSQL_Class;
		if ($truncate) {
			$result = $db->truncate_table( $tablename ) ;
			echo "<div>Truncated $tablename</div>";
		}
		foreach ($import1 as $row) {
			$db->insert_table1_row($row);
		}
	}

	set_time_limit(2000);

	if ($tablename==$cpg_options['sql_source_table2']) {

		$import1 = GetImportTable2(false, false);
		$db = new dbSQL_Class;
		if ($truncate) {
			$db->truncate_table( $tablename ) ;
			echo "<div>Truncated $tablename</div>";
		}
		foreach ($import1 as $row) {
			$db->insert_table2_row($row);
		}
	}

#	$import2 = GetImportTable2(false, false);
#	$db = new dbSQL_Class;
#	foreach ($import2 as $row) {
#		$db->insert_table2_row($row);
#	}

	echo '<div>Processing is now complete</div>';
	echo "<div id=\"posdiag\">memory=" . memory_get_usage()/1000000 . "</div>";
}


#####################################################################

?>