<?php

if (file_exists(cpg_plugin_dir_path() . '/phpoffice/vendor/autoload.php')){
require_once(cpg_plugin_dir_path() . '/phpoffice/vendor/autoload.php');
}

use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Cell\Coordinate;
use PhpOffice\PhpSpreadsheet\Reader\IReadFilter;



class PHPExcelInterface {

	var $status_messages = array();

	function __construct() {

	}

	function ReadExcel( $filename='', $sheetname='', $run_calculations=true ) {
	    // $sheetname may be an array of names
		if (is_array($sheetname)) {
			$sheetname = array_shift($sheetname);
		}
		if (empty($filename)) {
			return false;
		}
		ini_set('error_reporting', E_ALL & ~E_NOTICE & ~E_STRICT & ~E_DEPRECATED);
		set_time_limit(0);

		$start = microtime(true);
		#$batch_loop_start = 0;
		$batch_loop_start = intval(get_option('tMOR16' . "_batch_loop", false ));
		$batch_loop_start = intval(get_option($sheetname . "_batch_loop", false ));
		$batch_loop_start = !empty($batch_loop_start) ? $batch_loop_start : 2;
		#echo "batchloop time = " . $batch_loop_start;

		#$filename = "D:/Home/ApacheRoot/nufocusweb/httpdocs/wp-content/uploads/"  . "product.xlsx";
		$type = IOFactory::identify($filename);
		#echo $type;
		$objReader = IOFactory::createReader($type);
		$objReader->setReadDataOnly(TRUE);
		$objReader->setReadEmptyCells(false);
		$objReader->setLoadSheetsOnly($sheetname);
		$worksheetData = $objReader->listWorksheetInfo($filename);
		$rawRows = 11000; // set a large value
		foreach ($worksheetData as $sheetData) {
			// check if we can get the accurate value from the sheet
			if ($sheetData['worksheetName']==$sheetname) {
				$rawRows = $sheetData['totalRows'];
			}
		}
		$this->status_messages['progress'][] = "<div>Importing Rows=" . $rawRows . "</div>";

		// Define how many rows we want to read for each "chunk"
		$chunkSize = 200;
		// Create a new Instance of our Read Filter
		$chunkFilter = new Chunk();
		// Tell the Reader that we want to use the Read Filter that we've Instantiated
		$objReader->setReadFilter($chunkFilter);
		// Loop to read our worksheet in "chunk size" blocks
		$chunkFilter->setRows(1, 2);
		$headers = $objReader->load($filename);
		foreach ($headers->getWorksheetIterator() as $worksheet) {
			$header = $worksheet->toArray(null,$run_calculations,true,true) ;
			#$header = $worksheet->rangeToArray(
			#		'A1:' . $worksheet->getHighestDataColumn() .  ($worksheet->getHighestDataRow()) );
		}
		$headers = array_shift($header);

		$loopexited = false;
		$nextRow = 0;
		for ($startRow = $batch_loop_start; $startRow <= $rawRows; $startRow += $chunkSize) {
			set_time_limit(0);
			$nextRow = 0;

			// Tell the Read Filter, the limits on which rows we want to read this iteration
			$chunkFilter->setRows($startRow, $chunkSize);
			// Load only the rows that match our filter from $inputFileName to a PhpSpreadsheet Object
			$spreadsheet = $objReader->load($filename);
			foreach ($spreadsheet->getWorksheetIterator() as $worksheet) {
				#$sheet = $worksheet->toArray(null,$run_calculations,true,true) ;
				#echo  "<br>Coords="  . 'A'.$startRow.':' . $worksheet->getHighestDataColumn() .  ($worksheet->getHighestDataRow());
				$sheet = $worksheet->rangeToArray(
					'A'.$startRow.':' . $worksheet->getHighestDataColumn() .  ($worksheet->getHighestDataRow()) );
				
				$sheet = convertToAssociatedKeys($headers, $sheet);
			}
			if (count($sheet)==1) {
				$this->status_messages['progress'][] = '<div>Last record found - exiting loop</div>';
				break;
			} else {
				$nextRow = $startRow + count($sheet);
			} 
		    #echo "<br>start=" . $startRow . '===' . count($sheet) . ' ++ ' . $nextRow;
			$log = new cpgDiagnosticLogClass(-1);
			$log->message = "startRow = " . $startRow . " nextRow=" . $nextRow . " mem=" . memory_get_usage()/1000000;
			$log->save();
#print_r($headers);
		#	processImport( $sheetname, $headers, $sheet);
			$spreadsheet->disconnectWorksheets();
			unset($spreadsheet);
			unset($worksheet);
			unset($sheet);
			$log = new cpgDiagnosticLogClass(-1);
			$log->message = "afterprocessing= " . $startRow . " mem=" . memory_get_usage()/1000000;
			$log->save();

			$loop = microtime(true);

			if (($loop-$start)>100) {
				$this->status_messages['progress'][] = "<div>Loop Time exceeded</div>";
				#echo $nextRow;
				update_option($sheetname . "_batch_loop", intval($startRow+$chunkSize) );
				$loopexited = true;
				break;
			}
		}

		if (!$loopexited) {
			$this->status_messages['progress'][] = "<div>Process finished normally. All data has been imported for $sheetname</div>";
			// this is really stored to prevent accidentally importing the same sheet twice
			if (!empty($nextRow)){
				update_option($sheetname . "_batch_loop", intval($nextRow) );
			}
		}

		$stop = microtime(true);
		#echo "<br>finished " . ($stop-$start) . '==' . $nextRow;


		return false;
		$objPHPExcel = $objReader->load($filename);

		$worksheets = array();
		foreach ($objPHPExcel->getWorksheetIterator() as $worksheet) {
			if (empty($sheetname) || is_array($sheetname)) {
				$worksheets[$worksheet->getTitle()] = $worksheet->toArray();
			} elseif (!empty($sheetname) && $worksheet->getTitle()==$sheetname) {
				$worksheets[$worksheet->getTitle()] = $worksheet->toArray(null,$run_calculations,true,true);
			}
		}
		$objPHPExcel = null;
		return $worksheets;
	} # end of ReadExcel

	function GetSheetnames( $filename='' ) {

		if (empty($filename)) {
			return false;
		}
		ini_set('error_reporting', E_ALL & ~E_NOTICE & ~E_STRICT & ~E_DEPRECATED);

		$type = IOFactory::identify($filename);
		$objReader = IOFactory::createReader($type);
		$worksheetNames = $objReader->listWorksheetNames($filename);

		return $worksheetNames;
	} # end of ReadExcel

	function createProductExcel( $cli_array='' ) {
		#echo "client id matrix";
		// put the main functions into a separate code file
		// if it cannot be found fail gracefuly

		error_reporting(-1);
		error_reporting(E_ALL ^ E_DEPRECATED);
		ini_set("display_errors", 1);

	#	if (file_exists(cpg_plugin_dir_path()  . '/functions/cli_excel.php')) {
		#	require_once(cpg_plugin_dir_path() . '/functions/cli_excel.php');
			#require_once (cpg_plugin_dir_path()  . 'PHPExcel.php');


			if (!isset($objPHPExcel) || !is_a($objPHPExcel,  'PHPExcel')){
				$objPHPExcel = new Spreadsheet(); // this creates the first sheet
			} 
			$objPHPExcel->getActiveSheet()->setTitle("no data");
			#$sheetname = '';

			if  (empty($cli_array)) {
				echo "No matching data found!<br>";
				return false;
			}
			
			$first = true;
			foreach ($cli_array as $sheetname=>$sheet) {
			    
			    if (!$first) {
			       $res = $objPHPExcel->createsheet();
			       $objPHPExcel->setActiveSheetIndex( $objPHPExcel->getSheetCount()-1);
			    }
			    $first = false;
			    $currentSheet = $objPHPExcel->getActiveSheet()->setTitle($sheetname);
			    
			    $i = 0;
			    foreach ($sheet as $row) {
			        if (empty($i)) {
			            $j=0;
			            foreach ($row as $key=>$cell){
			                if (in_array($key, array('id', 'active','deleted', 'created', 'modified') )) {
			                    continue;
			                }
			                $currentSheet->setCellValue(num2alpha($j).'1', $key);
			                $currentSheet->getColumnDimension(num2alpha($j) )->setAutoSize(true);
			                $j++;
			            }
			            $i=2;
			        }
		            $j=0;
				    foreach ($row as $key=>$cell) {
			            if (in_array($key, array('id', 'active','deleted', 'created', 'modified') )) {
			                    continue;
			           }
			           $currentSheet->setCellValue(num2alpha($j).$i, $cell);
			           $j++;
			        }
			        $i++;
			    }
			    
			    
			}

			// now write file files
		#	if ($file) {
				$file =  excelWriteWorkbook($objPHPExcel);
		#	}
			return $file;

	#	} # end of require files
	} # end of createProductExcel

	function ReformatExcel( $filename ) {
		/** Include PHPExcel */
		#require_once (cpg_plugin_dir_path()  . 'PHPExcel.php');

		if (!file_exists($filename)) {
		//	$uploads = wp_upload_dir();
		//	$file = $uploads['path'] . "/" . $filename;
		}

		$csv_file = $filename;
		$objPHPExcel = IOFactory::load($filename);
		$objPHPExcel->setActiveSheetIndex(0);
		$row = $objPHPExcel->getActiveSheet()->getHighestRow()+1;
		#echo $row;
		#$objPHPExcel->getActiveSheet()->SetCellValue('A'.$row, 'name');
		#$objPHPExcel->getActiveSheet()->SetCellValue('B'.$row, 'email');
		#$objPHPExcel->getActiveSheet()->SetCellValue('C'.$row, 'phone');
		#$objPHPExcel->getActiveSheet()->SetCellValue('D'.$row, 'city');
		#$objPHPExcel->getActiveSheet()->SetCellValue('E'.$row, 'kid1');
		#$objPHPExcel->getActiveSheet()->SetCellValue('F'.$row, 'kid2');

		$maxColumn = $objPHPExcel->getActiveSheet()->getHighestDataColumn();
		$startRange = "A1";
		$endRange = $maxColumn . "1";
		$objPHPExcel->getActiveSheet()->getStyle("$startRange:$endRange")->getFont()->setBold( true );
		$maxColumn = Coordinate::columnIndexFromString($maxColumn);
		#echo "<br>" . $maxColumn . "<br>";
		for ($i=0; $i<=$maxColumn; $i++) {
			$objPHPExcel->getActiveSheet()->getColumnDimensionByColumn($i)->setAutoSize(true);
		}	
		$objPHPExcel->getActiveSheet()->calculateColumnWidths();

		$fileparts = explode(".", $filename);
		array_pop($fileparts);
		$fileparts[] = "xlsx";
		$filename = implode(".", $fileparts);

		$objWriter = new Xlsx($objPHPExcel);
		$objWriter->save( $filename );
		unlink($csv_file);

		$fileparts = explode("/", $filename) ;
		$filename = array_pop($fileparts);
		return $filename;

	}

	function WriteCSVFile( $array, $filename, $convertXL = true ) {
		global $masteroutputcount;
		global $masterfilename;

		if (stripos($filename, "/")!==false) {
			// filename has the path
			$parts = explode("/", $filename) ;

			$filename = array_pop($parts);
			$path = implode("/", $parts) . "/";
		} else {
			$uploads = wp_upload_dir();
			$path = $uploads['path'] . "/";
		}

		//increment the count
		#$masteroutputcount++;

		#$uploads = wp_upload_dir();
		#if(!empty($filename) || $filename==false) {
		#	if (!empty($masterfilename)) {
		#		$filename = $masterfilename . ' - Import'. $masteroutputcount . '.csv';
		#	} else {
			#	$filename = randomFilename() . ' - Import'.$masteroutputcount . '.csv';
		#	}
			#echo "<br>" . $filename;
		#}
		#$file = str_replace('.php', '.csv', $uploads['path'] . "/" . $filename);

		// ensure we are saving a csv file
		$file = str_replace('.php', '.csv', $path . $filename);

		$rowcount = count($array);
		echo "<br>Count=" . $rowcount;
		$chunksize = 1000;
		$pointer = 0;
		$append = false;

		while ($pointer<=$rowcount) {
			$chunk = array_slice($array, $pointer, $chunksize);
	
			$this->WriteFileSnippet($file, $chunk, $append) ;

			$pointer += $chunksize;
			$append = true;
		}	

		if ($convertXL) {
		#	$filename = $this->ReformatExcel( $file) ;
		}
		return $uploads['url'] . "/" . $filename; 
	}

	function WriteFileSnippet( $file, $array, $append=false){
		$writemode = 'a'; // default is to open for write new
		if (!$append) {
			if (file_exists($file)) {
				chmod($file, 0777);
				unlink($file);
			}
			$writemode = 'w';
		}

		$f = fopen($file, $writemode);
		foreach ($array as $line) {
			fputcsv($f, $line);
		}

		fclose($f);
	}


} # end pf class


/**  Define a Read Filter class implementing IReadFilter  */
class Chunk implements IReadFilter
{
    private $startRow = 0;

    private $endRow = 0;

    /**
     * Set the list of rows that we want to read.
     *
     * @param mixed $startRow
     * @param mixed $chunkSize
     */
    public function setRows($startRow, $chunkSize)
    {
        $this->startRow = $startRow;
        $this->endRow = $startRow + $chunkSize;
    }

    public function readCell($column, $row, $worksheetName = '')
    {
        //  Only read the heading row, and the rows that are configured in $this->_startRow and $this->_endRow
        if (($row == 1) || ($row >= $this->startRow && $row < $this->endRow)) {
            return true;
        }

        return false;
    }
}


/*
class PriceSheetParser {

	var $master = array();
	var $master_default = array();
	var $master_default2 = array();

	var $maxDropWidths = array() ;

	var $productnames = array();
	var $productDetails = array();

	var $useTapeGroups = false;
	var $hasFrameColours = false;
	var $useSlatSizing = false;
	var $useGlassBead = false;
	var $useOperatingWand = false;
	var $wandPrices = array();
	var $activeSlats = array();

	var	$priceGroup = array();

	var $maxBlindWidth = '';
	var $maxBlindDrop = '';
	var $maxFabricWidth = '';
	var $maxFabricDrop = '';
	var $usevariantPricing = false;


	function __construct() {
		#echo "loading parser";
		$this->wandPrices = array();
	}

	function SetupChunk() {
		$this->master = array(); #array_slice($this->master,0,1);
		$this->productnames = array();
		$this->productDetails = array();

		$this->master_default = array();
		$this->master_default2 = array();

		$wandPrices = array();

	} # end of SetupChunk

	function ReadExcel( $filename='' ) {

		if (empty($filename)) {
			return false;
		}
		ini_set('error_reporting', E_ALL & ~E_NOTICE & ~E_STRICT & ~E_DEPRECATED);

		#$filename = "D:/Home/ApacheRoot/nufocusweb/httpdocs/wp-content/uploads/"  . "product.xlsx";
		$type = IOFactory::identify($filename);
		$objReader = IOFactory::createReader($type);
		$objPHPExcel = $objReader->load($filename);

		$worksheets = array();
		foreach ($objPHPExcel->getWorksheetIterator() as $worksheet) {
			$worksheets[$worksheet->getTitle()] = $worksheet->toArray();
		}
		$objPHPExcel = null;
		return $worksheets;
	} # end of ReadExcel

}
*/
#######################################################################################################

function num2alpha($n)
{
    for($r = ""; $n >= 0; $n = intval($n / 26) - 1)
        $r = chr($n%26 + 0x41) . $r;
    return $r;
}
// S E T U P  T H E  D O C U M E N T  P R O P E R T I E S
function excelDocumentProperties( &$excel, $properties=array() ) {
		// setups generated Excel properties (like author, titles etc0
		// pass spaces (not empty) if you want to overwrite the defaults!
		$defaults = array( 'creator' => 'NuFocus Plugin',
							'modifiedBy' => 'Taichi Union Admin',
							'title' => 'Taichi Union',
							'subject' => 'Miscellaneous',
							'description' => 'This document is a generic template',
							'keywords' => 'None',
							'category' => 'Admin'
							);

		foreach  ($defaults as $key=>$value) {
			if (!isset($properties[$key]) || $properties[$key]=='') {
				//echo "<br>key=" . $key . " value=" . $value ;
				$properties[$key] = $value;
			}
		}
		$excel->getProperties()->setCreator($properties['creator'])
									 ->setLastModifiedBy($properties['modifiedBy'])
									 ->setTitle($properties['title'])
									 ->setSubject($properties['subject'])
									 ->setDescription($properties['description'])
									 ->setKeywords($properties['keywords'])
									 ->setCategory($properties['category']);

}

// A D D  H E A D E R  C E L L  W R A P P E R 
function excelHeaderCellByAxis( &$excel, $row, $column, $content='') {
	//wrapper function to add content converting row/column reference to A6 type reference
	$columnLetter = num2alpha($column);

	$rowcolumn = $columnLetter . $row;

	excelHeaderCell($excel, $rowcolumn, $content);
}
// A D D  H E A D E R  C E L L  
function excelHeaderCell( &$excel, $rowcolumn, $content='') {
	// adds content to a singele cell using A6 type reference
	##$excel->setActiveSheetIndex(0)->setCellValue($rowcolumn, $content);
	$excel->getActiveSheet()->setCellValue($rowcolumn, $content);
}
function excelHeaderRow ( &$excel, $params, $startCell, $stopCell='', $row=1, $sortkeys=array()) {
	if (empty($stopCell)) {
		$stopCell =$startCell + sizeof($params) - 1;
	}
	#$newparams = array();
	#foreach ($params as $key=>$val) {
	#	#$newparams[$key] = $val;
	#	$newparams[] = $val;
	#}
	#print_r($newparams);
	#$params = $newparams;

	$newparams = array();
	if ($sortkeys!=array()) {
		foreach ($sortkeys as $key=>$val) {
		#	echo $key . " = " . $val;
			$newparams[$key] = $params[$val] ;
		}
		$params = $newparams;
	} else {
		foreach ($params as $key=>$val) {
			$newparams[$key] = $val;
			$newparams[] = $val;
		}
		$params = $newparams;
	}
	#print_r($params);
	for ($i=$startCell; $i<=$stopCell; $i++) {
			#echo "<br>row=" . $row . " i=" . $i . " content=" . $params[$i-$startCell];
		excelHeaderCellByAxis($excel, $row, $i, $params[$i-$startCell]);
	}

	$excel->getActiveSheet()->setAutoFilter($excel->getActiveSheet()->calculateWorksheetDimension());
}

function excelColorCell( &$excel, $range, $color ) {

	$excel->getActiveSheet()->getStyle($range)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
	$excel->getActiveSheet()->getStyle($range)->getFill()->getStartColor()->setARGB('FF' . $color);

}
function excelTextStyleCell( &$excel, $range, $style ) {

	$style_array = array('font' => array('size' => 10,'bold' => true,'color' => array('rgb' => 'FF0000')));

	if (is_array($style)) {
		if (is_array($style['font'])) {
			foreach ($style['font'] as $key=>$value) {
				$style_array['font'][$key] = $value;
			}
		} else {
			foreach ($style as $key=>$value) {
				$style_array['font'][$key] = $value;
			}
		}
	} else {
		// only change colour
		$style_array['font']['color'] = array('rgb' => $style) ;
	}
		#print_r($style_array);

	#$excel->getActiveSheet()->getStyle($range)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
	$excel->getActiveSheet()->getStyle($range)->applyFromArray($style_array);

	#$excel->getActiveSheet()->getStyle($range)->getFill()->getStartColor()->setARGB('FF' . $color);

}

function excelTextAlignmentCell(&$excel, $range, $style='') {
	$center_style = 'HORIZONTAL_CENTER';
	if ($style!='') {
		$center_style = $style;
		$excel->getActiveSheet()->getStyle( $range  )->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER_CONTINUOUS );  
	} else {
		$excel->getActiveSheet()->getStyle( $range  )->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);  
	}
	#define('CENTER_STYLE', $center_style);

	#echo CENTER_STYLE;

	#$excel->getActiveSheet()->getStyle( $range  )->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::{$center_style}());  
}



function excelWriteWorkbook( $objPHPExcel ) {

	// Set active sheet index to the first sheet, so Excel opens this as the first sheet
	$objPHPExcel->setActiveSheetIndex(0);

	// Save Excel 2007 file
	#echo date('H:i:s') , " Write to Excel2007 format" , EOL;
	$callStartTime = microtime(true);

	#$filename = randomFilename() . '.xlsx';
	$filename = 'test.xlsx';
	$uploads = wp_upload_dir();

	$objWriter = IOFactory::createWriter($objPHPExcel, "Xlsx");

	$objWriter->save(str_replace('.php', '.xlsx', $uploads['path'] . "/" . $filename));
	$callEndTime = microtime(true);
	$callTime = $callEndTime - $callStartTime;

	return $uploads['url'] . "/" . $filename; 

}

?>